(function ($) {

    "use strict";
    function Legacy() {

        function Book() {

            var customFieldTemplate;
            var template;
            if ($('#stachethemes-admin-woocommerce-product-template').length > 0) {
                template = $('#stachethemes-admin-woocommerce-product-template').html();
            }

            customFieldTemplate = $('#stec-create-ticket-form-add-field-template').html();
            
            function arrange() {
                $(".stec-create-ticket-form-custom-field").each(function (i) {
                    $(this).find("input").each(function () {
                        this.name = this.name.replace(/wc_book_create_ticket_addinfo_field\[\d]/g, function (str, p1) {
                            return 'wc_book_create_ticket_addinfo_field[' + i + ']';
                        });
                    });
                });
            }

            $('#stec-create-ticket-form').on('click', '.stec-create-ticket-form-remove-field', function (e) {
                e.preventDefault();
                $(this).parent().remove();
                arrange();
            });
            $('#stec-create-ticket-form .stec-create-ticket-form-add-field').on('click', function (e) {
                e.preventDefault();
                $(customFieldTemplate)
                        .appendTo('.stec-create-ticket-form-custom-fields');
                arrange();
            });
            
            $('.add-book-item').on('click', function (e) {

                var itemId = $('[data-tab="booking"] select[name="wc_book_list"]').children(':selected').val();
                var itemName, html;
                e.preventDefault();
                if (!itemId) {
                    return;
                }

                itemName = $('[data-tab="booking"] select[name="wc_book_list"]').children(':selected').text();
                html = $(template);
                html.html(function (index, html) {

                    return html
                            .replace(/stec_replace_wc_product_id/g, itemId)
                            .replace(/stec_replace_wc_product_name/g, itemName);
                });
                $(html).appendTo($('.stachethemes-admin-section-tab[data-tab="booking"] .stachethemes-admin-tickets-list'));
            });
            $(document).on('click', '.stachethemes-admin-woocommerce-product .delete', function (e) {

                var parent = this;
                e.preventDefault();
                parent = $(this).parents('.stachethemes-admin-woocommerce-product');
                parent.remove();
            });
        }

        function Attachments() {

            var template;
            
            if ($('#stachethemes-admin-attachments-attachment-template').length <= 0) {
                return;
            }
            
            template = $('#stachethemes-admin-attachments-attachment-template').html();
            
            function arrange() {
                $(".stachethemes-admin-attachments-attachment").each(function (i) {
                    $(this).find("input").each(function () {
                        this.name = this.name.replace(/attachment\[\d]/g, function (str, p1) {
                            return 'attachment[' + i + ']';
                        });
                    });
                });
            }

            $(document).on('click', '.add-attachments-attachment', function (e) {

                var th = this, mediaFrame;
                e.preventDefault();
                mediaFrame = window.wp.media({
                    button: {text: "Pick Selected"},
                    library: {type: ''},
                    frame: 'select',
                    title: "Select Attachment",
                    multiple: true
                });
                mediaFrame.open();
                mediaFrame.on('select', function () {

                    var attachments = mediaFrame.state().get('selection').toJSON();
                    $(attachments).each(function (i) {

                        var att = this;
                        var html = $(template);
                        html.removeClass('stachethemes-admin-attachments-attachment-template');
                        html.html(function (index, html) {

                            return html
                                    .replace(/%title%/g, att.filename)
                                    .replace(/%id%/g, att.id);
                        });
                        $(html).insertBefore(th);
                    });
                    arrange();
                });
            });
            $(document).on('click', '.stachethemes-admin-attachments-attachment .delete', function (e) {

                var parent;
                e.preventDefault();
                parent = $(this).parents('.stachethemes-admin-attachments-attachment');
                parent.remove();
                arrange();
            });
            arrange();
        }

        function List() {

            $('.stec-list-bulk input').on('click', function (e) {
                if ($(this).is(':checked')) {
                    $('.stec-list li').find('input[type="checkbox"]').prop('checked', true);
                } else {
                    $('.stec-list li').find('input[type="checkbox"]').prop('checked', false);
                }
            });
            $('.stec-list-bulk form').on('submit', function (e) {
                var form = this;
                $(form).find('[name="idlist[]"]').remove();
                $('.stec-list li input[type="checkbox"]').filter(':checked').each(function () {
                    $('<input type="hidden" name="idlist[]" value="' + $(this).val() + '" />').appendTo(form);
                });
                return true;
            });
        }

        function Schedule() {

            var template;
            
            template = $('#stachethemes-admin-schedule-timespan-template').html();
            
            function arrange() {
                $(".stachethemes-admin-schedule-timespan").each(function (i) {
                    $(this).find("input, select, textarea").each(function () {
                        this.name = this.name.replace(/schedule\[\d]/g, function (str, p1) {
                            return 'schedule[' + i + ']';
                        });
                    });
                });
            }


            function scheduleFixTime($el) {

                var start, end;
                var $scheduleDate = $el.find('.input-date');
                var $scheduleHours = $el.find('.stachethemes-admin-select').first();
                var $scheduleMinutes = $el.find('.stachethemes-admin-select').last();
                var $startDate = $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="start_date"]');
                var $endDate = $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="end_date"]');
                var $startHours = $('.stachethemes-admin-section-tab[data-tab="general"] select[name="start_time_hours"]');
                var $endHours = $('.stachethemes-admin-section-tab[data-tab="general"] select[name="end_time_hours"]');
                var $startMinutes = $('.stachethemes-admin-section-tab[data-tab="general"] select[name="start_time_minutes"]');
                var $endMinutes = $('.stachethemes-admin-section-tab[data-tab="general"] select[name="end_time_minutes"]');
                var schedule = new Date($scheduleDate.val());
                schedule.setHours($scheduleHours.val());
                schedule.setMinutes($scheduleMinutes.val());
                start = new Date($startDate.val());
                start.setHours($startHours.val());
                start.setMinutes($startMinutes.val());
                end = new Date($endDate.val());
                end.setHours($endHours.val());
                end.setMinutes($endMinutes.val());
                if (schedule.getTime() < start.getTime()) {
                    $scheduleDate.datepicker({
                        setDate: $startDate.val()
                    });
                    $scheduleHours.val($startHours.val());
                    $scheduleMinutes.val($startMinutes.val());
                }

                if (schedule.getTime() > end.getTime()) {
                    $scheduleDate.datepicker({
                        setDate: $endDate.val()
                    });
                    $scheduleHours.val($endHours.val());
                    $scheduleMinutes.val($endMinutes.val());
                }
            }


            function controlBind($el) {

                $el.find('.input-date').datepicker({
                    showAnim: 0,
                    dateFormat: "yy-mm-dd",
                    minDate: $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="start_date"]').val(),
                    maxDate: $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="end_date"]').val(),
                    onSelect: function () {
                        scheduleFixTime($(this).parents('.stachethemes-admin-schedule-timespan'));
                    }
                });
                $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="start_date"]').on('change', function () {
                    $el.find('.input-date').datepicker('option', 'minDate', $(this).val());
                });
                $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="end_date"]').on('change', function () {
                    $el.find('.input-date').datepicker('option', 'maxDate', $(this).val());
                });
                $el.find('.stachethemes-admin-select').on('change', function () {
                    scheduleFixTime($(this).parents('.stachethemes-admin-schedule-timespan'));
                });
                $el.find('.stachethemes-admin-colorpicker').each(function () {

                    var th = this;
                    var color = $(th).val();
                    $(th).css({
                        backgroundColor: color
                    });
                    $(th).StecColorPicker({
                        color: color,
                        onShow: function (colpkr) {
                            $(colpkr).show();
                            return false;
                        },
                        onHide: function (colpkr) {
                            $(colpkr).hide();
                            return false;
                        },
                        onChange: function (hsb, hex, rgb) {

                            $(th).attr("title", "#" + hex);
                            $(th).css({
                                backgroundColor: "#" + hex
                            });
                            $(th).val("#" + hex);
                            $(th).trigger('stec-color-change');
                        }
                    });
                });
            }


            $(document).on('change, keyup', '.stachethemes-admin-schedule-timespan .stachethemes-admin-input:not(.input-date)', function (e) {

                var $parent = $(this).parents('.stachethemes-admin-schedule-timespan');
                var value = $(this).val();
                if (value !== "") {
                    $parent.find('.stachethemes-admin-schedule-timespan-title span').first().text(value);
                    $parent.find('.stachethemes-admin-schedule-timespan-title span').last().hide();
                } else {
                    $parent.find('.stachethemes-admin-schedule-timespan-title span').first().text('');
                    $parent.find('.stachethemes-admin-schedule-timespan-title span').last().show();
                }

            });
            $(document).on('click', '.stachethemes-admin-schedule-timespan .collapse', function (e) {
                e.preventDefault();
                $(this).parents('.stachethemes-admin-schedule-timespan').addClass('stachethemes-admin-schedule-collapse');
            });
            $(document).on('click', '.stachethemes-admin-schedule-timespan .expand', function (e) {
                e.preventDefault();
                $(this).parents('.stachethemes-admin-schedule-timespan').removeClass('stachethemes-admin-schedule-collapse');
            });
            $(document).on('click', '.stachethemes-admin-schedule-timespan .delete', function (e) {
                var parent;
                e.preventDefault();
                parent = $(this).parents('.stachethemes-admin-schedule-timespan');
                parent.remove();
                arrange();
            });
            $(document).on('click', '.add-schedule-timespan', function (e) {

                var $template;
                e.preventDefault();
                $template = $(template);
                $template.insertBefore($(this).parents('.stachethemes-admin-section-tab').find('.add-schedule-timespan'));
                arrange();
                $(".stachethemes-admin-schedule-timespan").not(":last").find('.collapse').trigger('click');
                $(".stachethemes-admin-schedule-timespan").last().find('.expand').trigger('click');
                controlBind($(".stachethemes-admin-schedule-timespan").last());
            });
            $(".stachethemes-admin-schedule-timespan").addClass('stachethemes-admin-schedule-collapse');
            $(".stachethemes-admin-schedule-timespan").each(function (i) {

                var title = $(this).find('input[type="text"]').not('.input-date').val();
                if (title !== '') {
                    $(this).find('.stachethemes-admin-schedule-timespan-title span').first().text(title);
                    $(this).find('.stachethemes-admin-schedule-timespan-title span').last().hide();
                }

                controlBind($(this));
            });
            arrange();
        }

        function Guests() {

            var template;
            
            template = $('#stachethemes-admin-guests-guest-template').html();
            
            function arrange() {
                $(".stachethemes-admin-guests-guest").each(function (i) {
                    $(this).find("input, select, textarea").each(function () {
                        this.name = this.name.replace(/guests\[\d]/g, function (str, p1) {
                            return 'guests[' + i + ']';
                        });
                    });
                    $(this).find("[data-name]").each(function () {
                        $(this).attr('data-name', $(this).attr('data-name').replace(/guests\[\d]/g, function (str, p1) {
                            return 'guests[' + i + ']';
                        }));
                    });
                });
            }

            function arrangeSocLinks($el) {

                $el.find('.stachethemes-admin-section-flex-guest-social').each(function (i) {
                    $(this).find("input, select, textarea").each(function () {
                        this.name = this.name.replace(/\[social]\[\d]/g, function (str, p1) {
                            return '[social][' + i + ']';
                        });
                    });
                });
            }

            $(document).on('click', '.stachethemes-admin-guests-guest .collapse', function (e) {
                e.preventDefault();
                $(this).parents('.stachethemes-admin-guests-guest').addClass('stachethemes-admin-guests-collapse');
            });
            $(document).on('click', '.stachethemes-admin-guests-guest .expand', function (e) {
                e.preventDefault();
                $(this).parents('.stachethemes-admin-guests-guest').removeClass('stachethemes-admin-guests-collapse');
            });
            $(document).on('click', '.add-guests-soclink', function (e) {

                var soc;
                e.preventDefault();
                soc = $(this).parent().find('.stachethemes-admin-section-flex-guest-social').last().clone();
                $(soc).insertAfter($(this).parent().find('.stachethemes-admin-section-flex-guest-social').last());
                $(this).parent().find('.stachethemes-admin-section-flex-guest-social').last().find('input, select').val('');
                arrangeSocLinks($(this).parent());
            });
            $(document).on('click', '.stachethemes-admin-guests-social-remove', function (e) {

                var total;
                e.preventDefault();
                total = $(this).parents('.stachethemes-admin-guests-guest').find('.stachethemes-admin-section-flex-guest-social').length;
                if (total <= 1) {
                    $(this).parent().find('select, input').val('');
                } else {
                    $(this).parent().remove();
                    arrangeSocLinks($(this).parent());
                }


            });
            $(document).on('click', '.add-guests-guest', function (e) {

                var $template;
                e.preventDefault();
                $template = $(template);
                $($template).insertBefore($(this).parents('.stachethemes-admin-section-tab').find('.add-guests-guest'));
                arrange();
                $(".stachethemes-admin-guests-guest").not(":last").find('.collapse').trigger('click');
                $(".stachethemes-admin-guests-guest").last().find('.expand').trigger('click');
            });
            $(document).on('click', '.stachethemes-admin-guests-guest .delete', function (e) {

                var parent;
                e.preventDefault();
                parent = $(this).parents('.stachethemes-admin-guests-guest');
                parent.remove();
                arrange();
            });
            $(document).on('change, keyup', '.stachethemes-admin-guests-guest .stachethemes-admin-input:first', function (e) {

                var $parent = $(this).parents('.stachethemes-admin-guests-guest');
                var value = $(this).val();
                if (value !== "") {
                    $parent.find('.stachethemes-admin-guests-guest-title span').first().text(value);
                    $parent.find('.stachethemes-admin-guests-guest-title span').last().hide();
                } else {
                    $parent.find('.stachethemes-admin-guests-guest-title span').first().text('');
                    $parent.find('.stachethemes-admin-guests-guest-title span').last().show();
                }

            });
            if ($('.stachethemes-admin-guests-toggle-wrap .stachethemes-admin-add-image-list[data-single="1"] li').length > 0) {
                $('.stachethemes-admin-guests-toggle-wrap .stachethemes-admin-add-image-list[data-single="1"]').next().hide();
            }

            $(".stachethemes-admin-guests-guest").addClass('stachethemes-admin-guests-collapse');
            arrange();
            $(".stachethemes-admin-guests-guest").each(function (i) {
                var title;
                arrangeSocLinks($(this));
                title = $(this).find('input[type="text"]').first().val();
                if (title !== '') {
                    $(this).find('.stachethemes-admin-guests-guest-title span').first().text(title);
                    $(this).find('.stachethemes-admin-guests-guest-title span').last().hide();
                }

            });
        }

        function Tabs() {

            $('.stachethemes-admin-tabs-list li').first().addClass('active');
            $('.stachethemes-admin-section-tab').first().show();
            $('.stachethemes-admin-tabs-list li').on('click', function (e) {

                var tab;
                e.preventDefault();
                $('.stachethemes-admin-tabs-list li').removeClass('active');
                $(this).addClass('active');
                tab = $(this).attr('data-tab');
                $('.stachethemes-admin-section-tab').hide();
                $('.stachethemes-admin-section-tab[data-tab="' + tab + '"]').show();
            });
        }

        function Images() {

            $(document).on('click', '.stachethemes-admin-image-container i', function () {
                if (parseInt($(this).parents(".stachethemes-admin-add-image-list").attr('data-single'), 10) === 1) {
                    $(this).parents(".stachethemes-admin-add-image-list").next().show();
                }

                $(this).parent().remove();
            });
            $('.stachethemes-admin-add-image-list').sortable();
            $(document).on("click", '.stachethemes-admin-add-image', function (e) {

                var th = this,
                        dataName, dataSingle, mediaFrame;
                e.preventDefault();
                th = this;
                dataName = $(this).attr('data-name');
                dataSingle = $(this).attr('data-single');
                mediaFrame = window.wp.media({
                    button: {text: "Pick Selected"},
                    library: {type: 'image'},
                    frame: 'select',
                    title: dataSingle ? "Select Image" : "Select Images",
                    multiple: dataSingle ? false : true
                });
                mediaFrame.open();
                mediaFrame.on('select', function () {
                    var attachments = mediaFrame.state().get('selection').toJSON();
                    $(attachments).each(function (i) {

                        var att = this;
                        var src, html;
                        if (att.type === "image") {

                            src = att.sizes.medium ? att.sizes.medium.url : att.sizes.full.url;
                            html = '<li class="stachethemes-admin-image-container">';
                            html += '<i class="fa fa-times"></i>';
                            html += '<img data-id="' + att.id + '" src="' + src + '" alt="' + att.alt + '" />';
                            html += '<input type="hidden" name="' + dataName + '" value="' + att.id + '">';
                            html += '</li>';
                            $(html).appendTo($(th).prev('.stachethemes-admin-add-image-list'));
                        }

                    });
                    if (dataSingle) {
                        $(th).hide();
                    }
                });
            });
        }

        function generalTimeFix() {

            var start, end;
            var $startDate = $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="start_date"]');
            var $endDate = $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="end_date"]');
            var $startHours = $('.stachethemes-admin-section-tab[data-tab="general"] select[name="start_time_hours"]');
            var $endHours = $('.stachethemes-admin-section-tab[data-tab="general"] select[name="end_time_hours"]');
            var $startMinutes = $('.stachethemes-admin-section-tab[data-tab="general"] select[name="start_time_minutes"]');
            var $endMinutes = $('.stachethemes-admin-section-tab[data-tab="general"] select[name="end_time_minutes"]');
            start = new Date($startDate.val());
            start.setHours($startHours.val());
            start.setMinutes($startMinutes.val());
            end = new Date($endDate.val());
            end.setHours($endHours.val());
            end.setMinutes($endMinutes.val());
            if (start.getTime() > end.getTime()) {
                $endHours.children().eq($startHours.children().filter(':selected').index()).prop('selected', true);
                $endMinutes.children().eq($startMinutes.children().filter(':selected').index()).prop('selected', true);
            }

        }

        function General() {

            $('.stachethemes-admin-msg-notice, .stachethemes-admin-msg-error').on('click', function () {
                $(this).remove();
            });
            $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="start_date"]').datepicker({
                showAnim: 0,
                dateFormat: "yy-mm-dd"
            });
            $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="end_date"]').datepicker({
                showAnim: 0,
                dateFormat: "yy-mm-dd",
                minDate: $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="start_date"]').val()
            });
            /** 
             * End date cannot be less than start date
             */

            $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="start_date"]').on('change', function () {
                $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="end_date"]').datepicker('option', 'minDate', $(this).val());
                generalTimeFix();
            });
            $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="end_date"]').on('change', function () {
                generalTimeFix();
            });
            $('.stachethemes-admin-section-tab[data-tab="general"] select[name="start_time_hours"]').on('change', function (e) {
                generalTimeFix();
            });
            $('.stachethemes-admin-section-tab[data-tab="general"] select[name="end_time_hours"]').on('change', function (e) {
                generalTimeFix();
            });
            $('.stachethemes-admin-section-tab[data-tab="general"] select[name="start_time_minutes"]').on('change', function (e) {
                generalTimeFix();
            });
            $('.stachethemes-admin-section-tab[data-tab="general"] select[name="end_time_minutes"]').on('change', function (e) {
                generalTimeFix();
            });
            $('.stachethemes-admin-colorpicker').each(function () {

                var th = this;
                var color = $(th).val();
                $(th).css({
                    backgroundColor: color
                });
                $(th).StecColorPicker({
                    color: color,
                    onShow: function (colpkr) {
                        $(colpkr).show();
                        return false;
                    },
                    onHide: function (colpkr) {
                        $(colpkr).hide();
                        return false;
                    },
                    onChange: function (hsb, hex, rgb) {
                        $(th).attr("title", "#" + hex);
                        $(th).css({
                            backgroundColor: "#" + hex
                        });
                        $(th).val("#" + hex);
                        $(th).trigger('stec-color-change');
                    }
                });
            });
            function allDayCheck() {

                if ($('[name="all_day"]').is(':checked')) {

                    $('[name="start_time_hours"]').hide().val($('[name="start_time_hours"]').children().first().val());
                    $('[name="start_time_minutes"]').hide().val($('[name="start_time_minutes"]').children().first().val());
                    $('[name="end_time_hours"]').hide().val($('[name="end_time_hours"]').children().last().val());
                    $('[name="end_time_minutes"]').hide().val($('[name="end_time_minutes"]').children().last().val());
                } else {

                    $('[name="start_time_hours"]').show();
                    $('[name="start_time_minutes"]').show();
                    $('[name="end_time_hours"]').show();
                    $('[name="end_time_minutes"]').show();
                }
            }

            $('[name="all_day"]').on('change', function (e) {
                allDayCheck();
            });
            allDayCheck();
            $('.stachethemes-admin-section-tab[data-tab="general"] select[name="calid"]').on('change', function () {

                var id = $(this).val();
                var color = $('.stachethemes-admin-section-tab[data-tab="general"] [name="calendar_colors_by_id[' + id + ']"]').val();
                $('.stachethemes-admin-section-tab[data-tab="general"] [name="event_color"]')
                        .val(color)
                        .attr('title', color)
                        .attr('value', color)
                        .css('background-color', color);
            });
        }

        function Other() {

            $('.stec-list .delete-item').on('click', function (e) {

                var lang = $(this).attr('data-confirm');
                if (confirm(lang)) {
                    return true;
                } else {
                    return false;
                }

            });
            $('.stec-list-bulk .delete-all-items').last().on('click', function (e) {

                var lang = $(this).attr('data-confirm');
                if (confirm(lang)) {
                    return true;
                } else {
                    return false;
                }

            });
        }

        function Activator() {

            var block = false;
            $('.stec-activator-success').hide();
            $('.stec-activator-beforesend').hide();
            $('#stec-activator .stachethemes-admin-form').on('submit', function (e) {

                var purchaseCode, task, stecActivator;
                var $statusText = $('.stec-activator-status');
                if (block === true) {
                    return false;
                }

                e.preventDefault();
                purchaseCode = $(this).find('[name="purchase_code"]').val();
                task = $(this).find('[name="task"]').val();
                if (purchaseCode.trim() === '') {
                    return false;
                }

                stecActivator = {

                    activate: function (purchaseCode) {

                        var DB = new window.StecDB();
                        var r = DB.newRequest();
                        r.setData({
                            action: 'stec_ajax_action',
                            purchase_code: purchaseCode,
                            task: 'activate_license'
                        });
                        r.setBefore(function () {
                            $('#stec-activator .stachethemes-admin-button').hide();
                            $statusText.show();
                            $statusText.find('span').text(window.stecLang.connectingToStachethemes);
                        });
                        r.setCallback(function (result) {

                            if (1 === result.error) {
                                $statusText.find('span').text(result.msg);
                                $statusText.find('i').attr('class', $statusText.find('i').data('alt'));
                            } else {
                                $statusText.find('span').text(window.stecLang.success);
                                location.reload();
                            }

                        });
                        DB.query(r);
                    },
                    deactivate: function (purchaseCode) {

                        var DB = new window.StecDB();
                        var r = DB.newRequest();
                        r.setData({
                            action: 'stec_ajax_action',
                            purchase_code: purchaseCode,
                            task: 'deactivate_license'
                        });
                        r.setBefore(function () {
                            $statusText.show();
                            $('#stec-activator .stachethemes-admin-button').hide();
                            $statusText.find('span').text(window.stecLang.connectingToStachethemes);
                        });
                        r.setCallback(function (result) {
                            if (1 === result.error) {
                                $statusText.find('span').text(result.msg);
                                $statusText.find('i').attr('class', $statusText.find('i').data('alt'));
                            } else {
                                $statusText.find('span').text(window.stecLang.success);
                                location.reload();
                            }
                        });
                        DB.query(r);
                    }
                };
                switch (task) {

                    case 'activate' :

                        stecActivator.activate(purchaseCode);
                        break;
                    case 'deactivate' :

                        stecActivator.deactivate(purchaseCode);
                        break;
                }

            });
        }

        function Repeater() {

            var theRule = '';
            var rrText = '';
            if ($('input[name="rrule"]').length <= 0) {
                return;
            }

            function checkVisibleOptions() {

                switch ($('select[name="repeat_freq"]').val()) {

                    case '0':
                        $('.stec-repeater-popup-weekdays').hide();
                        break;
                    case '2':
                        $('.stec-repeater-popup-weekdays').show();
                        break;
                    default:
                        $('.stec-repeater-popup-weekdays').hide();
                        $('.stec-repeater-popup-exdate-menu').show();
                }
            }

            function checkDisabledFields() {

                switch ($('input[name="repeat_endson"]').filter(":checked").val()) {

                    case '0' :
                        //never
                        $('input[name="repeat_occurences"]').attr('disabled', 'disabled');
                        $('input[name="repeat_ends_on_date"]').attr('disabled', 'disabled');
                        break;
                    case '1' :
                        // after n
                        $('input[name="repeat_occurences"]').prop('disabled', false);
                        $('input[name="repeat_ends_on_date"]').prop('disabled', true);
                        break;
                    case '2' :
                        // on date
                        $('input[name="repeat_occurences"]').attr('disabled', 'disabled');
                        $('input[name="repeat_ends_on_date"]').prop('disabled', false);
                        break;
                }

            }

            function rruleToSettings() {

                var rruleString,
                        rrule,
                        exdateString,
                        exdateArray,
                        weekdays = ['MO', 'TU', 'WE', 'TH', 'FR', 'SA', 'SU'];
                if (parseInt($('input[name="is_advanced_rrule"]').val(), 10) !== 1) {

                    // These settings apply only for basic repeater

                    rruleString = $('input[name="rrule"]').val();
                    if (rruleString === '') {
                        $('.stec-repeater-summary span').text('-');
                        return;
                    }

                    rrule = new window.rrule.RRule.fromString(rruleString);
                    // set freq
                    $('select[name="repeat_freq"]').val(Math.abs(4 - rrule.origOptions.freq)); // invert order 4,3,2,1 to 1,2,3,4...

                    if (rrule.origOptions.byweekday) {

                        $('.stec-repeater-popup-repeat-on input[type="checkbox"]').prop('checked', '');
                        $(rrule.origOptions.byweekday).each(function (a, b) {

                            var val = (weekdays[b.weekday]);
                            $('.stec-repeater-popup-repeat-on input[name="' + val + '"]').prop('checked', 'checked');
                        });
                    }

                    if (rrule.origOptions.interval) {
                        $('select[name="repeat_gap"]').val(rrule.origOptions.interval);
                    } else {
                        $('select[name="repeat_gap"]').val(0);
                    }

                    if (rrule.origOptions.count) {
                        $('input[name="repeat_occurences"]')
                                .prop('disabled', false)
                                .val(rrule.origOptions.count);
                        $('#stec-repeater-popup-repeat-endson-after-n').prop('checked', 'checked');
                        $('input[name="repeat_ends_on_date"]').prop('disabled', 'disabled');
                    }

                    if (rrule.origOptions.until) {
                        $('.stec-repeater-popup-endson-options #repeat_end_date').datepicker("setDate", rrule.origOptions.until);
                        $('#stec-repeater-popup-repeat-endson-date').prop('checked', 'checked');
                        $('input[name="repeat_ends_on_date"]').removeProp('disabled', 'disabled');
                        $('input[name="repeat_occurences"]').prop('disabled', 'disabled');
                    }

                    rrText = rrule.toText();
                    rrText = rrText.charAt(0).toUpperCase() + rrText.slice(1);
                    $('.stec-repeater-summary span').text(rrText);
                    $('.stec-repeater-popup-repeat-summary').text(rrText);
                } else {

                    // Advanced rrule sets only text

                    theRule = new window.rrule.RRule.fromString($('input[name="rrule"]').val());
                    rrText = theRule.toText();
                    rrText = rrText.charAt(0).toUpperCase() + rrText.slice(1);
                    // Move exdate to advanced menu
                    $('.stec-repeater-popup-exdate-menu').appendTo('.stec-repeater-popup-repeat-advanced');
                    $('.stec-repeater-summary span').text(rrText);
                }

                // exdate
                exdateString = $('input[name="exdate"]').val();
                if (exdateString !== '') {

                    $('.stec-repeater-popup .stec-repeater-popup-exdate-datelist li').remove();
                    exdateArray = exdateString.split(',');
                    $.each(exdateArray, function () {

                        var template = $('#stec-repeater-popup-exdate-datelist-template').html();
                        var altDate = this;
                        var date = altDate.substr(0, 4) + '-' + altDate.substr(4, 2) + '-' + altDate.substr(6, 2);
                        var $template = $(template);
                        $template
                                .html(function (index, html) {
                                    return html
                                            .replace(/stec_replace_date/g, date)
                                            .replace(/stec_replace_altdate/g, altDate);
                                });
                        $($template).appendTo($('.stec-repeater-popup .stec-repeater-popup-exdate-datelist'));
                    });
                }

                checkVisibleOptions();
            }

            function updateRepeatRules() {

                var interval, count, until, rrOptions, exdates, exdatesArray;
                var freq = $('.stec-repeater-popup').find('select[name="repeat_freq"]').val();
                var byweekday = [];
                switch (freq) {
                    case '0' :
                        freq = false;
                        break;
                    case '1' :
                        freq = window.rrule.RRule.DAILY;
                        break;
                    case '2' :
                        freq = window.rrule.RRule.WEEKLY;
                        $('.stec-repeater-popup-repeat-on')
                                .find('input[type="checkbox"]')
                                .filter(':checked')
                                .each(function () {

                                    byweekday.push(window.rrule.RRule[$(this).attr('name')]);
                                });
                        break;
                    case '3' :
                        freq = window.rrule.RRule.MONTHLY;
                        break;
                    case '4' :
                        freq = window.rrule.RRule.YEARLY;
                        break;
                }

                interval = $('.stec-repeater-popup').find('select[name="repeat_gap"]').val();
                count = false;
                until = false;
                switch ($('input[name="repeat_endson"]').filter(":checked").val()) {

                    case '0' :
                        //never
                        count = false;
                        until = false;
                        break;
                    case '1' :
                        // after n
                        count = $('input[name="repeat_occurences"]').val();
                        until = false;
                        break;
                    case '2' :
                        // on date
                        count = false;
                        until = new Date($('input[name="repeat_ends_on_date"]').val());
                        break;
                }

                rrOptions = {};
                rrOptions.freq = freq;
                if (count > 0) {
                    rrOptions.count = count;
                }

                if (until) {
                    rrOptions.until = until;
                }

                if (interval > 0) {
                    rrOptions.interval = interval;
                }

                if (byweekday.length > 0) {
                    rrOptions.byweekday = byweekday;
                }

                if (freq !== false) {
                    // Set rule
                    theRule = new window.rrule.RRule(rrOptions);
                    rrText = theRule.toText();
                    rrText = rrText.charAt(0).toUpperCase() + rrText.slice(1);
                } else {
                    // Empty rrule
                    theRule = new window.rrule.RRule();
                    rrText = '-';
                }

                $('.stec-repeater-popup-repeat-summary').text(rrText);
                exdates = $('.stec-repeater-popup .stec-repeater-popup-exdate-datelist li');
                if (exdates.length > 0) {

                    exdatesArray = [];
                    $(exdates).each(function () {
                        var value = $(this).find('.stec-repeater-popup-exdate-datelist-submit-value').text();
                        exdatesArray.push(value);
                    });
                    $('input[name="exdate"]').val(exdatesArray.join(','));
                } else {
                    $('input[name="exdate"]').val('');
                }

            }

            $('.stec-repeater-popup-bg').on('click', function (e) {
                $('.stec-repeater-popup-bg').hide();
                $('.stec-repeater-popup').hide();
            });
            $('.set-repeater-button').on('click', function (e) {

                e.preventDefault();
                $('.stec-repeater-popup-bg').show();
                $('.stec-repeater-popup').show();
                // Show the advanced settings if is advanced prop
                if ($('input[name="is_advanced_rrule"]').val() === '1') {
                    $('.stec-repeater-popup tbody').not('.stec-repeater-popup-repeat-advanced').hide();
                    $('.stec-repeater-popup .stec-repeater-popup-repeat-advanced').show();
                } else {
                    $('input[name="advanced_rrule"]').val('');
                    $('.stec-repeater-popup tbody').not('.stec-repeater-popup-repeat-advanced').show();
                    $('.stec-repeater-popup .stec-repeater-popup-repeat-advanced').hide();
                }

                rruleToSettings();
            });
            $('select[name="repeat_freq"]').on('change', function () {
                checkVisibleOptions();
            });
            $('input[name="repeat_endson"]').on('change', function () {
                checkDisabledFields();
            });
            $('.stec-repeater-popup-endson-options #repeat_end_date').datepicker({
                showAnim: 0,
                dateFormat: "yy-mm-dd",
                minDate: $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="end_date"]').val(),
                onSelect: function () {
                    updateRepeatRules();
                }
            });
            $('.stec-repeater-popup-endson-options #repeat_end_date').datepicker("setDate", new Date());
            $('.stachethemes-admin-section-tab[data-tab="general"] .input-date[name="end_date"]').on('change', function () {
                $('.stec-repeater-popup-endson-options #repeat_end_date').datepicker('option', 'minDate', $(this).val());
            });
            // accepts numbers only
            $('.stec-repeater-popup-endson-options input[name="repeat_occurences"]').on('keyup', function (a) {
                var val = $(this).val();
                $(this).val(val.replace(/[^0-9]/g, ''));
            });
            $('.stec-repeater-popup').on('keyup change', 'select, input:not([name="advanced_rrule"])', function () {
                updateRepeatRules();
            });
            $(document).on('keydown', function (e) {

                if (!$('.stec-repeater-popup').is(':visible')) {
                    return;
                }

                if (e.ctrlKey && e.altKey && e.shiftKey && e.keyCode === 82) {
                    e.preventDefault();
                    $('.stec-repeater-popup tbody').toggle();
                    if ($('.stec-repeater-popup-repeat-advanced').is(':visible')) {
                        $('.stec-repeater-popup-exdate-menu').appendTo('.stec-repeater-popup-repeat-advanced');
                    } else {
                        $('.stec-repeater-popup-exdate-menu').insertBefore($('.stec-repeater-popup-repeat-advanced').prev().find('tr').last());
                    }
                }

            });
            $('.stec-repeater-popup button').first().on('click', function (e) {

                var advancedRruleString;
                e.preventDefault();
                updateRepeatRules();
                advancedRruleString = $('input[name="advanced_rrule"]').val().replace(/\s+/g, '');
                if (advancedRruleString !== '') {
                    theRule = new window.rrule.RRule.fromString(advancedRruleString);
                    $('input[name="is_advanced_rrule"]').val(1);
                    rrText = theRule.toText();
                    rrText = rrText.charAt(0).toUpperCase() + rrText.slice(1);
                } else {
                    $('input[name="is_advanced_rrule"]').val(0);
                }

                $('input[name="rrule"]').val(theRule.toString().replace('T000000Z', '')); // ignore timezone
                $('.stec-repeater-summary span').text(rrText);
                $('.stec-repeater-popup-bg').hide();
                $('.stec-repeater-popup').hide();
            });
            $('.stec-repeater-popup button').last().on('click', function (e) {
                e.preventDefault();
                $('.stec-repeater-popup-bg').hide();
                $('.stec-repeater-popup').hide();
            });
            $('.stec-repeater-popup #stec-repeater-popup-exdate-datepicker').datepicker({
                showAnim: 0,
                dateFormat: "yy-mm-dd",
                altFormat: "yymmdd",
                altField: "#stec-repeater-popup-exdate-datepicker-exdate-value",
                onSelect: function () {

                }
            });
            $('.stec-repeater-popup #stec-add-exdate').on('click', function () {

                var $template;
                var template = $('#stec-repeater-popup-exdate-datelist-template').html();
                var date = $('#stec-repeater-popup-exdate-datepicker').val();
                var altDate = $('#stec-repeater-popup-exdate-datepicker-exdate-value').val();
                if (!date) {
                    return false;
                }

                $template = $(template);
                $template
                        .html(function (index, html) {
                            return html
                                    .replace(/stec_replace_altdate/g, altDate)
                                    .replace(/stec_replace_date/g, date);
                        });
                $($template).appendTo($('.stec-repeater-popup .stec-repeater-popup-exdate-datelist'));
            });
            $('.stec-repeater-popup').on('click', '.stec-remove-exdate', function () {
                $(this).parents('li').first().remove();
            });
            checkDisabledFields();
            rruleToSettings();
        }

        function Duplicate() {

            var href;
            if ($('#wp-admin-bar-WPML_ALS').length <= 0) {
                return;
            }

            href = '';
            $('.stec-duplicate-select-language').on('click', function (e) {
                $('.stec-duplicate-select-language').hide();
            });
            $('.stec-duplicate-select-language-pop').on('click', function (e) {
                e.stopPropagation();
            });
            $('.stec-duplicate-select-language-close').on('click', function () {
                $('.stec-duplicate-select-language').hide();
            });
            // WPML is active
            $('.stachethemes-admin-wrapper .duplicate').on('click', function (e) {

                e.preventDefault();
                $('.stec-duplicate-select-language').show();
                href = $(this).attr('href');
            });
            $('.stec-duplicate-select-language-pop button').on('click', function (e) {

                var lang;
                e.preventDefault();
                if (!href) {
                    return;
                }

                lang = $('.stec-duplicate-select-language-pop').find('select').val();
                href += '&stec_change_lang=' + lang;
                window.location.href = href;
            });
        }

        function EventIcons() {

            var defColor, defaultIcon;
            function checkIconType() {
                switch ($('select[name="icon_type"]').val()) {
                    case 'icon' :
                        $('.stec-icons-list.event').show();
                        $('.stec-icon-image-list').hide();
                        break;
                    case 'image' :
                        $('.stec-icons-list.event').hide();
                        $('.stec-icon-image-list').show();
                        break;
                    default:
                        $('.stec-icons-list.event').hide();
                        $('.stec-icon-image-list').hide();
                }
            }

            checkIconType();
            defColor = $('[name="event_color"]').val();
            defaultIcon = $('input[name="icon"]').val();
            $('.stec-icons-list.event ul').children().filter('[data-icon="' + defaultIcon + '"]').addClass('active');
            $(document).on('click', '.stec-icons-list.event ul > li', function () {
                var icon;
                $(this).siblings()
                        .css({background: '#fff'})
                        .removeClass('active');
                $(this)
                        .css({background: defColor})
                        .addClass('active');
                icon = $(this).data('icon');
                $('input[name="icon"]').val(icon);
            });
            $('[name="event_color"]').on('stec-color-change', function () {
                defColor = $(this).val();
                $('.stec-icons-list.event ul').children().filter('.active').css({background: defColor});
            });
            $('.stec-icons-list.event ul').children().filter('.active').css({background: defColor});
            $('select[name="icon_type"]').on('change', function () {
                checkIconType();
            });
        }

        function CalendarIcons() {

            var icon;
            var defColor = $('[name="calendar_color"]').val();
            var defaultIcon = $('input[name="calendar_icon"]').val();
            $('.stec-icons-list.calendar ul').children().filter('[data-icon="' + defaultIcon + '"]').addClass('active');
            $(document).on('click', '.stec-icons-list.calendar ul > li', function () {
                $(this).siblings()
                        .css({background: '#fff'})
                        .removeClass('active');
                $(this)
                        .css({background: defColor})
                        .addClass('active');
                icon = $(this).data('icon');
                $('input[name="calendar_icon"]').val(icon);
            });
            $('[name="calendar_color"]').on('stec-color-change', function () {
                defColor = $(this).val();
                $('.stec-icons-list.calendar ul').children().filter('.active').css({background: defColor});
            });
            $('.stec-icons-list.calendar ul').children().filter('.active').css({background: defColor});
        }

        function ScheduleIcons() {

            $('.stec-icons-list.schedule').each(function () {

                var block = $(this).parents('.stachethemes-admin-schedule-timespan').first();
                var defColor = block.find('[name$="[schedule_icon_color]"]').val();
                var defaultIcon = block.find('[name$="[schedule_icon]"]').val();
                $(this).find('ul').children().filter('[data-icon="' + defaultIcon + '"]')
                        .css({background: defColor})
                        .addClass('active');
            });
            $(document).on('click', '.stec-icons-list.schedule ul > li', function () {
                var icon;
                var block = $(this).parents('.stachethemes-admin-schedule-timespan').first();
                var defColor = block.find('[name$="[schedule_icon_color]"]').val();
                $(this).siblings()
                        .css({background: '#fff'})
                        .removeClass('active');
                $(this)
                        .css({background: defColor})
                        .addClass('active');
                icon = $(this).data('icon');
                block.find('[name$="[schedule_icon]"]').val(icon);
            });
            $(document).on('stec-color-change', '[name$="[schedule_icon_color]"]', function () {
                var block = $(this).parents('.stachethemes-admin-schedule-timespan').first();
                var defColor = $(this).val();
                block.find('.stec-icons-list.schedule ul').children().filter('.active').css({background: defColor});
            });
        }

        function ImportCustomIcons() {
            $(document).on('click', '.add-fa-icon', function (e) {

                var DB, $input, value, request;
                e.preventDefault();
                $input = $(this).prev('[name="add_fa_icon"]');
                value = $input.val();
                if (value.trim() === '') {
                    return;
                }

                try {
                    if ($(value).attr('class')) {
                        value = $(value).attr('class');
                    }

                    if (/[^A-Za-z-\s\d]/.test(value)) {
                        throw '';
                    }

                } catch (err) {
                    alert('Invalid input value');
                }

                DB = new window.StecDB();
                request = DB.newRequest();
                request.setData({
                    action: 'stec_ajax_action',
                    task: 'add_fa_icon',
                    icon: value
                });
                request.setCallback(function (r) {
                    var $list = $('.stec-icons-list ul');
                    var newIcon = '<li data-icon="' + value + '"><i class="' + value + '"></i></li>';
                    $(newIcon).appendTo($list);
                    $input.val('');
                    $list.scrollTop($list.outerHeight() + 5);
                });
                DB.query(request);
            });
        }

        this.init = function () {
            // Set boostrap datetimepicker to no conflict mode
            if (typeof $.fn.datepicker.noConflict === 'function') {
                $.fn.bootstrapDP = $.fn.datepicker.noConflict();
            }

            Book();
            Attachments();
            List();
            Schedule();
            Guests();
            Tabs();
            Images();
            General();
            Other();
            Activator();
            Repeater();
            Duplicate();
            EventIcons();
            CalendarIcons();
            ScheduleIcons();
            ImportCustomIcons();
        };
    }

    function Attendance() {
        var parent = this,
                $container = null,
                template = null,
                rsvpDate = null,
                DB = null,
                blockAction = false,
                dbAttendees = [];
        this.checkAddBySwitch = function () {
            switch ($container.find('select[name="invite_by"]').val()) {

                case 'role' :
                    $container.find('.stachethemes-admin-attendance-by-name').hide();
                    $container.find('.stachethemes-admin-attendance-by-role').show();
                    $container.find('.stachethemes-admin-attendance-by-user').hide();
                    break;
                case 'name' :
                    $container.find('.stachethemes-admin-attendance-by-name').show();
                    $container.find('.stachethemes-admin-attendance-by-role').hide();
                    $container.find('.stachethemes-admin-attendance-by-user').hide();
                    break;
                case 'user' :
                    $container.find('.stachethemes-admin-attendance-by-user').show();
                    $container.find('.stachethemes-admin-attendance-by-name').hide();
                    $container.find('.stachethemes-admin-attendance-by-role').hide();
                    break;
            }
        };
        this.gatherAttendeeInfo = function () {

            var request;
            var attendee = {
                type: null,
                userid: null,
                name: null,
                email: null,
                status: null,
                role: null,
                send: null
            };
            attendee.type = $container.find('select[name="invite_by"]').val();
            attendee.status = $container.find('.stachethemes-admin-attendance-add-form').find('[name="attendee_status"]').val();
            attendee.send = $container.find('.stachethemes-admin-attendance-add-form').find('[name="attendee_send_rsvp"]').prop("checked") ? 1 : 0;
            switch (attendee.type) {
                case 'name' :
                    attendee.name = $container.find('.stachethemes-admin-attendance-by-name').find('[name="attendee_name"]').val();
                    attendee.email = $container.find('.stachethemes-admin-attendance-by-name').find('[name="attendee_email"]').val();
                    attendee.people = 1;
                    parent.addAttendee(attendee);
                    break;
                case 'role' :
                    attendee.role = $container.find('.stachethemes-admin-attendance-by-role').find('[name="attendance_roles[]"]').val();
                    if (null === attendee.role || attendee.role.length <= 0) {
                        return;
                    }

                    request = DB.newRequest();
                    request.setData({
                        action: 'stec_ajax_action',
                        task: 'get_users_by_role',
                        role: attendee.role
                    });
                    request.setBefore(function () {
                        blockAction = true;
                        $container.find('#add-attendance').css('opacity', 0.5);
                    });
                    request.setCallback(function (r) {
                        blockAction = false;
                        $container.find('#add-attendance').css('opacity', 1);
                        $.each(r.data.users, function () {
                            attendee.userid = this.ID;
                            attendee.name = this.display_name;
                            attendee.email = this.user_email;
                            attendee.people = 1;
                            parent.addAttendee(attendee);
                        });
                    });
                    DB.query(request);
                    break;
                case 'user' :
                    attendee.userid = $container.find('.stachethemes-admin-attendance-by-user').find('[name="attendee_wp_users"]').val();
                    attendee.name = $container.find('.stachethemes-admin-attendance-by-user').find('[name="attendee_wp_users"]').find('option:selected').text();
                    attendee.email = $container.find('.stachethemes-admin-attendance-by-user').find('[name="attendee_wp_users"]')
                            .find('option:selected')
                            .data('email');
                    attendee.people = 1;
                    parent.addAttendee(attendee);
                    break;
            }

        };
        this.fillDBAttendees = function () {

            $.each(dbAttendees, function () {
                
                var attendee = {
                    userid: this.userid,
                    name: this.name,
                    email: this.email,
                    send: this.mail_sent === 1 ? 0 : 1,
                    people: this.people,
                    role: null,
                    type: this.userid ? 'user' : 'name',
                    status: this.status[rsvpDate] ? this.status[rsvpDate] : 0,
                    access_token: this.access_token,
                    custom: this.custom
                };
                parent.addAttendee(attendee);
            });
        };
        this.addAttendee = function (attendee) {
            
            var exists = false,
                    $template = null,
                    $attendee = null;
            if (!(attendee.email.trim()) || !(attendee.name.trim())) {
                return;
            }

            $.each($container.find('.stachethemes-admin-attendance-list ul li'), function () {
                if ($(this).data('email') === attendee.email.trim()) {
                    exists = true;
                    return false; // break;
                }
            });
            if (true === exists) {
                return;
            }

            $template = $(template);

            // Need to change checkbox id numbers otherwise it will throw warning in the console
            $template.find('.stachethemes-admin-checkbox').each(function () {
                var newId = 'id-' + new Date().getTime();
                $(this).attr('id', newId);
                $(this).next('.stachethemes-admin-checkbox-label').attr('for', newId);
            });

            $template.html(function (index, html) {

                var statusClass = '';
                switch (parseInt(attendee.status, 10)) {
                    case 0:
                        statusClass = 'far fa-question-circle';
                        break;
                    case 1:
                        statusClass = 'far fa-check-circle';
                        break;
                    case 2:
                        statusClass = 'far fa-times-circle';
                        break;
                }

                return html
                        .replace(/stec_replace_status_class/g, statusClass)
                        .replace(/stec_replace_name/g, attendee.name)
                        .replace(/stec_replace_people/g, attendee.people)
                        .replace(/stec_replace_email/g, attendee.email);
            });
            
            $attendee = $template
                    .appendTo($container.find('.stachethemes-admin-attendance-list ul'));
            $attendee.find('input[name$="[userid]"]').val(attendee.userid);
            $attendee.find('input[name$="[name]"]').val(attendee.name);
            $attendee.find('input[name$="[email]"]').val(attendee.email);
            $attendee.find('input[name$="[role]"]').val(attendee.role);
            $attendee.find('input[name$="[send]"]').prop('checked', attendee.send);
            $attendee.find('select[name$="[status]"]').val(attendee.status);
            $attendee.find('input[name$="[type]"]').val(attendee.type);
            $attendee.find('input[name$="[people]"]').val(attendee.people);
            $attendee.data('name', attendee.name)
                    .data('email', attendee.email)
                    .data('send', attendee.send)
                    .data('status', attendee.status);
            $attendee.find('.rsvp-date').text(rsvpDate);

            // Clear name and E-mail fields
            $container.find('.stachethemes-admin-attendance-add-form')
                    .find('input[type="email"], input[type="text"]').val('');
            $(document).trigger('stecOnAdminAddAttendee', {
                attendee: attendee,
                $attendee: $attendee,
                $container: $container
            });
            parent.updateAttendeeIndexes();
        };
        this.cancelUpdateAttendee = function ($attendee) {
            var $edit = $attendee.find('.edit');
            $edit.find('input[name$="[name]"]').val($attendee.data('name'));
            $edit.find('input[name$="[email]"]').val($attendee.data('email'));
            $edit.find('input[name$="[send]"]').prop('checked', $attendee.data('send'));
            $edit.find('select[name$="[status]"]').val($attendee.data('status'));
        };
        this.updateAttendeeIndexes = function () {
            $.each($container.find('.stachethemes-admin-attendance-list-attendee'), function (i) {
                $(this).find("input, select, textarea").each(function () {
                    this.name = this.name.replace(/attendee\[\d]/g, function (str, p1) {
                        return 'attendee[' + i + ']';
                    });
                });
            });
        };
        this.updateAttendee = function ($attendee) {

            var statusClass;
            var $edit = $attendee.find('.edit');
            var status = $edit.find('select[name$="[status]"]').val();
            var name = $edit.find('input[name$="[name]"]').val();
            var email = $edit.find('input[name$="[email]"]').val();
            var send = $edit.find('input[name$="[send]"]').val();
            var people = $edit.find('input[name$="[people]"]').val();
            if (!(email.trim()) || !(name.trim())) {
                return false;
            }

            statusClass = '';
            switch (parseInt(status, 10)) {
                case 0:
                    statusClass = 'far fa-question-circle';
                    break;
                case 1:
                    statusClass = 'far fa-check-circle';
                    break;
                case 2:
                    statusClass = 'far fa-times-circle';
                    break;
            }

            $attendee.find('.preview .status i').attr('class', statusClass);
            $attendee.find('.preview .name').text(name);
            $attendee.find('.preview .email').text(email);
            $attendee.find('.preview .people span').text(people);
            $attendee.data('name', name)
                    .data('email', email)
                    .data('people', people)
                    .data('send', send)
                    .data('status', status);
            return true;
        };
        /**
         * Sets next event occurrence date in YYYY-MM-DD format
         */
        this.setNextRSVPDate = function () {

            var rsvpDate = null;
            var $generalTab = $('.stachethemes-admin-section-tab[data-tab="general"]');
            var date = $generalTab.find('input[name="start_date"]').val();
            var hours = $generalTab.find('select[name="start_time_hours"]').val();
            var minutes = $generalTab.find('select[name="start_time_minutes"]').val();
            var rrule = $('.stec-repeater-popup').find('input[name="rrule"]').val();
            var exdate = $('.stec-repeater-popup').find('input[name="exdate"]').val();
            var calId = $generalTab.find('[name="calid"]').val();
            var timezone = $generalTab.find('[name="calendar_tz_by_id[' + calId + ']"]').val();
            var startDate;
            var rfcString;
            var exdates;
            var exdatesFixedArray;
            var rruleSet;
            var result;
            if (!rrule || rrule === '') {
                rsvpDate = date;
            } else {
                startDate = new window.moment.tz(date, timezone);
                startDate.set('hour', hours)
                        .set('minute', minutes)
                        .set('seconds', 0)
                        .tz(timezone)
                        .utc();
                rfcString = rrule + ';DTSTART=' + startDate.format('YYYYMMDDTHHmmss') + 'Z';
                if (exdate) {

                    exdates = exdate.split(',');
                    exdatesFixedArray = [];
                    $.each(exdates, function () {

                        var dt;
                        if (this.length === 8) {
                            dt = window.moment(this);
                            exdatesFixedArray.push(dt
                                    .hours(hours)
                                    .minutes(minutes)
                                    .seconds(0)
                                    .tz(timezone)
                                    .utc()
                                    .format('YYYYMMDD\THHmmss') + 'Z');
                        } else {
                            exdatesFixedArray.push(this);
                        }
                    });
                    rfcString += '\nEXDATE:' + exdatesFixedArray.join(',');
                }

                rruleSet = window.rrule.rrulestr(rfcString, {
                    forceset: true
                });
                result = rruleSet.after(new Date());
                if (!result) {
                    result = rruleSet.before(new Date());
                }

                rsvpDate = new window.moment.tz(result.valueOf(), timezone).format('YYYY-MM-DD');
            }

            $container.find('input[name="attendees_rsvp_date"]').val(rsvpDate);
            $container.find('.rsvp-date').text(rsvpDate);
            
            return rsvpDate;
        };
        /**
         * Upon date change
         * Loop all attendees and update their status for the given rsvp-date
         */
        this.updateRSVPDateStatuses = function () {
            parent.setNextRSVPDate();
            $.each($container.find('.stachethemes-admin-attendance-list-attendee'), function () {
                var $attendee = $(this);
                var email = $attendee.find('input[name$="[email]"]').val();
                $.each(dbAttendees, function () {

                    var newStatus;
                    if (this.email === email) {
                        newStatus = this.status[rsvpDate] ? this.status[rsvpDate] : 0;
                        $attendee.find('select[name$="[status]"]').val(parseInt(newStatus, 10));
                        parent.updateAttendee($attendee);
                        return false; // break;
                    }
                });
            });
        };
        function Controller() {
            $container.find('select[name="invite_by"]').on('change', function () {
                parent.checkAddBySwitch();
            });
            $container.find('#add-attendance').on('click', function () {
                if (true === blockAction) {
                    return;
                }
                parent.gatherAttendeeInfo();
            });
            // Remove attendee 
            $container.on('click', '.stachethemes-admin-attendance-list-attendee button[data-action="remove"]', function () {
                $(this).parents('.stachethemes-admin-attendance-list-attendee').first().remove();
                parent.updateAttendeeIndexes();
            });
            // Edit attendee 
            $container.on('click', '.stachethemes-admin-attendance-list-attendee button[data-action="edit"]', function () {
                var $attendee = $(this).parents('.stachethemes-admin-attendance-list-attendee').first();
                if ($attendee.find('input[name$="[type]"]').val() !== 'name') {
                    $attendee.find('input[name$="[name]"]').prop('readonly', true);
                    $attendee.find('input[name$="[email]"]').prop('readonly', true);
                }

                $attendee.addClass('edit');
            });
            // Update attendee 
            $container.on('click', '.stachethemes-admin-attendance-list-attendee [data-action="update-attendee"]', function () {
                var $attendee = $(this).parents('.stachethemes-admin-attendance-list-attendee').first();
                if (parent.updateAttendee($attendee)) {
                    $attendee.find('input, select').prop('readonly', false);
                    $attendee.removeClass('edit');
                }
            });
            // Cancel update attendee 
            $container.on('click', '.stachethemes-admin-attendance-list-attendee [data-action="cancel-update-attendee"]', function () {
                var $attendee = $(this).parents('.stachethemes-admin-attendance-list-attendee').first();
                parent.cancelUpdateAttendee($attendee);
                $attendee.find('input, select').prop('readonly', false);
                $attendee.removeClass('edit');
            });
        }

        function RSVPDateController() {

            var $generalTab = $('.stachethemes-admin-section-tab[data-tab="general"]');
            var $date = $generalTab.find('input[name="start_date"]');
            var $hours = $generalTab.find('select[name="start_time_hours"]');
            var $minutes = $generalTab.find('select[name="start_time_minutes"]');
            $generalTab.find('[name="calid"]').on('change', function () {
                parent.updateRSVPDateStatuses();
            });
            $date.on('change', function () {
                parent.updateRSVPDateStatuses();
            });
            $hours.on('change', function () {
                parent.updateRSVPDateStatuses();
            });
            $minutes.on('change', function () {
                parent.updateRSVPDateStatuses();
            });
            $('.stec-repeater-popup').find('.stec-repeater-popup-buttons button').on('click', function () {
                setTimeout(function () {
                    parent.updateRSVPDateStatuses();
                });
            });
        }

        this.init = function () {

            $container = $('.stachethemes-admin-section-tab[data-tab="attendance"]');
            if ($container.length <= 0) {
                return;
            }

            template = $('#stachethemes-admin-attendance-list-attendee-template').html();
     
            try {
                dbAttendees = JSON.parse($container.find('#db-attendees').val().trim());
            } catch (e) {
                dbAttendees = [];
            }

            Controller();
            RSVPDateController();
            DB = new window.StecDB();
            parent.checkAddBySwitch();
            rsvpDate = parent.setNextRSVPDate();
            parent.fillDBAttendees();
        };
    }

    function Location() {
        var parent = this,
                $container = null;
        this.nominatimGetCoordinates = function (address) {

            return new Promise(function (resolve, reject) {
                $.getJSON('//nominatim.openstreetmap.org/search?format=json&limit=1&q=' + address, function (data) {

                    if (data.length > 0) {
                        return resolve([data[0].lat, data[0].lon].join(','));
                    } else {
                        return reject(address);
                    }
                });
            });
        };
        this.googleGetCoordinates = function (address) {

            return new Promise(function (resolve, reject) {

                var geocoder = new window.google.maps.Geocoder();
                geocoder.geocode({'address': address}, function (results, status) {
                    var coords;
                    if (status === window.google.maps.GeocoderStatus.OK) {
                        coords = results[0].geometry.location.toString().replace(/\(|\)/gi, '');
                        return resolve(coords);
                    } else {
                        return reject(address);
                    }
                });
            });
        };
        this.fillCoordinates = function (gmapKey) {

            var address = $container.find('.stachethemes-admin-input[name="address"]').val();
            var city = $container.find('.stachethemes-admin-input[name="city"]').val();
            var country = $container.find('.stachethemes-admin-input[name="country"]').val();
            var location = (address + ' ' + city + ' ' + country).trim();
            if (!location) {
                return false;
            }

            if (false !== gmapKey && typeof window.google !== 'undefined') {

                this.googleGetCoordinates(location).then(function (coords) {
                    $container.find('.stachethemes-admin-input[name="coordinates"]').val(coords);
                }).catch(function (address) {
                    alert('Google Geocoder was unable to find coordinates for: ' + address);
                });
            } else {

                this.nominatimGetCoordinates(location).then(function (coords) {
                    $container.find('.stachethemes-admin-input[name="coordinates"]').val(coords);
                }).catch(function (address) {
                    alert('Nominatim was unable to find coordinates for: ' + address);
                });
            }
        };
        this.checkLocationType = function () {
            switch ($container.find('select[name="type"]').val()) {
                case 'virtual' :
                    $container.find('.physical-settings').hide();
                    break;
                case 'physical':
                default:
                    $container.find('.physical-settings').show();
            }
        };
        function Controller() {

            $container.find('.stec-get-coordinates').on('click', function (e) {
                e.preventDefault();
                let gmapKey = $(this).data('gmap-key');
                parent.fillCoordinates(gmapKey);
            });
            $container.find('select[name="type"]').on('input', function () {
                parent.checkLocationType();
            });
        }

        this.init = function () {
            $container = $('.stachethemes-admin-section[data-menu="location"]');
            this.checkLocationType();
            Controller();
        };
    }

    function EventAddEditLocation() {
        var parent = this,
                $container = null;
        this.checkLocationType = function () {
            switch ($container.find('select[name="location_type"]').val()) {
                case 'virtual' :
                    $container.find('.physical-settings').hide();
                    break;
                case 'physical':
                default:
                    $container.find('.physical-settings').show();
            }
        };
        this.checkState = function () {
            switch ($container.find('select').val()) {
                case 'custom' :
                    $container.find('.stec-admin-new-location').show();
                    break;
                default:
                    $container.find('.stec-admin-new-location').hide();
            }
        };
        this.nominatimGetCoordinates = function (address) {

            return new Promise(function (resolve, reject) {
                $.getJSON('//nominatim.openstreetmap.org/search?format=json&limit=1&q=' + address, function (data) {

                    if (data.length > 0) {
                        return resolve([data[0].lat, data[0].lon].join(','));
                    } else {
                        return reject(address);
                    }
                });
            });
        };
        this.googleGetCoordinates = function (address) {

            return new Promise(function (resolve, reject) {

                var geocoder = new window.google.maps.Geocoder();
                geocoder.geocode({'address': address}, function (results, status) {
                    var coords;
                    if (status === window.google.maps.GeocoderStatus.OK) {
                        coords = results[0].geometry.location.toString().replace(/\(|\)/gi, '');
                        return resolve(coords);
                    } else {
                        return reject(address);
                    }
                });
            });
        };
        this.fillCoordinates = function (gmapKey) {

            var address = $container.find('.stachethemes-admin-input[name="location_address"]').val();
            var city = $container.find('.stachethemes-admin-input[name="location_city"]').val();
            var country = $container.find('.stachethemes-admin-input[name="location_country"]').val();
            var location = (address + ' ' + city + ' ' + country).trim();
            if (!location) {
                return false;
            }

            if (false !== gmapKey) {

                this.googleGetCoordinates(location).then(function (coords) {
                    $container.find('.stachethemes-admin-input[name="location_coordinates"]').val(coords);
                }).catch(function (address) {
                    alert('Google Geocoder was unable to find coordinates for: ' + address);
                });
            } else {

                this.nominatimGetCoordinates(location).then(function (coords) {
                    $container.find('.stachethemes-admin-input[name="location_coordinates"]').val(coords);
                }).catch(function (address) {
                    alert('Nominatim was unable to find coordinates for: ' + address);
                });
            }
        };
        function Controller() {
            $container.find('.stec-get-coordinates').on('click', function (e) {
                e.preventDefault();
                let gmapKey = $(this).data('gmap-key');
                parent.fillCoordinates(gmapKey);
            });
            $container.find('select').on('change', function () {
                parent.checkState();
            });
            $container.find('select[name="location_type"]').on('input', function () {
                parent.checkLocationType();
            });
        }

        this.init = function () {
            $container = $('.stachethemes-admin-section-tab[data-tab="location"]');
            Controller();
            parent.checkState();
            parent.checkLocationType();
        };
    }

    function Organizer() {
        var $container = null;
        function arrangeSocLinks() {

            $container.find('.stachethemes-admin-section-flex-organizer-social').each(function (i) {
                $(this).find("input, select").each(function () {
                    this.name = this.name.replace(/social\[\d\]/g, function (str, p1) {
                        return 'social[' + i + ']';
                    });
                });
            });
        }

        function Controller() {
            $(document).on('click', '.add-organizers-soclink', function (e) {

                var soc;
                e.preventDefault();
                soc = $container.find('.stachethemes-admin-section-flex-organizer-social').last().clone();
                $(soc).insertAfter($(this).parent().find('.stachethemes-admin-section-flex-organizer-social').last());
                $container.find('.stachethemes-admin-section-flex-organizer-social').last().find('input, select').val('');
                arrangeSocLinks();
            });
            $(document).on('click', '.stachethemes-admin-organizers-social-remove', function (e) {

                var total;
                e.preventDefault();
                total = $container.find('.stachethemes-admin-section-flex-organizer-social').length;
                if (total <= 1) {
                    $(this).parent().find('select, input').val('');
                } else {
                    $(this).parent().remove();
                    arrangeSocLinks();
                }
            });
        }

        this.init = function () {

            $container = $('.stachethemes-admin-section[data-menu="organizer"]');
            if ($container.length <= 0) {
                return;
            }

            if ($container.find('.stachethemes-admin-add-image-list').children().length > 0) {
                $container.find('.stachethemes-admin-add-image').hide();
            }

            arrangeSocLinks();
            Controller();
        };
    }

    function EventAddEditOrganizer() {
        var $container = null,
                container = '.stachethemes-admin-section-tab[data-tab="organizers"] .stec-admin-new-organizer',
                DB = null,
                blockAction = false;
        function validateFields() {
            var valid = true;
            var name = $container.find('input[name="name"]').val().trim();
            if (!name) {
                valid = false;
            }

            return valid;
        }

        function insertNewOrganizer() {

            var formData, request;
            if (false === validateFields()) {
                return;
            }

            formData = new FormData();
            $container.find('input,select,textarea').each(function () {
                formData.append($(this).attr('name'), $(this).val());
            });
            formData.append('action', 'stec_ajax_action');
            formData.append('task', 'insert_new_organizer');
            request = DB.newRequest();
            request.setData(formData);
            request.setBefore(function () {
                blockAction = true;
                $container.find('.status').find('p').text($container.find('.status').data('default-text'));
                $container.find('.status').show();
                $container.find('[data-action="insert-organizer"]').hide();
            });
            request.setOnError(function (err) {
                blockAction = false;
            });
            request.setCallback(function (result) {
                var $selector, html;
                blockAction = false;
                $container.find('.status').hide();
                $container.find('[data-action="insert-organizer"]').show();
                if (result.error) {
                    $container.find('.status').find('p').text(result.error_msg);
                    $container.find('.status').show();
                    return;
                }

                if (result.data.success && result.data.organizer) {
                    $selector = $('.stachethemes-admin-section-tab[data-tab="organizers"]').find('select[name="organizers[]"]');
                    html = '<option selected value="' + result.data.organizer.id + '">' + result.data.organizer.name + '</option>';
                    $(html).appendTo($selector);
                    $('html,body').animate({scrollTop: 0}, 250, function () {
                        $selector.focus();
                    });
                    $container.find('input,select,textarea').val(null);
                    $container.find('.stachethemes-admin-section-flex-organizer-social').not(':first').remove();
                    $container.find('.stachethemes-admin-image-container').remove();
                    $container.find('.stachethemes-admin-add-image').show();
                }
            });
            DB.query(request);
        }

        function arrangeSocLinks() {

            $container.find('.stachethemes-admin-section-flex-organizer-social').each(function (i) {
                $(this).find("input, select").each(function () {
                    this.name = this.name.replace(/social\[\d\]/g, function (str, p1) {
                        return 'social[' + i + ']';
                    });
                });
            });
        }

        function Controller() {

            $container.find('[data-action="insert-organizer"]').on('click', function (a) {
                insertNewOrganizer();
            });

            $container.on('click', '.add-organizers-soclink', function (e) {

                var soc;
                e.preventDefault();
                soc = $container.find('.stachethemes-admin-section-flex-organizer-social').last().clone();
                $(soc).insertAfter($(this).parent().find('.stachethemes-admin-section-flex-organizer-social').last());
                $container.find('.stachethemes-admin-section-flex-organizer-social').last().find('input, select').val('');
                arrangeSocLinks();
            });

            $(document).on('click', container + ' .stachethemes-admin-organizers-social-remove', function (e) {

                var total;
                e.preventDefault();
                total = $container.find('.stachethemes-admin-section-flex-organizer-social').length;
                if (total <= 1) {
                    $(this).parent().find('select, input').val('');
                } else {
                    $(this).parent().remove();
                    arrangeSocLinks();
                }
            });
        }

        this.init = function () {
            DB = new window.StecDB();
            $container = $(container);
            Controller();
        };
    }

    function Migrate() {

        var $container = null;
        var $status = null;
        var blockAction = false;
        var DB = new window.StecDB();
        function locations(callback) {

            var request = DB.newRequest();
            request.setData({
                action: 'stec_ajax_action',
                task: 'migrate_261_locations'
            });
            request.setBefore(function () {
                $status.text(window.stecLang['Migrating locations...']);
            });
            request.setCallback(function (r) {

                if (r.error !== 0) {
                    $status.text(r.error_msg);
                    return;
                }

                if (parseInt(r.data.rerun, 10) > 0) {
                    locations(callback);
                } else {
                    if (typeof callback === 'function') {
                        callback(r);
                    }
                }
            });
            DB.query(request);
        }

        function organizers(callback) {

            var request = DB.newRequest();
            request.setData({
                action: 'stec_ajax_action',
                task: 'migrate_261_organizers'
            });
            request.setBefore(function () {
                $status.text(window.stecLang['Migrating organizers...']);
            });
            request.setCallback(function (r) {

                if (r.error !== 0) {
                    $status.text(r.error_msg);
                    return;
                }

                if (parseInt(r.data.rerun, 10) > 0) {
                    organizers(callback);
                } else {
                    if (typeof callback === 'function') {
                        callback(r);
                    }
                }

            });
            DB.query(request);
        }

        function refresh() {

            var request = DB.newRequest();
            request.setData({
                action: 'stec_ajax_action',
                task: 'clear_session_message'
            });
            request.setBefore(function () {
            });
            request.setCallback(function (r) {
                window.location.href = $container.find('input[name="back_url"]').val();
            });
            DB.query(request);
        }

        function migrate() {

            locations(function (result) {
                organizers(function (result) {
                    $status.text(window.stecLang['Completed']);
                    refresh();
                });
            });
        }

        function Controller() {

            $container.find('[data-action="migrate"]').on('click', function () {
                if (blockAction === true) {
                    return;
                }
                migrate();
            });
        }

        this.init = function () {

            $container = $('#stec-migrate');
            $status = $container.find('.status');
            Controller();
        };
    }

    function Tools() {

        var $container = null;
        var $status = null;
        var blockAction = false;
        var DB = new window.StecDB();
        function refresh() {

            var permalinks = {
                event: $container.find('[name="stec_event_path"]').val(),
                organizer: $container.find('[name="stec_organizer_path"]').val()
            };
            var request = DB.newRequest();
            request.setData({
                action: 'stec_ajax_action',
                task: 'refresh_permalinks',
                permalinks: permalinks
            });
            request.setBefore(function () {
                blockAction = true;
                $container.find('[data-action="refresh-permalinks"]').css('opacity', 0.5);
                $container.find('[data-action="reset-permalinks"]').css('opacity', 0.5);
            });
            request.setOnError(function (xhr, status, thrown) {

                blockAction = false;
                $container.find('[data-action="reset-permalinks"]').css('opacity', 0);
                $container.find('[data-action="refresh-permalinks"]').css('opacity', 0);
                $container.find('[data-action="refresh-permalinks"]').hide();
                $container.find('[data-action="reset-permalinks"]').hide();
                $status.text(status + ' ' + thrown);
                $status.show(400);
                setTimeout(function () {
                    $status.hide();
                    $container.find('[data-action="refresh-permalinks"]').show().stop().animate({
                        opacity: 1
                    }, 250);
                    $container.find('[data-action="reset-permalinks"]').show().stop().animate({
                        opacity: 1
                    }, 250);
                }, 2400);
            });
            request.setCallback(function (r) {

                blockAction = false;
                $container.find('[data-action="reset-permalinks"]').css('opacity', 0);
                $container.find('[data-action="refresh-permalinks"]').css('opacity', 0);
                $container.find('[data-action="refresh-permalinks"]').hide();
                $container.find('[data-action="reset-permalinks"]').hide();
                if (r.error && r.error_msg) {
                    $status.text(r.error_msg);
                    $status.show(400);
                }

                if (r.data && r.data.success === 1) {
                    if (r.data.msg) {
                        $status.text(r.data.msg);
                        $status.show(400);
                    }
                }

                setTimeout(function () {
                    $status.hide();
                    $container.find('[data-action="refresh-permalinks"]').show().stop().animate({
                        opacity: 1
                    }, 250);
                    $container.find('[data-action="reset-permalinks"]').show().stop().animate({
                        opacity: 1
                    }, 250);
                }, 2400);
            });
            DB.query(request);
        }

        function Controller() {

            $container.find('[data-action="reset-permalinks"]').on('click', function (e) {
                if (blockAction === true) {
                    e.preventDefault();
                }
            });
            $container.find('[data-action="refresh-permalinks"]').on('click', function (e) {
                e.preventDefault();
                if (blockAction === true) {
                    return;
                }

                refresh();
            });
        }

        this.init = function () {
            $container = $('.stachethemes-admin-section-tab[data-tab="tools"]');
            $status = $container.find('#tools-permalinks-status');
            Controller();
        };
    }

    function General() {

        var parent = this;
        this.checkMapType = function () {
            let gmapApiKeyEl = $('.toplevel_page_stec_menu__general input[name="gmaps_api_key"]');
            switch ($('.toplevel_page_stec_menu__general select[name="map_type"]').val()) {
                case 'gmap' :

                    gmapApiKeyEl.show();
                    gmapApiKeyEl.prev('.stachethemes-admin-info').show();
                    break;
                case 'osm' :

                    gmapApiKeyEl.hide();
                    gmapApiKeyEl.prev('.stachethemes-admin-info').hide();
                    break;
            }
        };
        this.checkOpenEventInType = function () {

            let openEventInEl = $('.toplevel_page_stec_menu__general select[name="open_event_in"]');
            let openEventTargetEl = $('.toplevel_page_stec_menu__general select[name="event_open_target"]');
            switch (openEventInEl.val()) {
                case 'single' :
                case 'external' :

                    openEventTargetEl.show();
                    openEventTargetEl.prev('.stachethemes-admin-info').show();
                    break;
                default:

                    openEventTargetEl.hide();
                    openEventTargetEl.prev('.stachethemes-admin-info').hide();
                    break;
            }
        };
        function Controller() {

            $('.toplevel_page_stec_menu__general select[name="map_type"]').on('change', function () {
                parent.checkMapType();
            });
        }

        this.init = function () {
            parent.checkMapType();
            Controller();
        };
    }

    function Shop() {

        var parent = this;
        var DB = new window.StecDB();
        this.getSearchResult = function (search) {

            return new Promise(function (resolve, reject) {

                var request = DB.newRequest();
                request.setData({
                    action: 'stec_ajax_action',
                    task: 'get_search_products',
                    search: search
                });

                request.setCallback(function (result) {

                    if (result.data.error === 1) {
                        return reject(result);
                    }

                    if (result.data.success === 1) {
                        return resolve(result);
                    }
                });

                DB.query(request);
            });
        };
        function Controller() {

            $('input[name="wc_product_list"]').autocomplete({
                select: function (event, ui) {

                    $(parent.getProductHtml(ui.item.id, ui.item.title)).appendTo($('.stachethemes-admin-section-tab[data-tab="shop"]'));

                },
                minLength: 3,
                source: function (request, response) {
                    parent.getSearchResult(request.term).then(function (result) {
                        response(result.data.products);
                    }).catch(function (result) {
                        console.warn(result);
                    });
                }
            }).data("ui-autocomplete")._renderItem = function (ul, item) {

                var html = [];

                html.push('<li class="stachethemes-admin-autocomplete-li">');
                html.push(item.image);
                html.push(' <div>');
                html.push('     <span><strong>' + item.title + '</strong></span>');
                html.push(item.price);
                html.push(' </div>');
                html.push('</li>');

                return $(html.join(''))
                        .attr("data-id", item.id)
                        .appendTo(ul);
            };

            $(document).on('click', '.stachethemes-admin-woocommerce-product .delete', function (e) {
                e.preventDefault();
                $(this).parents('.stachethemes-admin-woocommerce-product').remove();
            });
        }

        this.getProductHtml = function (itemId, itemName) {

            var html = [];
            html.push('<div class="stachethemes-admin-woocommerce-product">');
            html.push(' <div class="stachethemes-admin-woocommerce-product-head">');
            html.push('     <p class="stachethemes-admin-woocommerce-product-title"><span></span><span>' + itemName + '</span></p>');
            html.push('     <input type="hidden" name="wc_product[]" value="' + itemId + '" />');
            html.push('     <div>');
            html.push('         <button class="stachethemes-admin-button stachethemes-admin-button-no-clear light-btn delete">' + window.stecLang.Remove + '</button>');
            html.push('     </div>');
            html.push(' </div>');
            html.push('</div>');
            return html.join('');
        };
        this.init = function () {

            if ($('.stachethemes-admin-section-tab[data-tab="shop"]').length <= 0) {
                return;
            }

            Controller();
        };
    }

    function Main() {

        var DB = null, blockAction = false;
        function Controller() {

            $('.stec-remove-doi-consents').on('click', function () {

                var request = DB.newRequest();
                request.setData({
                    action: 'stec_ajax_action',
                    task: 'doi_revoke_consents'
                });
                request.setBefore(function () {
                    blockAction = true;
                    $('.stec-remove-doi-consents')
                            .text(window.stecLang.revoking)
                            .css('opacity', 0.5);
                });
                request.setCallback(function (r) {
                    blockAction = false;
                    setTimeout(function () {
                        $('.stec-remove-doi-consents').remove();
                    }, 1000);
                });
                DB.query(request);
            });
            $('.stachethemes-admin-form').on('submit', function () {
                $('.stec-disable-on-submit').find('input, select, textarea').prop('disabled', true);
            });
        }

        /**
         * Construtor
         */
        (function () {

            var general,
                    attendance,
                    organizer,
                    location,
                    migrate,
                    tools,
                    legacy,
                    eventAddEditLocation,
                    eventAddEditOrganizer,
                    shop;
            if (window.stecAdminMain) {
                return window.stecAdminMain;
            }

            DB = new window.StecDB();
            general = new General();
            general.init();
            attendance = new Attendance();
            attendance.init();
            organizer = new Organizer();
            organizer.init();
            eventAddEditOrganizer = new EventAddEditOrganizer();
            eventAddEditOrganizer.init();
            location = new Location();
            location.init();
            eventAddEditLocation = new EventAddEditLocation();
            eventAddEditLocation.init();
            migrate = new Migrate();
            migrate.init();
            tools = new Tools();
            tools.init();
            shop = new Shop();
            shop.init();
            legacy = new Legacy();
            legacy.init();
            Controller();
        })();
    }

    $(function () {
        window.stecAdminMain = new Main();
    });
})(window.jQuery);