(function ($) {

    "use strict";

    function StecSingle() {

        const __ = new window.StecHelper().lang;

        var glob = {
            template: {
                preloader: '',
                share: ''
            },
            event: {},
            temp: {},
            options: {

                siteurl: '',
                monthLabelsShort: [
                    __('jan'),
                    __('feb'),
                    __('mar'),
                    __('apr'),
                    __('may'),
                    __('jun'),
                    __('jul'),
                    __('aug'),
                    __('sep'),
                    __('oct'),
                    __('nov'),
                    __('dec')
                ],
                monthLabels: [
                    __('january'),
                    __('february'),
                    __('march'),
                    __('april'),
                    __('may'),
                    __('june'),
                    __('july'),
                    __('august'),
                    __('september'),
                    __('october'),
                    __('november'),
                    __('december')
                ],
                dayLabels: [
                    __('sunday'),
                    __('monday'),
                    __('tuesday'),
                    __('wednesday'),
                    __('thursday'),
                    __('friday'),
                    __('saturday')
                ],
                dayLabelsShort: [
                    __('sun'),
                    __('mon'),
                    __('tue'),
                    __('wed'),
                    __('thu'),
                    __('fri'),
                    __('sat')
                ]
            }
        };
        var helper = null;
        var DB = null;
        var reminder = null;
        var rsvp = null;
        var moment = window.moment;
        /*
         * Media Screen Size Handler
         */
        var media = {
            init: function () {
                this.bindControls();
                this.mediaTrigger();

                $('.stec-layout-single').css({
                    visibility: 'visible'
                });
            },
            bindControls: function () {

                var parent = this;

                $(window).on('resize', function () {
                    parent.mediaTrigger();
                });

            },
            mediaTrigger: function () {

                var width = $('.stec-layout-single').width();

                if (width <= 620) {
                    $('.stec-layout-single').removeClass("stec-layout-single-media-med");
                    $('.stec-layout-single').addClass("stec-layout-single-media-small");
                } else if (width <= 870) {
                    $('.stec-layout-single').removeClass("stec-layout-single-media-small");
                    $('.stec-layout-single').addClass("stec-layout-single-media-med");
                } else {
                    $('.stec-layout-single').removeClass("stec-layout-single-media-med stec-layout-single-media-small");
                }
            }
        };
        /* 
         * Media Slider
         */
        var slider = {
            cslide: 0,
            offset: 0,
            total: 0,
            blockAction: false,
            visCount: 0,
            visCountSmall: 3,
            visCountBig: 4,
            imagesArray: [],
            init: function () {

                var parent = this;
                var totalImages = $('.stec-layout-single-media-controls-list li').length;
                if (totalImages === 1) {

                    $('.stec-layout-single').find('.stec-layout-single-media-controls').remove();
                } else {

                    if (totalImages < this.visCountBig) {
                        this.visCountBig = totalImages;
                    }

                    if (totalImages < this.visCountSmall) {
                        this.visCountSmall = totalImages;
                    }
                }

                $.each(window.stecSingleEvent.images_meta, function () {
                    parent.imagesArray.push(this.src);
                });
                helper.preloadContentImages(parent.imagesArray).then(function () {

                    setTimeout(function () {
                        parent.controlsDimensions();
                        parent.showImage();
                        $('.stec-layout-single').find('.stec-layout-single-media').fadeTo(1000, 1);
                    }, 100);
                });
                this.bindControls();
            },
            bindControls: function () {

                var parent = this;
                helper.onResizeEnd(function () {
                    parent.controlsDimensions();
                });
                $('.stec-layout-single').find('.stec-layout-single-media-controls-next').on(helper.clickHandle(), function (e) {
                    e.preventDefault();
                    parent.slideNext();
                });
                $('.stec-layout-single').find('.stec-layout-single-media-controls-prev').on(helper.clickHandle(), function (e) {
                    e.preventDefault();
                    parent.slidePrev();
                });
                $('.stec-layout-single').find('.stec-layout-single-media-controls li').on(helper.clickHandle(), function (e) {

                    e.preventDefault();
                    if (parent.cslide === $(this).index()) {
                        return;
                    }

                    parent.cslide = $(this).index();
                    parent.showImage();
                });
            },
            controlsDimensions: function () {

                var parent = this;
                var maxWidth, $li, liWidth, listWidth, left;
                if (!$('.stec-layout-single').is(':visible')) {
                    return;
                }

                if ($('.stec-layout-single').hasClass('stec-layout-single-media-small')) {
                    parent.visCount = parent.visCountSmall;
                } else {
                    parent.visCount = parent.visCountBig;
                }

                if ($('.stec-layout-single').find('.stec-layout-single-media-controls-list li').length === parent.visCount) {
                    $('.stec-layout-single').find('.stec-layout-single-media-controls').addClass('no-side-controls');
                } else {
                    $('.stec-layout-single').find('.stec-layout-single-media-controls').removeClass('no-side-controls');
                }

                maxWidth = $('.stec-layout-single').find('.stec-layout-single-media-controls-list-wrap').width();
                $li = $('.stec-layout-single').find('.stec-layout-single-media-controls-list li');
                $('.stec-layout-single').find('.stec-layout-single-media-content').height(Math.min(400, helper.getImageHeight(parent.imagesArray[0])));
                // ~'calc( (100% - 2*10px) / 3 )';
                liWidth = (maxWidth - ((this.visCount - 1) * 10)) / this.visCount;
                listWidth = ($li.length * liWidth) + ($li.length * 10) - 10;
                $('.stec-layout-single').find('.stec-layout-single-media-controls-list').width(listWidth);
                $li.width(liWidth);
                this.offset = 0;
                left = -1 * ($li.first().width() * this.offset + this.offset * 10);
                $('.stec-layout-single').find('.stec-layout-single-media-controls-list').stop().css({
                    left: left
                });
            },
            showImage: function () {

                var $old, $new, $textContent;
                $('.stec-layout-single').find('.stec-layout-single-media-controls-list .active-thumb').removeClass('active-thumb');
                $('.stec-layout-single').find('.stec-layout-single-media-controls-list li').eq(this.cslide).addClass('active-thumb');
                $old = $('.stec-layout-single').find('.stec-layout-single-media-content .active-image');
                $new = $('.stec-layout-single').find('.stec-layout-single-media-content > div').eq(this.cslide);
                $textContent = $new.find('div');
                if ($textContent.length > 0) {

                    $('.stec-layout-single').find('.stec-layout-single-media-content-subs div').fadeTo(250, 0, function () {

                        var caption = $textContent.find('p').text();
                        var desc = $textContent.find('span').text();
                        var height;
                        $('.stec-layout-single').find('.stec-layout-single-media-content-subs p').text(caption);
                        $('.stec-layout-single').find('.stec-layout-single-media-content-subs span').text(desc);
                        height = $('.stec-layout-single').find('.stec-layout-single-media-content-subs p').height() + $('.stec-layout-single').find('.stec-layout-single-media-content-subs span').height();
                        if (height > 0) {
                            height = height + 40;
                        }

                        $('.stec-layout-single').find('.stec-layout-single-media-content-subs').stop().animate({
                            height: height
                        }, {
                            duration: 400,
                            easing: 'easeInOutExpo',
                            complete: function () {
                                $('.stec-layout-single').find('.stec-layout-single-media-content-subs div').fadeTo(250, 1);
                            }
                        });
                    });
                } else {

                    $('.stec-layout-single').find('.stec-layout-single-media-content-subs div').fadeTo(250, 0, function () {

                        $('.stec-layout-single').find('.stec-layout-single-media-content-subs').stop().animate({
                            height: 0
                        }, {
                            duration: 400,
                            easing: 'easeInOutExpo'
                        });
                    });
                }

                $new.addClass('fade-in');
                setTimeout(function () {

                    $old.removeClass('active-image');
                    $new.removeClass('fade-in').addClass('active-image');
                }, 250);
            },
            slideNext: function () {
                var $li = $('.stec-layout-single').find('.stec-layout-single-media-controls-list li');
                var left;
                if (this.offset + this.visCount >= $li.length) {
                    this.offset = 0;
                } else {
                    this.offset = this.offset + this.visCount;
                    if (this.offset > $li.length - this.visCount) {
                        this.offset = $li.length - this.visCount;
                    }
                }

                left = -1 * ($li.first().width() * this.offset + this.offset * 10);
                $('.stec-layout-single').find('.stec-layout-single-media-controls-list').stop().animate({
                    left: left
                }, {
                    duration: 750,
                    easing: 'easeInOutExpo'
                });
            },
            slidePrev: function () {
                var left;
                var $li = $('.stec-layout-single').find('.stec-layout-single-media-controls-list li');
                if (this.offset <= 0) {
                    this.offset = $li.length - this.visCount;
                } else {
                    this.offset = this.offset - this.visCount;
                    if (this.offset < 0) {
                        this.offset = 0;
                    }
                }

                left = -1 * ($li.first().width() * this.offset + this.offset * 10);
                $('.stec-layout-single').find('.stec-layout-single-media-controls-list').stop().animate({
                    left: left
                }, {
                    duration: 750,
                    easing: 'easeInOutExpo'
                });
            }

        };
        /* Attachments */
        var attachments = {
            init: function () {
                this.bindControls();
            },
            bindControls: function () {

                $('.stec-layout-single-attachments-toggle').on(helper.clickHandle(), function () {
                    $(this).toggleClass('active');
                    $('.stec-layout-single-attachments-list').toggleClass('active');
                });
            }
        };
        /* Clock */
        var clock = {
            days: 0,
            hours: 0,
            minutes: 0,
            seconds: 0,
            daysLabel: '',
            hoursLabel: '',
            mionutesLabel: '',
            secondsLabel: '',
            interval: '',
            init: function () {

                var nowDate, startDate, timeLeft;
                // Check counter disabled
                if ($('.stec-layout-single-counter').length <= 0) {
                    return;
                }

                nowDate = moment();
                startDate = moment.tz(glob.event.start_date, glob.event.timezone).add(glob.options.repeat_offset, 'seconds');
                timeLeft = Math.floor((startDate.unix() - nowDate.unix()));
                this.days = Math.floor(timeLeft / 86400);
                this.hours = Math.floor(timeLeft % 86400 / 3600);
                this.minutes = Math.floor(timeLeft % 86400 % 3600 / 60);
                this.seconds = Math.floor(timeLeft % 86400 % 3600 % 60);
                $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(0).text(this.days);
                $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(1).text(this.hours);
                $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(2).text(this.minutes);
                $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(3).text(this.seconds);
                this.daysLabel = $('.stec-layout-single').find('.stec-layout-single-counter-label').eq(0);
                this.hoursLabel = $('.stec-layout-single').find('.stec-layout-single-counter-label').eq(1);
                this.minutesLabel = $('.stec-layout-single').find('.stec-layout-single-counter-label').eq(2);
                this.secondsLabel = $('.stec-layout-single').find('.stec-layout-single-counter-label').eq(3);
                this.daysLabel.text(this.days === 1 ? this.daysLabel.attr('data-singular-label') : this.daysLabel.attr('data-plural-label'));
                this.hoursLabel.text(this.hours === 1 ? this.hoursLabel.attr('data-singular-label') : this.hoursLabel.attr('data-plural-label'));
                this.minutesLabel.text(this.minutes === 1 ? this.minutesLabel.attr('data-singular-label') : this.minutesLabel.attr('data-plural-label'));
                this.secondsLabel.text(this.seconds === 1 ? this.secondsLabel.attr('data-singular-label') : this.secondsLabel.attr('data-plural-label'));
                if (timeLeft < 0) {
                    this.complete();
                    return;
                }

                $('.stec-layout-single').find('.stec-layout-single-event-status-text').removeClass('active');
                $('.stec-layout-single').find('.stec-layout-single-event-status-text.event-startsin').addClass('active');
                this.count();
            },
            count: function () {

                var parent = this;
                parent.interval = setInterval(function () {

                    parent.seconds--;
                    if (parent.seconds < 0) {
                        parent.seconds = 59;
                        parent.minutes--;
                        if (parent.minutes < 0) {
                            parent.minutes = 59;
                            parent.hours--;
                            if (parent.hours < 0) {
                                parent.hours = 23;
                                if (parent.days > 0) {
                                    parent.days--;
                                }
                                $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(0).text(parent.days);
                                parent.daysLabel.text(parent.days === 1 ? parent.daysLabel.attr('data-singular-label') : parent.daysLabel.attr('data-plural-label'));
                            }
                            $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(1).text(parent.hours);
                            parent.hoursLabel.text(parent.hours === 1 ? parent.hoursLabel.attr('data-singular-label') : parent.hoursLabel.attr('data-plural-label'));
                        }
                        $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(2).text(parent.minutes);
                        parent.minutesLabel.text(parent.minutes === 1 ? parent.minutesLabel.attr('data-singular-label') : parent.minutesLabel.attr('data-plural-label'));
                    }
                    $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(3).text(parent.seconds);
                    parent.secondsLabel.text(parent.seconds === 1 ? parent.secondsLabel.attr('data-singular-label') : parent.secondsLabel.attr('data-plural-label'));
                    if (parent.days === 0 && parent.hours === 0 && parent.minutes === 0 && parent.seconds === 0) {
                        parent.complete();
                    }

                }, 1000);
            },
            complete: function () {

                var now, endDate;
                clearInterval(this.interval);
                $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(0).text(0);
                $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(1).text(0);
                $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(2).text(0);
                $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(3).text(0);
                this.daysLabel.text(this.days === 1 ? this.daysLabel.attr('data-singular-label') : this.daysLabel.attr('data-plural-label'));
                this.hoursLabel.text(this.hours === 1 ? this.hoursLabel.attr('data-singular-label') : this.hoursLabel.attr('data-plural-label'));
                this.minutesLabel.text(this.minutes === 1 ? this.minutesLabel.attr('data-singular-label') : this.minutesLabel.attr('data-plural-label'));
                this.secondsLabel.text(this.seconds === 1 ? this.secondsLabel.attr('data-singular-label') : this.secondsLabel.attr('data-plural-label'));
                $('.stec-layout-single-attendance-buttons').hide();
                $('.stec-layout-single-attendance-invited').hide();
                now = moment();
                endDate = moment.tz(glob.event.end_date, glob.event.timezone).add(glob.options.repeat_offset, 'seconds');
                if (1 === glob.event.all_day) {
                    endDate = endDate.endOf('day');
                }

                if (now >= endDate) {
                    $('.stec-layout-single').find('.stec-layout-single-event-status-text').removeClass('active');
                    $('.stec-layout-single').find('.stec-layout-single-event-status-text.event-expired').addClass('active');
                } else {

                    let timeToEventEnd = Math.floor((endDate.unix() - now.unix()));
                    this.days = Math.floor(timeToEventEnd / 86400);
                    this.hours = Math.floor(timeToEventEnd % 86400 / 3600);
                    this.minutes = Math.floor(timeToEventEnd % 86400 % 3600 / 60);
                    this.seconds = Math.floor(timeToEventEnd % 86400 % 3600 % 60);
                    $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(0).text(this.days);
                    $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(1).text(this.hours);
                    $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(2).text(this.minutes);
                    $('.stec-layout-single').find('.stec-layout-single-counter-num').eq(3).text(this.seconds);
                    this.daysLabel.text(this.days === 1 ? this.daysLabel.attr('data-singular-label') : this.daysLabel.attr('data-plural-label'));
                    this.hoursLabel.text(this.hours === 1 ? this.hoursLabel.attr('data-singular-label') : this.hoursLabel.attr('data-plural-label'));
                    this.minutesLabel.text(this.minutes === 1 ? this.minutesLabel.attr('data-singular-label') : this.minutesLabel.attr('data-plural-label'));
                    this.secondsLabel.text(this.seconds === 1 ? this.secondsLabel.attr('data-singular-label') : this.secondsLabel.attr('data-plural-label'));
                    this.count();
                    $('.stec-layout-single').find('.stec-layout-single-event-status-text').removeClass('active');
                    $('.stec-layout-single').find('.stec-layout-single-event-status-text.event-inprogress').addClass('active');
                }
            }

        };
        /* Coments */
        var comments = {

            init: function () {

                var eventId;
                var disqusShortname;
                var disqusTitle;
                if (parseInt(glob.event.comments, 10) === 0) {
                    return;
                }

                eventId = glob.event.id;
                switch (glob.options.comments_form) {
                    case 'facebook' :

                        if ($('#fb-root').length <= 0) {
                            $('<div id="fb-root"></div>').appendTo('body');
                        }

                        $('<div class="stec-fb-comments fb-comments" data-width="100%" data-href="' + window.location.hostname + "#!stecEventDiscussion" + eventId + '" data-numposts="5"></div>').appendTo('.stec-layout-single-comments');
                        if (typeof window.FB !== 'undefined') {
                            window.FB.XFBML.parse();
                        }


                        break;
                    case 'disqus' :

                        disqusShortname = glob.options.disqus_shortname;
                        disqusTitle = glob.event.title;
                        window.disqus_url = window.location.href + "#!stecEventDiscussion" + eventId;
                        window.disqus_identifier = "stecEventID" + eventId;
                        window.disqus_title = disqusTitle;
                        $('<div id="disqus_thread"></div>').appendTo('.stec-layout-single-comments');
                        if (typeof window.DISQUS === "undefined") {
                            $.ajax({
                                type: "GET",
                                url: "//" + +".disqus.com/embed.js",
                                dataType: "script",
                                cache: true
                            });
                        } else {
                            window.DISQUS.reset({
                                reload: true
                            });
                        }

                }

            }


        };
        /* Booking */
        var booking = {

            init: function () {

                var book;
                if (window.StecBooking) {


                    if (window.stecSingleEvent.bookable_products.length <= 0) {
                        $('.stec-layout-single').find('button[data-action="open-tickets"]').remove();
                    } else {
                        $('.stec-layout-single').find('button[data-action="open-tickets"]').data({
                            event: glob.event,
                            offset: glob.options.repeat_offset
                        });
                        book = new window.StecBooking('booking-popup-id-single');
                        book
                                .set('$instance', $('.stec-layout-single'))
                                .set('helper', helper)
                                .set('glob', glob);
                        book.controller();
                    }

                }
            }

        };
        /* Forecast */
        var forecast = {

            loaded: false,
            ajax: null,
            init: function () {

                var parent = this;

                if (0 === glob.event.location.length || !glob.options.weather_api_key || 'EventMovedOnline' === glob.event.event_status) {
                    return;
                }

                this.bindControls();

                if (
                        $('.stec-layout-single-tabs-list li[data-tab="stec-layout-single-forecast"]').hasClass('active') ||
                        $('.stec-layout-single-forecast').is(':visible')

                        ) {
                    if (parent.loaded === false) {
                        parent.getWeather();
                        parent.loaded = true;
                    }
                }
            },
            fillError: function () {
                $('.stec-layout-single-forecast .stec-layout-single-preloader').remove();
                $('.stec-layout-single-forecast-content').remove();
                $('.stec-layout-single-forecast').find('.errorna').show();
            },
            getWindDir: function (bearing) {

                var val, arr;
                while (bearing < 0) {
                    bearing += 360;
                }

                while (bearing >= 360) {
                    bearing -= 360;
                }

                val = Math.round((bearing - 11.25) / 22.5);
                arr = [
                    __('N'),
                    __('NNE'),
                    __('NE'),
                    __('ENE'),
                    __('E'),
                    __('ESE'),
                    __('SE'),
                    __('SSE'),
                    __('S'),
                    __('SSW'),
                    __('SW'),
                    __('WSW'),
                    __('W'),
                    __('WNW'),
                    __('NW'),
                    __('NNW')
                ];
                return arr[ Math.abs(val) ];
            },
            iconToText: function (icon) {

                switch (icon) {

                    case ('01d') :
                    case ('01n') :
                        return __('clear_sky');
                    case ('02d') :
                    case ('02n') :
                        return __('partly_cloudy');
                    case ('03d') :
                    case ('03n') :
                    case ('04d') :
                    case ('04n') :
                        return __('cloudy');
                    case ('09d') :
                    case ('09n') :
                    case ('10d') :
                    case ('10n') :
                        return __('rain');
                    case ('11d') :
                    case ('11n') :
                        return __('thunderstorm');
                    case ('13d') :
                    case ('13n') :
                        return __('snow');
                    case ('50d') :
                    case ('50n') :
                        return __('mist');
                }
            },
            iconToiconHTML: function (icon, forceday) {

                // openweathermap.org/weather-conditions

                switch (icon) {

                    case ('01d') :
                        return '<div class="stec-forecast-icon-clear-day"></div>';
                    case ('01n') :
                        return forceday ? '<div class="stec-forecast-icon-clear-day"></div>' : '<div class="stec-forecast-icon-clear-night"></div>';
                    case ('02d') :
                    case ('04d') :
                        return '<div class="stec-forecast-icon-cloudy-day"></div>';
                    case ('02n') :
                    case ('04n') :
                        return forceday ? '<div class="stec-forecast-icon-cloudy-day"></div>' : '<div class="stec-forecast-icon-cloudy-night"></div>';
                    case ('03d') :
                    case ('03n') :
                        return '<div class="stec-forecast-icon-cloudy"></div>';
                    case ('50d') :
                    case ('50n') :
                        return '<div class="stec-forecast-icon-mist"></div>';
                    case ('11d') :
                    case ('11n') :

                    case ('10d') :
                    case ('10n') :

                    case ('09d') :
                    case ('09n') :
                        return  '<div class="stec-forecast-icon-rain"></div>';
                    case ('sleet') :
                        return '<div class="stec-forecast-icon-sleet"></div>';
                    case ('13d') :
                    case ('13n') :
                        return '<div class="stec-forecast-icon-snow"></div>';
                }
            },
            floorFigure: function (figure, decimals) {
                var d;
                if (!decimals) {
                    decimals = 4;
                }
                d = Math.pow(10, decimals);
                return (parseInt(figure * d) / d).toFixed(decimals);
            },
            getWeather: function () {

                var parent = this;
                var location = glob.event.location.coordinates;
                var r = DB.newRequest();
                r.setData({
                    action: 'stec_public_ajax_action',
                    task: 'get_weather_data',
                    location: function () {
                        location = location.split(',');
                        location[0] = parent.floorFigure(location[0]);
                        location[1] = parent.floorFigure(location[1]);
                        location = location.join(',');
                        return location;
                    }
                });
                r.setBefore(function () {
                    $(glob.template.preloader).appendTo($('.stec-layout-single-forecast'));
                });
                r.setCallback(function (data) {

                    if (data) {

                        // error ?
                        if (data.error || !data) {
                            parent.fillError();
                            return;
                        }

                        parent.fillData(data);
                    } else {
                        parent.fillError();
                    }

                    // Remove tabs preloaders
                    $('.stec-layout-single-forecast').find('.stec-layout-single-preloader').remove();
                });
                DB.query(r);
            },
            fillData: function (data) {

                var parent = this;
                var fiveDays = [];
                var forecast = data;
                var ch;
                var template = $('#stec-layout-single-forecast-details-left-forecast-day-template').html();

                $(forecast.daily).each(function (index) {

                    var th, icon, d, niceDay;
                    if (index > 5) {
                        return;
                    }

                    th = this;
                    icon = parent.iconToiconHTML(th.weather[0].icon, true);
                    // Localtime
                    d = moment.unix(th.dt).tz(glob.event.timezone);
                    niceDay = helper.beautifyTimespan(d, d, 1);
                    fiveDays[index] = $(template).html(function (index, html) {

                        var tempFmin = Math.round(th.temp.min);
                        var tempCmin = Math.round((tempFmin - 32) * 5 / 9);
                        var tempFmax = Math.round(th.temp.max);
                        var tempCmax = Math.round((tempFmax - 32) * 5 / 9);
                        return html
                                .replace(/\bstec_replace_date\b/g, niceDay)
                                .replace(/\bstec_replace_min\b/g, glob.options.temp_units === "C" ? tempCmin : tempFmin)
                                .replace(/\bstec_replace_max\b/g, glob.options.temp_units === "C" ? tempCmax : tempFmax)
                                .replace(/\bstec_replace_temp_units\b/g, glob.options.temp_units === "C" ? "C" : "F")
                                .replace(/\bstec_replace_icon_div\b/g, icon);
                    })[0].outerHTML;
                });

                fiveDays = fiveDays.join('');
                $('.stec-layout-single-forecast').html(function (index, html) {

                    var icon = parent.iconToiconHTML(forecast.current.weather[0].icon);
                    var tempF = Math.round(forecast.current.temp);
                    var tempC = Math.round((tempF - 32) * 5 / 9);
                    var apTempF = Math.round(forecast.current.feels_like);
                    var apTempC = Math.round((tempF - 32) * 5 / 9);
                    var windMPH = Math.round(forecast.current.wind_speed);
                    var windKPH = Math.round(windMPH * 1.609344);
                    var niceDay;
                    // Local time
                    var d = moment.unix(forecast.current.dt).tz(glob.event.timezone);
                    niceDay = helper.beautifyTimespan(d, d, 1);
                    return html
                            .replace(/\bstec_replace_current_summary_text\b/g, parent.iconToText(forecast.current.weather[0].icon))
                            .replace(/\bstec_replace_today_date\b/g, niceDay)
                            .replace(/\bstec_replace_location\b/g, helper.capitalizeFirstLetter(glob.event.location.full_address))
                            .replace(/\bstec_replace_current_temp\b/g, glob.options.temp_units === "C" ? tempC : tempF)
                            .replace(/\bstec_replace_current_feels_like\b/g, glob.options.temp_units === "C" ? apTempC : apTempF)
                            .replace(/\bstec_replace_current_humidity\b/g, (forecast.current.humidity))
                            .replace(/\bstec_replace_current_temp_units/g, glob.options.temp_units === "C" ? "C" : "F")
                            .replace(/\bstec_replace_current_wind\b/g, glob.options.wind_units === "MPH" ? windMPH : windKPH)
                            .replace(/\bstec_replace_current_wind_units\b/g, glob.options.wind_units === "MPH" ? "MPH" : "KPH")
                            .replace(/\bstec_replace_current_wind_direction\b/g, parent.getWindDir(forecast.current.wind_deg))
                            .replace(/\bstec_replace_today_icon_div\b/g, icon)
                            .replace(/\bstec_replace_5days\b/g, fiveDays);
                });
                // Chart instance
                setTimeout(function () {

                    var th,
                            i,
                            humidity = [],
                            tempf,
                            tempc,
                            tempC = [],
                            tempF = [],
                            cloudness = [],
                            j = -1,
                            timeFormat,
                            d;
                    var charTimeLabels = [];
                    for (i = 0; i < 8; i++) {

                        j++;
                        th = forecast.hourly[j];
                        tempf = Math.round(th.temp);
                        tempc = Math.round((tempf - 32) * 5 / 9);
                        tempC[i] = tempc;
                        tempF[i] = tempf;
                        humidity[i] = th.humidity;
                        cloudness[i] = th.clouds;
                        timeFormat = 'HH:mm';
                        if (parseInt(glob.options.time_format, 10) === 12) {
                            timeFormat = 'hh:mma';
                        }

                        // Local time
                        d = moment.unix(th.dt).tz(glob.event.timezone);
                        charTimeLabels.push(d.format(timeFormat));
                    }

                    ch = new parent.chart();
                    ch.setCanvas($('.stec-layout-single-forecast-details-chart canvas'));
                    ch.setChartData({
                        labels: charTimeLabels,
                        datasets: [

                            {
                                yAxisID: 'mainYAxis',
                                label: __('temperature') + ' ' + '\u00B0' + (glob.options.temp_units === "C" ? 'C' : 'F'),
                                data: glob.options.temp_units === "C" ? tempC : tempF,
                                backgroundColor: "rgba(255, 196, 79,0.3)",
                                borderColor: "rgba(255, 196, 79,1)",
                                pointBackgroundColor: "rgba(252,183,85,1)",
                                fill: true,
                                lineTension: 0.3,
                                pointHoverRadius: 5,
                                pointHitRadius: 10,
                                borderWidth: 1
                            },
                            {
                                yAxisID: 'mainYAxis',
                                label: __('humidity_percents'),
                                data: humidity,
                                backgroundColor: "rgba(202, 212, 224,0.1)",
                                borderColor: "rgba(202, 212, 224,1)",
                                pointBackgroundColor: "rgba(202, 212, 224,1)",
                                fill: true,
                                lineTension: 0.3,
                                pointHoverRadius: 5,
                                pointHitRadius: 10,
                                borderWidth: 1
                            },
                            {
                                yAxisID: 'mainYAxis',
                                label: __('cloudness'),
                                data: cloudness,
                                backgroundColor: "rgba(141, 152, 166,0.1)",
                                borderColor: "rgba(141, 152, 166,1)",
                                pointBackgroundColor: "rgba(141, 152, 166,1)",
                                fill: true,
                                lineTension: 0.3,
                                pointHoverRadius: 5,
                                pointHitRadius: 10,
                                borderWidth: 1
                            }
                        ]
                    });
                    ch.build();
                    helper.onResizeEnd(function () {

                        if ($('.stec-layout-single').hasClass('stec-layout-single-media-small')) {
                            ch.chart.options.legend.display = false;
                        } else {
                            ch.chart.options.legend.display = true;
                        }

                        ch.chart.update();
                    }, 50);
                }, 0);
                $('.stec-layout-single-forecast-content').show();
            },
            chart: function () {

                this.ctx = null;
                this.chartData = null;
                this.chart = null;
                this.setCanvas = function ($canvas) {

                    var canvas = $canvas.get(0);
                    var w = parseInt($('.stec-layout-single-forecast-details-chart').width(), 10);
                    var h = parseInt($('.stec-layout-single-forecast-details-chart').height(), 10);
                    canvas.width = w;
                    canvas.height = h;
                    this.ctx = $canvas.get(0).getContext("2d");
                };
                this.setChartData = function (chartData) {
                    this.chartData = chartData;
                };
                this.destroy = function () {
                    this.chart.destroy();
                };
                this.build = function () {

                    var parent = this;
                    var generalTextColor,
                            generalFontFamily,
                            displayLegend;
                    if (this.chart) {
                        this.destroy();
                    }

                    generalTextColor = $('.stec-layout-single-forecast-details-left-forecast-top p').css('color');
                    generalFontFamily = $('.stec-layout-single-forecast-details-left-forecast-top p').css('font-family');
                    displayLegend = true;
                    if ($('.stec-layout-single').hasClass('stec-media-small')) {
                        displayLegend = false;
                    }

                    this.chart = new window.Chart(this.ctx, {
                        type: 'line',
                        data: parent.chartData,
                        options: {
                            maintainAspectRatio: false,
                            responsive: true,
                            defaultFontFamily: generalFontFamily,
                            defaultFontColor: generalTextColor,
                            legend: {
                                display: displayLegend,
                                labels: {
                                    fontFamily: generalFontFamily,
                                    fontColor: generalTextColor,
                                    fontSize: 12
                                }
                            },
                            scales: {
                                xAxes: [{
                                        ticks: {
                                            fontFamily: generalFontFamily,
                                            fontSize: 11,
                                            fontColor: generalTextColor
                                        },
                                        gridLines: {
                                            color: 'rgba(0,0,0,0.1)',
                                            zeroLineColor: 'rgba(0,0,0,0)'
                                        }
                                    }],
                                yAxes: [
                                    {
                                        id: 'mainYAxis',
                                        position: 'right',
                                        ticks: {
                                            beginAtZero: true,
                                            fontFamily: generalFontFamily,
                                            fontSize: 11,
                                            fontColor: generalTextColor
                                        },
                                        gridLines: {
                                            color: 'rgba(0, 0, 0,0.1)',
                                            zeroLineColor: 'rgba(0,0,0,0)'
                                        }
                                    }
                                ]
                            },
                            tooltips: {
                                titleFontColor: '#fff',
                                titleFontStyle: generalFontFamily,
                                bodyFontFamily: generalFontFamily,
                                bodyFontColor: '#fff'
                            }

                        }
                    });
                };
            },
            bindControls: function () {

                var parent = this;
                $('li[data-tab="stec-layout-single-forecast"]').on(helper.clickHandle(), function () {

                    if (parent.loaded === false) {
                        parent.getWeather();
                        parent.loaded = true;
                    }
                });
            }
        };
        /* Attendance */
        var attendance = {

            ajax: null,
            eventOccurrenceDate: null,
            init: function () {

                var startDate = moment.tz(glob.event.start_date, glob.event.timezone).add(glob.options.repeat_offset, 'seconds');
                var nowDate = moment();
                var timeLeft = Math.floor((startDate.unix() - nowDate.unix()));
                this.eventOccurrenceDate = startDate.format('YYYY-MM-DD');
                if (timeLeft < 0) {

                    $('.stec-layout-single-attendance-buttons').hide();
                    $('.stec-layout-single-attendance-invited').hide();
                    return;
                }

                $('.stec-layout-single .stec-layout-single-attendance-attendee').each(function () {

                    if ($(this).find('.stec-layout-single-attendance-attendee-avatar ul li i').hasClass('fa-check')) {
                        $(this).find('.stec-layout-single-attendance-attendee-persons').show();
                    }

                });
                this.bindControls();
            },
            ajaxAttendance: function (status) {

                // status
                // 0 - no decision
                // 1 - accept 
                // 2 - decline

                var $avatar, $attendee;
                var request = DB.newRequest();
                $avatar = $('.stec-layout-single').find('.stec-layout-single-attendance-attendee-avatar')
                        .filter('[data-userid="' + glob.options.userid + '"]');
                $attendee = $avatar.parent();
                request.setData({
                    action: 'stec_public_ajax_action',
                    task: 'set_user_event_attendance',
                    event_id: glob.event.id,
                    date: this.eventOccurrenceDate,
                    status: status
                });
                request.setBefore(function () {
                    $('.stec-layout-single-attendance-invited-buttons').hide();
                    $(glob.template.preloader).appendTo($('.stec-layout-single-attendance-invited'));
                    $('.stec-layout-single-attendance-buttons').children().hide();
                    $('<li>' + glob.template.preloader + '</li>').appendTo($('.stec-layout-single-attendance-buttons'));
                });
                request.setCallback(function (rtrn) {

                    var status = parseInt(rtrn.status, 10);
                    var slotsLeft = rtrn.slots_left;
                    $('.stec-layout-single-attendance-buttons').children().removeClass('active');
                    $('.stec-layout-single-attendance-invited-buttons').children().removeClass('active');
                    switch (status) {

                        case 1:

                            $('.stec-layout-single-attendance-invited-buttons-attend').addClass('active');
                            $('.stec-layout-single-attendance-button-attend').addClass('active');
                            $avatar
                                    .find('ul li i')
                                    .attr('class', 'fa fa-check');
                            break;
                        case 2:
                            $('.stec-layout-single-attendance-invited-buttons-decline').addClass('active');
                            $('.stec-layout-single-attendance-button-decline').addClass('active');
                            $avatar
                                    .find('ul li i')
                                    .attr('class', 'fa fa-times');
                            break;
                        case 3:
                            $('.stec-layout-single-attendance-buttons').remove();
                            $('.stec-layout-single-attendance-invited').remove();
                            $avatar
                                    .find('ul li i')
                                    .attr('class', 'fa fa-times');
                            break;
                        default:

                            $avatar
                                    .find('ul li i')
                                    .attr('class', 'fa fa-question');
                            $('.stec-layout-single-attendance-buttons').children().removeClass('active');
                            break;
                    }

                    $('.stec-layout-single-attendance-invited-buttons').css('display', 'flex');
                    $('.stec-layout-single-attendance-invited').find('.stec-layout-single-preloader').remove();
                    $('.stec-layout-single-attendance-buttons').children().show();
                    $('.stec-layout-single-attendance-buttons').children().last().remove();
                    $('.stec-layout-single-attendance-slots-count').text(slotsLeft);
                    if (1 === status) {
                        $attendee.find('.stec-layout-single-attendance-attendee-persons').show();
                    } else {
                        $attendee.find('.stec-layout-single-attendance-attendee-persons').hide();
                    }

                });
                DB.query(request);
            },
            bindControls: function () {

                var parent = this;
                $('.stec-layout-single-attendance-invited-buttons-attend').on(helper.clickHandle(), function (e) {

                    e.preventDefault();
                    if ($(this).hasClass('active')) {
                        parent.ajaxAttendance(0);
                    } else {
                        rsvp.settings.id = glob.event.id;
                        rsvp.settings.offset = glob.options.repeat_offset;
                        rsvp.settings.event = glob.event;
                        rsvp.settings.date = moment.tz(glob.event.start_date, glob.event.timezone).add(glob.options.repeat_offset, 'seconds').format('YYYY-MM-DD');
                        rsvp.settings.update = true;
                        rsvp.popOpen();
                    }

                });
                $('.stec-layout-single-attendance-invited-buttons-decline').on(helper.clickHandle(), function (e) {
                    var status;
                    e.preventDefault();
                    status = $(this).hasClass('active') ? 0 : 2;
                    parent.ajaxAttendance(status);
                });
                $('.stec-layout-single-attendance-invited-buttons-unlist').on(helper.clickHandle(), function (e) {
                    var status;
                    e.preventDefault();
                    status = 3;
                    parent.ajaxAttendance(status);
                });
                $('.stec-layout-single-attendance-button-attend').on(helper.clickHandle(), function (e) {

                    e.preventDefault();
                    if ($(this).hasClass('active')) {
                        parent.ajaxAttendance(0);
                    } else {
                        rsvp.settings.id = glob.event.id;
                        rsvp.settings.offset = glob.options.repeat_offset;
                        rsvp.settings.event = glob.event;
                        rsvp.settings.date = moment.tz(glob.event.start_date, glob.event.timezone).add(glob.options.repeat_offset, 'seconds').format('YYYY-MM-DD');
                        rsvp.settings.update = true;
                        rsvp.popOpen();
                    }
                });
                $('.stec-layout-single-attendance-button-decline').on(helper.clickHandle(), function (e) {
                    var status;
                    e.preventDefault();
                    status = $(this).hasClass('active') ? 0 : 2;
                    parent.ajaxAttendance(status);
                });
                $('.stec-layout-single-attendance-button-unlist').on(helper.clickHandle(), function (e) {
                    var status;
                    e.preventDefault();
                    status = 3;
                    parent.ajaxAttendance(status);
                });
            }
        };
        /* Location */
        var location = {
            init: function () {

                if (glob.event.location && 'virtual' === glob.event.location.type) {
                    this.virtulLocation.init();
                    return;
                }

                switch (glob.options.map_type) {
                    case 'osm':
                        this.osmLocation.init();
                        break;
                    case 'gmap':
                    default:
                        this.gmapLocation.init();
                }
            },

            fillMyLocation: function ($el) {

                if (glob.options.myLocation) {
                    $el.val(glob.options.myLocation);
                } else {

                    if (navigator.geolocation) {

                        navigator.geolocation.getCurrentPosition(
                                function (position) {

                                    var pos = [position.coords.latitude, position.coords.longitude];
                                    glob.options.myLocation = pos.join(', ');
                                    $el.val(glob.options.myLocation);
                                },
                                function (a, b, c) {
                                    console.log('Navigator Geolocation Error');
                                }
                        );
                    }
                }
            },

            osmLocation: {
                initNoMap: function () {
                    var parent = this;
                    var $start, $end;
                    parent.$tabCont = $('.stec-layout-single-location');
                    parent.address = glob.event.location.full_address;
                    $start = parent.$tabCont.find('input[name="start"]');
                    $end = parent.$tabCont.find('input[name="end"]');
                    if ($end.val().trim() === "") {
                        $end.val(parent.$tabCont.find(".stec-layout-single-location-address").text());
                    }

                    if ($start.val().trim() === "") {
                        location.fillMyLocation($start);
                    }

                    parent.bindControls();
                },
                init: function () {

                    var parent = this;
                    var $start, $end;
                    if ($('.stec-layout-single-location-map').length <= 0) {
                        return;
                    }

                    $('.stec-layout-single-location-open-map').remove();
                    if (!window.L) {
                        this.initNoMap();
                        return;
                    }

                    parent.mapDiv = $('.stec-layout-single-location-map').get(0);
                    parent.map = helper.osm(parent.mapDiv);
                    parent.$container = $('.stec-layout-single-location');
                    parent.setLocation();
                    // start end directions
                    $start = parent.$container.find('input[name="start"]');
                    $end = parent.$container.find('input[name="end"]');
                    if ($end.val().trim() === "") {
                        $end.val(parent.address);
                    }

                    if ($start.val().trim() === "") {
                        location.fillMyLocation($start);
                    }

                    this.bindControls();
                },
                setLocation: function () {

                    var parent = this;
                    var latlng, pos;
                    var locationCoordinates = glob.event.location.coordinates;
                    parent.address = glob.event.location.full_address;
                    if (locationCoordinates) {

                        latlng = locationCoordinates.split(',');
                        pos = {
                            lat: parseFloat(latlng[0].trim()),
                            lng: parseFloat(latlng[1].trim())
                        };
                        parent.map.setView(pos, 15);
                        window.L.marker(pos).addTo(parent.map);
                    } else {

                        helper.promiseGetAddressCoordinates(parent.address).then(function (locationCoordinates) {

                            glob.event.location.coordinates = locationCoordinates;
                            latlng = locationCoordinates.split(',');
                            pos = {
                                lat: parseFloat(latlng[0].trim()),
                                lng: parseFloat(latlng[1].trim())
                            };
                            parent.map.setView(pos, 15);
                            window.L.marker(pos).addTo(parent.map);
                        });
                    }

                },
                bindControls: function () {

                    $(".stec-layout-single-location-get-direction-btn").on(helper.clickHandle(), function (e) {

                        var promiseCoordinates;
                        var $tabCont = $(".stec-layout-single-location");
                        e.preventDefault();
                        promiseCoordinates = new Promise(function (resolveCoordinates) {
                            var $start = $tabCont.find('input[name="start"]');
                            var startLocation = $start.val();
                            var endLocation = glob.event.location.coordinates;
                            var coords = {
                                start: startLocation,
                                end: endLocation
                            };
                            if (coords.start.match(/[aA-zZ]+/) !== null) {
                                helper.promiseGetAddressCoordinates(startLocation).then(function (startCoords) {
                                    coords.start = startCoords;
                                    return resolveCoordinates(coords);
                                });
                            } else {
                                return resolveCoordinates(coords);
                            }
                        });
                        promiseCoordinates.then(function (coords) {
                            window.open('//www.openstreetmap.org/directions?engine=fossgis_osrm_car&route=' + coords.start + ';' + coords.end, '_blank');
                        });
                    });
                }
            },
            gmapLocation: {
                initNoMap: function () {
                    var parent = this;
                    var $start, $end;
                    parent.$tabCont = $('.stec-layout-single-location');
                    parent.address = glob.event.location.full_address;
                    $start = parent.$tabCont.find('input[name="start"]');
                    $end = parent.$tabCont.find('input[name="end"]');
                    if ($end.val().trim() === "") {
                        $end.val(parent.$tabCont.find(".stec-layout-single-location-address").text());
                    }

                    if ($start.val().trim() === "") {
                        location.fillMyLocation($start);
                    }

                    parent.$tabCont.find('.stec-layout-single-location-get-direction-btn').remove();
                    parent.bindControls();
                },
                init: function () {

                    var parent = this;
                    var $start, $end;
                    if ($('.stec-layout-single-location-map').length <= 0) {
                        return;
                    }

                    if (!window.google || !window.google.maps) {
                        this.initNoMap();
                        return;
                    }

                    parent.mapDiv = $('.stec-layout-single-location-map').get(0);
                    parent.map = new window.google.maps.Map(parent.mapDiv, {
                        zoom: glob.options.gmap_zoom ? parseInt(glob.options.gmap_zoom, 10) : 15
                    });
                    if (glob.options.gmap_theme && glob.options.gmap_theme !== 'standard') {
                        parent.map.mapTypes.set('Custom_Style', helper.getMapStyles(glob.options.gmap_theme));
                        parent.map.setMapTypeId('Custom_Style');
                    }

                    parent.geocoder = new window.google.maps.Geocoder();
                    parent.directionsService = new window.google.maps.DirectionsService();
                    parent.directionsDisplay = new window.google.maps.DirectionsRenderer();
                    parent.directionsDisplay.setMap(parent.map);
                    parent.$container = $('.stec-layout-single-location');
                    parent.address = glob.event.location.full_address;
                    parent.setLocation(parent.address);
                    // start end directions
                    $start = parent.$container.find('input[name="start"]');
                    $end = parent.$container.find('input[name="end"]');
                    if ($end.val().trim() === "") {
                        $end.val(parent.address);
                    }

                    if ($start.val().trim() === "") {
                        location.fillMyLocation($start);
                    }

                    this.bindControls();
                },
                setLocation: function (address) {

                    var parent = this;
                    var latlng, pos;
                    var locationCoordinates = parent.$container.find(".stec-layout-single-location-address").attr("data-location-coordinates");
                    if (locationCoordinates) {

                        latlng = locationCoordinates.split(',');
                        pos = {
                            lat: parseFloat(latlng[0].trim()),
                            lng: parseFloat(latlng[1].trim())
                        };
                        parent.map.setCenter(pos);
                        parent.marker = new window.google.maps.Marker({
                            map: parent.map,
                            position: pos,
                            title: address
                        });
                    } else {

                        parent.geocoder.geocode({'address': address}, function (results, status) {
                            if (status === window.google.maps.GeocoderStatus.OK) {
                                parent.map.setCenter(results[0].geometry.location);
                                parent.marker = new window.google.maps.Marker({
                                    map: parent.map,
                                    position: results[0].geometry.location,
                                    title: address
                                });
                            } else {
                                console.log("Geocoder error");
                            }
                        });
                    }

                    parent.refresh();
                },
                getDirection: function (a, b) {

                    var parent = this;
                    parent.directionsService.route({
                        origin: a,
                        destination: b ? b : parent.marker.position,
                        travelMode: window.google.maps.TravelMode.DRIVING
                    }, function (response, status) {

                        if (status === window.google.maps.DirectionsStatus.OK) {
                            parent.directionsDisplay.setDirections(response);
                        } else {
                            console.log("Direction Service Error");
                            $('.stec-layout-single-location-direction-error').stop().fadeTo(250, 1, function () {

                                setTimeout(function () {
                                    $('.stec-layout-single-location-direction-error').fadeTo(250, 0);
                                }, 3000);
                            });
                        }
                    });
                },
                refresh: function (centerOnLocation) {

                    var parent = this;
                    setTimeout(function () {
                        window.google.maps.event.trigger(parent.mapDiv, 'resize');
                        if (centerOnLocation === true) {
                            parent.setLocation(parent.address);
                        }
                    }, 10); // timeout fixes resize bug

                },
                bindControls: function () {

                    var parent = this;
                    $(".stec-layout-single-location-open-map").on(helper.clickHandle(), function (e) {

                        var $tabCont = $(".stec-layout-single-location");
                        var $start = $tabCont.find('input[name="start"]');
                        var $end = $tabCont.find('input[name="end"]');
                        var eventLocation = $end.val();
                        var latlng, href;
                        if (glob.event.location.coordinates) {
                            latlng = glob.event.location.coordinates.split(',');
                            eventLocation = {
                                lat: parseFloat(latlng[0].trim()),
                                lng: parseFloat(latlng[1].trim())
                            };
                            href = 'https://www.google.com/maps/dir/?api=1&origin=' + $start.val() + '&destination=' + eventLocation.lat + ',' + eventLocation.lng + '&travelmode=driving';
                            $(this).attr('href', href);
                        } else {
                            e.preventDefault();
                        }
                    });
                    $(".stec-layout-single-location-get-direction-btn").on(helper.clickHandle(), function (e) {

                        var $tabCont = $(".stec-layout-single-location");
                        var $start = $tabCont.find('input[name="start"]');
                        var $end = $tabCont.find('input[name="end"]');
                        var eventLocation = $end.val();
                        var latlng;
                        if (glob.event.location.coordinates) {
                            latlng = glob.event.location.coordinates.split(',');
                            eventLocation = {
                                lat: parseFloat(latlng[0].trim()),
                                lng: parseFloat(latlng[1].trim())
                            };
                        }

                        if ($start.val() && eventLocation) {
                            e.preventDefault();
                            parent.getDirection($start.val(), eventLocation);
                        }

                        e.preventDefault();
                    });
                }
            },
            virtulLocation: {
                init: function () {
                    this.controller();
                },

                controller: function () {
                    $('.stec-layout-single-location-virtual').find('[data-action="stec-copy-link"]').on(helper.clickHandle(), function (e) {
                        var linkURL = $(this).attr('href');
                        var $temp = $("<input>");
                        e.preventDefault();
                        $("body").append($temp);
                        $temp.val(linkURL).select();
                        document.execCommand("copy");
                        $temp.remove();
                        helper.toast(__('copiedToClipboard'));
                    });
                }
            }

        };
        /* Tabs */
        var tabs = {

            init: function () {

                this.bindControls();

                if ($('.stec-layout-single-default').length > 0) {
                    this.checkSingleDefaultTabs();
                }
            },
            checkSingleDefaultTabs: function () {

                if (0 === glob.event.location.length || !glob.options.weather_api_key || 'EventMovedOnline' === glob.event.event_status) {
                    this.removeTab('forecast');
                }

                if (glob.event.schedule.length <= 0) {
                    this.removeTab('schedule');
                }

                if (glob.event.guests.length <= 0) {
                    this.removeTab('guests');
                }

                if (glob.event.attendance.length <= 0) {
                    this.removeTab('attendance');
                }

                if (glob.event.products.length <= 0) {
                    this.removeTab('shop');
                }

                if (glob.event.comments <= 0) {
                    this.removeTab('comments');
                }

                if ($('.stec-layout-single-default .stec-layout-single-tabs-list').children().length <= 0) {
                    $('.stec-layout-single-default .stec-layout-single-tabs').remove();
                } else {
                    $('.stec-layout-single-default .stec-layout-single-tabs-list > li').first().trigger(helper.clickHandle());
                }

            },

            removeTab: function (tabName) {

                if ($('.stec-layout-single-tabs-list > [data-tab="stec-layout-single-' + tabName + '"]').length <= 0) {
                    return;
                }

                $('.stec-layout-single-tabs-list > [data-tab="stec-layout-single-' + tabName + '"]').remove();
                $('.stec-layout-event-single-tabs-content > [data-tab="stec-layout-single-' + tabName + '"]').remove();
            },
            bindControls: function () {

                $('.stec-layout-single-tabs-list ').children('li').on(helper.clickHandle(), function () {

                    var tab;
                    if ($(this).hasClass('active')) {
                        return;
                    }

                    $('.stec-layout-single-tabs-list').children('li').not(this).removeClass('active');
                    $(this).addClass('active');
                    tab = $(this).attr('data-tab').replace('stec-layout-single-', '');
                    $('.stec-layout-event-single-tabs-content').children('div').removeClass('active');
                    $('.stec-layout-event-single-tabs-content').children('div').filter('[data-tab="stec-layout-single-' + tab + '"]').addClass('active');
                });
            }
        };
        /* Schedule */
        var schedule = {

            init: function () {

                this.bindControls();
            },
            bindControls: function () {

                $('.stec-layout-single-schedule-tab-preview').on(helper.clickHandle(), function (e) {
                    e.preventDefault();
                    $(this).parents(".stec-layout-single-schedule-tab")
                            .not('.stec-layout-single-schedule-tab-no-desc')
                            .toggleClass("open");
                });
            }
        };
        /* Shop */
        var shop = {

            init: function () {
                if (window.StecShop && window.stecSingleEvent.products.length > 0) {
                    shop = new window.StecShop();

                    shop
                            .set('$instance', $('.stec-layout-single'))
                            .set('helper', helper)
                            .set('glob', glob);

                    shop.controller();

                    shop.settings.event = glob.event;
                    shop.settings.offset = glob.options.repeat_offset;
                    shop.settings.$container = $('.stec-layout-single');

                    shop.displayProducts();

                } else {
                    $('.stec-layout-single-shop').remove();
                }
            }

        };

        var preview = {
            init: function () {
                this.bindControls();
            },
            bindControls: function () {

                if ($('.stec-layout-single-preview-left-icon-image').length > 0) {

                    setInterval(function () {

                        $('.stec-layout-single').find('.stec-layout-single-preview-left-icon-images').filter(':visible').each(function () {

                            var currentImage, nextImage;
                            if ($(this).children().length <= 1) {
                                return;
                            }

                            currentImage = $(this).children().filter('.active');
                            nextImage = currentImage.next();
                            if (nextImage.length === 0) {
                                nextImage = $(this).children().first();
                            }

                            nextImage.addClass('transition');
                            setTimeout(function () {
                                currentImage.removeClass('active');
                                nextImage.removeClass('transition').addClass('active');
                            }, 1000);
                        });
                    }, 6000);
                }
            }
        };

        /* Init */
        this.init = function () {

            // Assign settings
            $.extend(glob.options, window.stecSingleOptions);
            glob.event = window.stecSingleEvent;
            glob.options.siteurl = glob.options.site_url;
            if (!glob.event) {
                return;
            }

            // Assign helper
            helper = new window.StecHelper();
            helper.set('glob', glob);
            helper.set('$instance', $('.stec-layout-single'));

            // Assign DB
            DB = new window.StecDB();

            // Init reminder
            reminder = new window.StecReminder('reminder-popup-id-single');
            reminder
                    .set('$instance', $('.stec-layout-single'))
                    .set('instance', '.stec-layout-single')
                    .set('helper', helper)
                    .set('calData', null)
                    .set('displayPrivacyAgreement', glob.options.display_privacy_agreement)
                    .set('privacyAgreemntContent', glob.options.privacy_agreement_content)
                    .set('glob', glob);
            reminder.controller();

            // Init RSVP
            rsvp = new window.StecRsvpToEvent('rsvp-popup-id-' + glob.options.id);
            rsvp
                    .set('$instance', $('.stec-layout-single'))
                    .set('helper', helper)
                    .set('calData', null)
                    .set('displayPrivacyAgreement', glob.options.display_privacy_agreement)
                    .set('privacyAgreemntContent', glob.options.privacy_agreement_content)
                    .set('glob', glob);
            rsvp.controller();

            // Init Sharer
            $('.stec-layout-single').find('.stec-layout-single-share-and-export .stec-embed-button').on(helper.clickHandle(), function (e) {
                var linkURL = $(this).attr('href');
                var sharer = new window.stecSharer($('.stec-layout-single'), glob, helper, linkURL, glob.event.id, glob.options.repeat_offset);

                e.stopPropagation();
                e.preventDefault();

                sharer.init();
            });

            // Init Email share
            $('.stec-layout-single').find('.stec-layout-single-share-and-export .stec-email-button').on(helper.clickHandle(), function (e) {
                var eventId = glob.event;
                var eventOffset = glob.options.repeat_offset;
                var linkURL = $(this).attr('href');
                var emailForm = new window.stecEmailEvent($('.stec-layout-single'), glob, helper, linkURL, eventId, eventOffset);

                e.stopPropagation();
                e.preventDefault();

                emailForm.init();
            });

            // Assign predefined templates
            glob.template.preloader = '<div class="stec-layout-single-preloader"></div>';
            glob.template.share = $("#stec-share-template").html();
            glob.template.emailEvent = $("#stec-email-event-template").html();

            // Init everything else
            media.init();
            preview.init();
            slider.init();
            attachments.init();
            clock.init();
            booking.init();
            comments.init();
            forecast.init();
            attendance.init();
            location.init();
            schedule.init();
            shop.init();
            tabs.init();

        };
        moment.locale('en');
    }

    window.StecSingle = StecSingle;
    $(function () {
        var single = new window.StecSingle();
        single.init();
    });
})(window.jQuery);