<?php

namespace Stachethemes\Stec;

class Html_Templates {

    public static function get_submit_form_templates() {
        ?>
        <script type="text/html" id="stec-builder-submission-guest-template">
            <div class="stec-builder-submission-guest">

                <div class="stec-builder-submission-guest-head">
                    <p class="stec-builder-element-content-p-style"><?php esc_html_e('Guest', 'stec'); ?></p>
                    <div>
                        <button type="button" class="stec-builder-element-content-button-style expand"><?php esc_html_e('Expand', 'stec'); ?></button>
                        <button type="button" class="stec-builder-element-content-button-style collapse"><?php esc_html_e('Collapse', 'stec'); ?></button>
                        <button type="button" class="stec-builder-element-content-button-style delete"><?php esc_html_e('Delete', 'stec'); ?></button>            
                    </div>
                </div>

                <div class="stec-builder-submission-guest-toggle-wrap">
                    <div>
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Name', 'stec'); ?></p>
                        <input class="stec-builder-element-content-input-style" type="text" name="guests[0][name]" placeholder="<?php esc_html_e('Guest name', 'stec'); ?>" value="">
                    </div>
                    <div>
                        <button class="stec-builder-add-media-photo"><?php esc_html_e('Add Photo', 'stec'); ?></button>       
                    </div>
                    <div>
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('About', 'stec'); ?></p>
                        <textarea class="stec-builder-element-content-textarea-style" name="guests[0][about]" placeholder="<?php esc_html_e('About your guest', 'stec'); ?>"></textarea>
                    </div>
                    <div>
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Social Links', 'stec'); ?></p>            
                        <div class="stec-builder-submission-guest-social">
                            <select class="stec-builder-element-content-select-style" name="guests[0][social][0][ico]" autocomplete="off">
                                <?php
                                $social = Admin_Helper::social_array();
                                foreach ($social as $k => $v) {
                                    printf('<option value="%s">%s</option>', esc_attr($k), esc_html($v));
                                }
                                ?>
                            </select>
                            <input class="stec-builder-element-content-input-style" type="text" name="guests[0][social][0][link]" placeholder="<?php esc_html_e('Link', 'stec'); ?>" value="">
                            <i class="stec-builder-submission-guest-social-remove fa fa-times"></i>
                        </div>
                    </div>
                    <button type="button" class="stec-builder-element-content-button-style add-guests-soclink"><?php esc_html_e('Add social link', 'stec'); ?></button>       
                </div>
            </div>

        </script>

        <script type="text/html" id="stec-builder-submission-schedule-template">

            <?php
            $hours_list   = \Stachethemes\Stec\Admin_Helper::get_hours_array();
            $minutes_list = \Stachethemes\Stec\Admin_Helper::minutes_array();
            ?>

            <div class="stec-builder-submission-schedule">

                <div class="stec-builder-submission-schedule-head">
                    <p class="stec-builder-element-content-p-style"><?php esc_html_e('Schedule Timespan', 'stec'); ?></p>
                    <div>
                        <button type="button" class="stec-builder-element-content-button-style expand"><?php esc_html_e('Expand', 'stec'); ?></button>
                        <button type="button" class="stec-builder-element-content-button-style collapse"><?php esc_html_e('Collapse', 'stec'); ?></button>
                        <button type="button" class="stec-builder-element-content-button-style delete"><?php esc_html_e('Delete', 'stec'); ?></button>            
                    </div>
                </div>

                <div class="stec-builder-submission-schedule-toggle-wrap">
                    <div>
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Date and time', 'stec'); ?></p>
                        <div>
                            <input class="stec-builder-element-content-datetime-style stec-builder-element-content-input-style" type="text" name="schedule[0][schedule_date_from]" />
                            <input type="hidden" name="schedule[0][schedule_date_from_alt]" />
                            <select class="stec-builder-element-content-datetime-style stec-builder-element-content-select-style" name="schedule[0][schedule_time_hours_from]">
                                <?php
                                foreach ($hours_list as $key => $value) :
                                    ?>
                                    <option value="<?php esc_attr_e($key); ?>"><?php esc_html_e($value); ?></option>
                                    <?php
                                endforeach;
                                ?>
                            </select>
                            <select  class="stec-builder-element-content-datetime-style stec-builder-element-content-select-style" name="schedule[0][schedule_time_minutes_from]">
                                <?php
                                foreach ($minutes_list as $key => $value) :
                                    ?>
                                    <option value="<?php esc_attr_e($key); ?>"><?php esc_html_e($value); ?></option>
                                    <?php
                                endforeach;
                                ?>
                            </select>
                        </div>
                    </div>
                    <div>
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Name', 'stec'); ?></p>
                        <input class="stec-builder-element-content-input-style" type="text" name="schedule[0][schedule_title]" placeholder="<?php esc_html_e('Title', 'stec'); ?>" value="">
                    </div>
                    <div>
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Icon', 'stec'); ?></p>
                        <?php
                        $icons_list = Admin_Helper::get_icon_list();
                        $options    = array();
                        foreach ($icons_list as $k => $icon) {
                            $options[] = "<option value='{$k}'>{$icon}</option>";
                        }
                        printf('<select class="stec-builder-element-content-select-style" name="schedule[0][schedule_icon]">%s</select>', implode(PHP_EOL, $options));
                        ?>
                    </div>
                    <div>
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Color', 'stec'); ?></p>
                        <input class="stec-builder-element-content-colorpicker-style" name="schedule[0][schedule_icon_color]" value="#000" />
                    </div>
                    <div>
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Details', 'stec'); ?></p>
                        <textarea class="stec-builder-element-content-textarea-style" name="schedule[0][schedule_details]" placeholder="<?php esc_html_e('Timespan details', 'stec'); ?>"></textarea>
                    </div>
                </div>

            </div>
        </script>

        <script type="text/html" id="stec-builder-submission-organizer-template">

            <div class="stec-builder-submission-organizer">

                <div class="stec-builder-submission-organizer-head">
                    <p class="stec-builder-element-content-p-style"><?php esc_html_e('Insert new Organizer', 'stec'); ?></p>
                    <div>
                        <button type="button" class="stec-builder-element-content-button-style delete"><?php esc_html_e('Delete', 'stec'); ?></button>            
                    </div>
                </div>

                <div class="stec-builder-submission-organizer-toggle-wrap">
                    <div>
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Name', 'stec'); ?></p>
                        <input class="stec-builder-element-content-input-style" type="text" name="name" placeholder="<?php esc_html_e('Organizer name', 'stec'); ?>" value="">
                    </div>
                    <div>
                        <button class="stec-builder-add-media-photo"><?php esc_html_e('Add Photo', 'stec'); ?></button>       
                    </div>
                    <div>
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('About', 'stec'); ?></p>
                        <textarea class="stec-builder-element-content-textarea-style" name="details" placeholder="<?php esc_html_e('About your organizer', 'stec'); ?>"></textarea>
                    </div>
                    <div>
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Contact e-mail', 'stec'); ?></p>
                        <input class="stec-builder-element-content-input-style" type="email" name="email" placeholder="<?php esc_html_e('E-mail', 'stec'); ?>" value="">
                    </div>
                    <div>
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Social Links', 'stec'); ?></p>            
                        <div class="stec-builder-submission-organizer-social">
                            <select class="stec-builder-element-content-select-style" name="social[0][ico]" autocomplete="off">
                                <?php
                                $social = Admin_Helper::social_array();
                                foreach ($social as $id => $name) {
                                    printf("<option value='%s'>%s</option>", esc_attr($id), esc_html($name));
                                }
                                ?>
                            </select>
                            <input class="stec-builder-element-content-input-style" type="text" name="social[0][link]" placeholder="<?php esc_html_e('Link', 'stec'); ?>" value="">
                            <i class="stec-builder-submission-organizer-social-remove fa fa-times"></i>
                        </div>
                    </div>
                    <button type="button" class="stec-builder-element-content-button-style add-organizers-soclink"><?php esc_html_e('Add social link', 'stec'); ?></button>       
                </div>

                <div class="status" data-default-text="<?php esc_html_e('Adding new organizer. Please wait...', 'stec'); ?>">
                    <p class="stec-builder-element-content-p-style">-</p>
                </div>

                <button type='button' class='stec-builder-element-content-button-style' data-action="insert-organizer">
                    <i class="fas fa-plus"></i>
                    <?php esc_html_e('Add to Organizers', 'stec'); ?>
                </button>

            </div>

        </script>

        <script type="text/html" id="stec-repeater-content-exdate-datelist-template">
            <li>
                <span>stec_replace_date</span>
                <a class="stec-remove-exdate" href="javascript:void(0);"><?php esc_html_e('Remove', 'stec'); ?></a>
            </li>
        </script>

        <script type="text/html" id="stec-builder-submission-attendance-template">
            <div class="stec-builder-submission-attendance">

                <div class="stec-builder-submission-attendee-head">
                    <p class="stec-builder-element-content-p-style"><?php esc_html_e('Attendee', 'stec'); ?></p>
                    <div>
                        <button type="button" class="stec-builder-element-content-button-style expand"><?php esc_html_e('Expand', 'stec'); ?></button>
                        <button type="button" class="stec-builder-element-content-button-style collapse"><?php esc_html_e('Collapse', 'stec'); ?></button>
                        <button type="button" class="stec-builder-element-content-button-style delete"><?php esc_html_e('Delete', 'stec'); ?></button>            
                    </div>
                </div>

                <div class="stec-builder-submission-attendee-toggle-wrap">
                    <div>
                        <input class="stec-builder-element-content-input-style" type="email" name="attendees[0][email]" placeholder="<?php esc_html_e('Attendee e-mail', 'stec'); ?>" value="">
                        <input class="stec-builder-element-content-input-style" type="number" min="1" name="attendees[0][people]" placeholder="<?php esc_html_e('People', 'stec'); ?>" value="">
                        <div class="stec-builder-element-content-checkbox-style">
                            <label>
                                <input type="checkbox" name="attendees[0][send_email]" placeholder="<?php esc_html_e('Send e-mail', 'stec'); ?>" value="">
                                <p class="stec-builder-element-content-p-style"><?php esc_html_e('Send E-mail', 'stec'); ?></p>
                            </label>
                        </div>
                    </div>
                </div>

            </div>
        </script>

        <script type="text/html" id="stec-builder-submission-ticket-template">

            <?php if (class_exists('WooCommerce')) : ?>

                <div class="stec-builder-submission-ticket">

                    <div class="stec-builder-submission-ticket-head">
                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Ticket', 'stec'); ?></p>
                        <div>
                            <button type="button" class="stec-builder-element-content-button-style expand"><?php esc_html_e('Expand', 'stec'); ?></button>
                            <button type="button" class="stec-builder-element-content-button-style collapse"><?php esc_html_e('Collapse', 'stec'); ?></button>
                            <button type="button" class="stec-builder-element-content-button-style delete"><?php esc_html_e('Delete', 'stec'); ?></button>            
                        </div>
                    </div>

                    <div class="stec-builder-submission-ticket-toggle-wrap">
                        <div class='stec-builder-submission-ticket-flex'>
                            <div>
                                <p class="stec-builder-element-content-p-style"><?php esc_html_e('Name', 'stec'); ?></p>
                                <input class="stec-builder-element-content-input-style" type="text" name="tickets[0][name]" placeholder="<?php esc_html_e('Ticket name', 'stec'); ?>" value="">
                                <input type="hidden" name="tickets[0][id]" value="0" />
                            </div>
                            <div>
                                <p class="stec-builder-element-content-p-style"><?php printf('%s (%s)', esc_html__('Price', 'stec'), get_woocommerce_currency()); ?></p>
                                <input class="stec-builder-element-content-input-style" step="0.1" type="number" min='0' name="tickets[0][price]" placeholder="<?php esc_html_e('Ticket price', 'stec'); ?>" value="">
                            </div>
                        </div>
                        <div class='stec-builder-submission-ticket-flex'>
                            <div>
                                <p class="stec-builder-element-content-p-style"><?php esc_html_e('Total Quantity', 'stec'); ?></p>
                                <input class="stec-builder-element-content-input-style" type="number" min='0' name="tickets[0][qty]" placeholder="<?php esc_html_e('Total Quantity', 'stec'); ?>" value="0">
                            </div>
                            <div>
                                <p class="stec-builder-element-content-p-style"><?php esc_html_e('Quantity limit per event', 'stec'); ?></p>
                                <input class="stec-builder-element-content-input-style" type="number" min='0' name="tickets[0][qty_per_event]" placeholder="<?php esc_html_e('Quantity per event', 'stec'); ?>" value="0">
                            </div>
                        </div>

                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Stop purchases', 'stec') ?></p>
                        <div class="stec-builder-submission-ticket-flex stec-builder-submission-ticket-stop-before">
                            <div>
                                <input class="stec-builder-element-content-input-style" type="number" min='0' name="tickets[0][wc_book_create_ticket_stop_purchase][value]" placeholder="<?php esc_html_e('Total Quantity', 'stec'); ?>" value="0">
                            </div>
                            <div>
                                <select class="stec-builder-element-content-input-style" name="tickets[0][wc_book_create_ticket_stop_purchase][units]">
                                    <option value="hours"><?php esc_attr_e('Hour(s)', 'stec') ?></option>
                                    <option value="days"><?php esc_attr_e('Day(s)', 'stec') ?></option>
                                </select>
                            </div>
                            <div>
                                <p class="stec-builder-element-content-p-style"><?php echo esc_html_x('before the event', 'Days/Hours before the event', 'stec'); ?></p>
                            </div>
                        </div>

                        <div>
                            <p class="stec-builder-element-content-p-style"><?php esc_html_e('Short Description', 'stec'); ?></p>
                            <textarea class="stec-builder-element-content-textarea-style" name="tickets[0][about]" placeholder="<?php esc_html_e('About your ticket', 'stec'); ?>"></textarea>
                        </div>

                        <p class="stec-builder-element-content-p-style"><?php esc_html_e('Attributes', 'stec'); ?></p>            
                        <div class="stec-builder-submission-ticket-attributes">
                            <input class="stec-builder-element-content-input-style" type="text" name="tickets[0][attr][0][attr_name]" placeholder="<?php esc_html_e('Name', 'stec'); ?>" value="">
                            <input class="stec-builder-element-content-input-style" type="text" name="tickets[0][attr][0][attr_value]" placeholder="<?php esc_html_e('Value', 'stec'); ?>" value="">
                            <i class="stec-builder-submission-ticket-attrib-remove fa fa-times"></i>
                        </div>
                        <button type="button" class="stec-builder-element-content-button-style add-ticket-attribute"><?php esc_html_e('Add attribute', 'stec'); ?></button>       
                    </div>

                </div>

            <?php endif; ?>

        </script>
        <?php
    }

    public static function get_admin_templates() {
        ?>
        <script type="text/html" id="stachethemes-admin-attachments-attachment-template">
            <div class="stachethemes-admin-attachments-attachment">

                <div class="stachethemes-admin-attachments-attachment-head">
                    <p class="stachethemes-admin-attachments-attachment-title"><span>%title%</span></p>

                    <div>
                        <?php
                        Admin_Html::html_button(esc_html__('Delete', 'stec'), '', true, "light-btn delete");
                        ?>
                    </div>
                </div>

                <?php
                Admin_Html::html_hidden('attachment[0][id]', '%id%');
                ?>
            </div>
        </script>

        <script type="text/html" id="stachethemes-admin-attendance-list-attendee-template">

            <li class="stachethemes-admin-attendance-list-attendee"> 
                <div class="preview">
                    <div>
                        <input type="checkbox" /> 
                        <span class="status"><i class="stec_replace_status_class"></i></span> 
                        <p>
                            <span class="name">stec_replace_name</span> - <i class="email">stec_replace_email</i>
                            <br>
                            <span class="people"><span>stec_replace_people</span> <?php esc_html_e('person(s)', 'stec'); ?></span>
                        </p> 
                    </div>
                    <div>
                        <button data-action="edit" type="button"><?php esc_html_e('Edit', 'stec'); ?></button>
                        <button data-action="remove" type="button"><?php esc_html_e('Remove', 'stec'); ?></button>
                    </div>
                </div>

                <div class="edit">

                    <div>
                        <div>
                            <?php
                            Admin_Html::html_info(esc_html__('Name', 'stec'));
                            Admin_Html::html_input('attendee[0][name]', '', '', '', false, 'text');
                            ?>
                        </div>
                        <div>
                            <?php
                            Admin_Html::html_info(esc_html__('E-Mail', 'stec'));
                            Admin_Html::html_input('attendee[0][email]', '', '', '', false, 'email');
                            ?>
                        </div>
                        <div>
                            <?php
                            Admin_Html::html_info(esc_html__('Number of persons', 'stec'));
                            Admin_Html::html_input('attendee[0][people]', '', '1', '1', false, 'number', 'min=1');
                            ?>
                        </div>
                        <div>
                            <?php
                            Admin_Html::html_info(sprintf(esc_html__('RSVP Status for %s', 'stec'), '<i class="rsvp-date"></i>'));
                            Admin_Html::html_select('attendee[0][status]', array(
                                1 => esc_html__('Attending', 'stec'),
                                2 => esc_html__('Declined', 'stec'),
                                0 => esc_html__('No response', 'stec'),
                                    ), 0, false, false);
                            ?>
                        </div>

                        <input type="hidden" name="attendee[0][userid]" />
                        <input type="hidden" name="attendee[0][role]" />
                        <input type="hidden" name="attendee[0][type]" />
                    </div>
                    <?php
                    Admin_Html::html_checkbox('attendee[0][send]', true, true, esc_html__('Send invitation e-mail', 'stec'), false);
                    Admin_Html::html_button(esc_html__('Update attendee', 'stec'), 'javascript:void(0);', false, 'blue-button', 'data-action=update-attendee');
                    Admin_Html::html_button(esc_html__('Cancel', 'stec'), 'javascript:void(0);', true, 'blue-button', 'data-action=cancel-update-attendee');
                    ?>
                </div>

            </li>

        </script>

        <script type="text/html" id="stachethemes-admin-woocommerce-product-template">

            <?php if (class_exists('WooCommerce')) : ?>

                <div class="stachethemes-admin-woocommerce-product">

                    <div class="stachethemes-admin-woocommerce-product-head">
                        <p class="stachethemes-admin-woocommerce-product-title"><span></span><span>stec_replace_wc_product_name</span></p>
                        <input type="hidden" name="wc_bookable_product[]" value="stec_replace_wc_product_id" />
                        <div>
                            <?php
                            Admin_Html::html_button(esc_html__('Remove', 'stec'), '', true, "light-btn delete");
                            ?>
                        </div>
                    </div>

                </div> 

            <?php endif; ?>
        </script>

        <script type="text/html" id="stec-repeater-popup-exdate-datelist-template">
            <li>
                <span>stec_replace_date</span>
                <span class="stec-repeater-popup-exdate-datelist-submit-value">stec_replace_altdate</span>
                <a class="stec-remove-exdate" href="javascript:void(0);">
                    <?php esc_html_e('Remove', 'stec'); ?>
                </a>
            </li>
        </script>

        <script type="text/html" id="stachethemes-admin-guests-guest-template">

            <div class="stachethemes-admin-guests-guest">

                <div class="stachethemes-admin-guests-guest-head">
                    <p class="stachethemes-admin-guests-guest-title"><span></span><span><?php esc_html_e('Add Guest (optional)', 'stec'); ?></span></p>

                    <div>
                        <?php
                        Admin_Html::html_button(esc_html__('Expand', 'stec'), '', true, "light-btn expand");
                        Admin_Html::html_button(esc_html__('Collapse', 'stec'), '', true, "light-btn collapse");
                        Admin_Html::html_button(esc_html__('Delete', 'stec'), '', true, "light-btn delete");
                        ?>
                    </div>
                </div>

                <div class="stachethemes-admin-guests-toggle-wrap">

                    <?php
                    Admin_Html::html_info(esc_html__('Photo', 'stec'));
                    Admin_Html::html_add_image('guests[0][photo]', false, esc_html__('Add Photo', 'stec'), false, true);

                    Admin_Html::html_info(esc_html__('Name', 'stec'));
                    Admin_Html::html_input('guests[0][name]', '', '', esc_html__('Name', 'stec'), false);

                    Admin_Html::html_info(esc_html__('About', 'stec'));
                    Admin_Html::html_textarea('guests[0][about]', '', '', esc_html__('About your guest', 'stec'), false);

                    Admin_Html::html_info(esc_html__('Social Links', 'stec'));
                    ?>
                    <div class="stachethemes-admin-section-flex-guest-social">
                        <?php
                        Admin_Html::html_select('guests[0][social][0][ico]', Admin_Helper::social_array(), '', true);
                        Admin_Html::html_input('guests[0][social][0][link]', '', '', esc_html__('Link', 'stec'));
                        ?>
                        <i class="stachethemes-admin-guests-social-remove fa fa-times"></i>
                    </div>
                    <?php
                    Admin_Html::html_button(esc_html__('Add social link', 'stec'), false, false, 'light-btn add-guests-soclink');
                    ?>
                </div>

            </div>

        </script>

        <script type="text/html" id="stachethemes-admin-schedule-timespan-template">
            <div class="stachethemes-admin-schedule-timespan">
                <div class="stachethemes-admin-schedule-timespan-head">
                    <p class="stachethemes-admin-schedule-timespan-title"><span></span><span><?php esc_html_e('Schedule Timespan (optional)', 'stec'); ?></span></p>

                    <div>
                        <?php
                        Admin_Html::html_button(esc_html__('Expand', 'stec'), '', true, "light-btn expand");
                        Admin_Html::html_button(esc_html__('Collapse', 'stec'), '', true, "light-btn collapse");
                        Admin_Html::html_button(esc_html__('Delete', 'stec'), '', true, "light-btn delete");
                        ?>
                    </div>
                </div>

                <div class="stachethemes-admin-schedule-toggle-wrap">
                    <?php
                    Admin_Html::html_info(esc_html__('Date and time', 'stec'));
                    ?>
                    <div class="stachethemes-admin-section-flex">
                        <?php
                        Admin_Html::html_date('schedule[0][schedule_date_from]', '', '', esc_html__('Date', 'stec'), false);
                        Admin_Html::html_select('schedule[0][schedule_time_hours_from]', Admin_Helper::get_hours_array(), '00');
                        Admin_Html::html_select('schedule[0][schedule_time_minutes_from]', Admin_Helper::minutes_array(), '00');
                        ?>
                    </div>
                    <?php
                    Admin_Html::html_info(esc_html__('Title', 'stec'));
                    Admin_Html::html_input('schedule[0][schedule_title]', '', '', esc_html__('Timespan Title', 'stec'), false);

                    Admin_Html::html_info(esc_html__('Icon', 'stec'));
                    Admin_Html::html_hidden('schedule[0][schedule_icon]', 'fa');
                    ?>
                    <div class="stec-icons-list schedule">
                        <ul>
                            <?php
                            $icons = Admin_Helper::get_icon_list();
                            foreach ($icons as $key => $value) {
                                ?><li data-icon="<?php esc_attr_e($key) ?>"><i class="<?php esc_attr_e($key) ?>"></i></li><?php
                            }
                            ?>
                        </ul>

                        <?php
                        Admin_Html::html_info(esc_html__('Add icon from Font-Awesome', 'stec'));
                        Admin_Html::html_input('add_fa_icon', '', '', 'Icon class name');
                        Admin_Html::html_button(esc_html__('Add to the list', 'stec'), '', true, 'blue-button add-fa-icon');
                        ?>
                    </div>
                    <?php
                    Admin_Html::html_info(esc_html__('Icon Color', 'stec'));
                    Admin_Html::html_color("schedule[0][schedule_icon_color]", "#000000", "#000000");

                    Admin_Html::html_info(esc_html__('Details', 'stec'));
                    Admin_Html::html_textarea('schedule[0][schedule_details]', '', '', esc_html__('Timespan Details', 'stec'), false);
                    ?>
                </div>
            </div>
        </script>

        <script type="text/html" id="stec-create-ticket-form-add-field-template">

            <?php if (class_exists('WooCommerce')) : ?>

                <div class="stec-create-ticket-form-custom-field stachethemes-admin-section-flex stachethemes-admin-section-flex-margin">
                    <div>
                        <?php
                        Admin_Html::html_info(esc_html__('Name', 'stec'));
                        Admin_Html::html_input('wc_book_create_ticket_addinfo_field[0][name]', '', '', '', false);
                        ?>
                    </div>
                    <div>
                        <?php
                        Admin_Html::html_info(esc_html__('Value', 'stec'));
                        Admin_Html::html_input('wc_book_create_ticket_addinfo_field[0][value]', '', '', '', false);
                        ?>
                    </div>
                    <i class="fas fa-times stec-create-ticket-form-remove-field"></i>
                </div>

            <?php endif; ?>
        </script>

        <?php
    }

    public static function get_share_modal_template() {
        ?>

        <script type="text/html" id="stec-share-template">
            <div class="stec-share stec-modal">

                <div class="stec-share-block">

                    <div class="stec-share-block-top">
                        <div>
                            <i class="fa fa-link"></i>
                            <span class="stec-share-block-title"><?php esc_html_e('Share this event', 'stec'); ?></span>
                        </div>
                        <span class="stec-share-close"><i class="fa fa-times"></i></span>

                    </div>

                    <div class="stec-share-wrap">

                        <span class="stec-share-fw stec-share-text"><?php esc_html_e('Permalink', 'stec'); ?></span>

                        <div class="stec-share-flex">
                            <input name="stec_permalink" type="text" value="" /><button data-copy-permalink title="<?php esc_html_e('Copy to clipboard', 'stec'); ?>" type="button"><i class="fa fa-clipboard"></i></button>
                        </div>

                        <?php if (Settings::get_admin_setting_value('stec_menu__general', 'allow_embedding') === '1') : ?>

                            <span class="stec-share-fw stec-share-text"><?php esc_html_e('Embed code', 'stec'); ?></span>

                            <div class="stec-share-flex">
                                <textarea name="stec_embed"></textarea><button data-copy-embed title="<?php esc_html_e('Copy to clipboard', 'stec'); ?>" type="button"><i class="fa fa-clipboard"></i></button>
                            </div>

                            <span class="stec-share-fw stec-share-text"><?php esc_html_e('Width in pixels (Height will be calculated automatically)', 'stec'); ?></span>
                            <input name="stec_embed_width" type="text" value="400" />

                        <?php endif; ?>

                    </div>
                </div>
            </div>
        </script>

        <script type="text/html" id="stec-email-event-template">
            <div class="stec-email-event stec-modal">

                <div class="stec-email-event-block">

                    <div class="stec-email-event-block-top">
                        <div>
                            <i class="fa fa-envelope"></i>
                            <span class="stec-email-event-block-title"><?php esc_html_e('E-mail this event', 'stec'); ?></span>
                        </div>
                        <span class="stec-email-event-close"><i class="fa fa-times"></i></span>

                    </div>

                    <div class="stec-email-event-wrap">

                        <span class="stec-email-event-fw stec-email-event-text"><?php esc_html_e('Enter E-Mail Address', 'stec'); ?></span>

                        <div class="stec-email-event-flex">
                            <input name="stec_email" type="email" value="" />
                        </div>


                        <span class="stec-email-event-fw stec-email-event-text"><?php esc_html_e('Enter your message', 'stec'); ?></span>

                        <div class="stec-email-event-flex">
                            <textarea name="stec_message"></textarea>
                        </div>

                        <a class="stec-email-event-compose stec-style-button stec-style-float-left" href="mailto:"><?php esc_html_e('Send', 'stec'); ?></a>

                    </div>
                </div>
            </div>
        </script>

        <?php
    }

    public static function get_calendar_templates() {
        ?>

        <script type="text/html" id="stec-tooltip-template">
            <div class="stec-tooltip">

                <div class="stec-tooltip-image"> 
                    stec_replace_image
                </div>

                stec_replace_icon

                stec_replace_event_status

                <p class="stec-tooltip-title">stec_replace_summary</p>
                <div class="stec-tooltip-desc">stec_replace_desc_short</div>

                <div class="stec-tooltip-counter">
                    <span>0d 0h 0m 0s</span>
                </div>
                <div class="stec-tooltip-status stec-tooltip-expired"><?php esc_html_e('Expired', 'stec'); ?></div>
                <div class="stec-tooltip-status stec-tooltip-progress"><?php esc_html_e('In Progress', 'stec'); ?></div>

                <p class="stec-tooltip-location"><i class="fa fa-map-marker"></i>stec_replace_location</p>
                <p class="stec-tooltip-timespan"><i class="fas fa-clock"></i>stec_replace_timespan</p>

            </div>
        </script>

        <script type="text/html" id="stec-event-template">
            <li class="stec-layout-event">

                <div class="stec-layout-event-preview">

                    <div class="stec-layout-event-preview-left">

                        <div class="stec-layout-event-preview-left-icon" stec_replace_event_background="">
                            stec_replace_icon
                        </div>

                        <div class="stec-layout-event-preview-left-text">
                            stec_replace_event_status
                            <p class="stec-layout-event-preview-left-text-featured">
                                <i class="fa fa-star"></i>
                                <span><?php esc_html_e('Featured', 'stec'); ?></span>
                            </p>
                            <p class="stec-layout-event-preview-left-text-title">stec_replace_summary</p>
                            <p class="stec-layout-event-preview-left-text-secondary">
                                <span class="stec-layout-event-preview-left-text-date"><i class="fas fa-calendar"></i>stec_replace_date</span>
                                <span class="stec-layout-event-preview-left-text-location"><i class="fas fa-map-marker-alt"></i>stec_replace_location</span></p>
                            <p class="stec-layout-event-preview-left-text-secondary stec-layout-event-preview-left-text-desc"><span>stec_replace_desc_short</span></p>

                            <div class="stec-layout-event-preview-separator">
                                <a class="stec-layout-event-preview-left-event-edit" href="#stec_replace_edit_link"><i class="far fa-edit"></i></a>

                                <a href="javascript:void(0);" class="stec-layout-event-preview-left-reminder-toggle">
                                    <i class="fa fa-bell"></i>
                                </a>
                            </div>
                        </div>

                    </div>

                    <div class="stec-layout-event-preview-right">

                        <a class="stec-layout-event-preview-right-event-edit" href="#stec_replace_edit_link"><i class="far fa-edit"></i></a>

                        <div class="stec-layout-event-preview-right-menu">
                            <i class="fa fa-bell"></i>
                        </div>

                        <div class="stec-layout-event-preview-right-event-toggle">
                            <i class="fa fa-plus"></i>
                            <i class="fa fa-minus"></i>
                        </div>

                    </div>

                </div>

                <?php
                // event.inner.inc.php is added dynamically by js
                // template included in default.php
                // include("layout.event.inner.inc.php");
                ?>
            </li>

        </script>

        <script type="text/html" id="stec-event-create-form-template">
        <?php include Stachethemes_Event_Calendar::get_instance()->get_path('VIEW') . 'front/forms/inc.submit-form.php'; ?>
        </script>

        <script type="text/html" id="stec-grid-event-template">

            <div class="stec-layout-grid-event">

                <a target="stec_replace_atarget" href="#stec_replace_permalink">
                    <span class="stec-layout-grid-event-image" stec_replace_image></span>
                </a>

                <div class="stec-layout-grid-event-tags">
                    stec_replace_tags
                </div>

                <div class="stec-layout-grid-invited"><?php esc_html_e('Invited', 'stec'); ?></div>

                <div class="stec-layout-grid-event-wrap">

                    <div class="stec-layout-grid-icon" stec_replace_event_background="">stec_replace_icon</div>

                    <span class="stec-layout-grid-event-title"><a target="stec_replace_atarget" href="#stec_replace_permalink">stec_replace_summary</a></span>
                    <span class="stec-layout-grid-event-short-desc">stec_replace_short_desc</span>

                    <div class="stec-layout-grid-event-status">
                        <div class="stec-layout-grid-event-status-expired"><?php esc_html_e('Expired', 'stec'); ?></div>
                        <div class="stec-layout-grid-event-status-progress"><?php esc_html_e('In Progress', 'stec'); ?></div>
                    </div>
                </div>

                <div class="stec-layout-grid-event-ul">
                    <span class="stec-layout-grid-has-organizers">
                        <span class="stec-layout-grid-organizer" stec_replace_organizer_image></span>
                        <span class="stec-layout-grid-organizer-name">stec_replace_organizer_name</span>
                    </span>
                    <span class="stec-layout-grid-has-products">
                        <i class="fa fa-shopping-cart"></i>
                        <span>stec_replace_product_name</span>
                    </span>
                    <span class="stec-layout-grid-has-location">
                        <i class="fa fa-map-marker"></i>
                        <span>stec_replace_location</span>
                    </span>
                    <span class="stec-layout-grid-date">
                        <i class="fas fa-clock"></i>
                        <span>stec_replace_date</span>
                    </span>
                    <span class="stec-layout-grid-can-rsvp">
                        <a class="stec-layout-grid-rsvp stec-style-button stec-layout-event-btn-fontandcolor" href="javascript:void(0);"><?php esc_html_e('RSVP to Event', 'stec'); ?></a>
                    </span>
                </div>

            </div>
        </script>

        <script type="text/html" id="stec-boxgrid-event-template">
            <div class="stec-layout-boxgrid-event">
                <a class="stec-layout-boxgrid-event-permalink" target="stec_replace_atarget" href="#stec_replace_permalink"></a>
                <div class="stec-layout-boxgrid-event-background" stec_replace_event_background="">
                    <div class="stec-layout-boxgrid-hover-bg"></div>
                    <div class="stec-layout-boxgrid-images">stec_replace_image</div>
                    <div class="stec-layout-boxgrid-event-wrap">

                        <div class="stec-layout-boxgrid-event-icon" >stec_replace_icon</div>

                        <div class="stec-layout-boxgrid-event-timespan-wrap">
                            <div class="stec-layout-boxgrid-event-timespan-big">stec_replace_date_big</div>
                            <div class="stec-layout-boxgrid-event-timespan">stec_replace_date</div>
                        </div>

                        <div class="stec-layout-boxgrid-event-content-wrap">
                            <div class="stec-layout-boxgrid-event-tags">stec_replace_tags</div>
                            <div class="stec-layout-boxgrid-event-title">stec_replace_summary</div>
                            <div class="stec-layout-boxgrid-event-short-desc">stec_replace_short_desc</div>
                        </div>
                    </div>
                </div>
            </div>
        </script>

        <script type="text/html" id="stec-event-inner-template">
            <div class="stec-layout-event-inner">

                <ul class="stec-layout-event-inner-top-tabs">
                    <?php do_action('stec_add_event_tab'); ?>
                </ul>

                <div class="stec-layout-event-inner-top-tabs-content">
                    <?php do_action('stec_add_event_tab_content'); ?>
                </div>

            </div>
        </script>

        <script type="text/html" id="stec-preloader-template">
            <div class="stec-preloader"></div>
        </script>

        <script type="text/html" id="stec-layout-event-inner-attendance-attendee-template">
            <li class="stec-layout-event-inner-attendance-attendee">

                <div data-userid="stec_replace_userid" class="stec-layout-event-inner-attendance-attendee-avatar">
                    <img src="#stec_replace_avatar" alt="stec_replace_name" />
                    <ul>
                        stec_replace_status
                    </ul>
                </div>

                <p class="stec-style-title2">stec_replace_name</p>
                <span class="stec-layout-event-inner-attendance-attendee-persons"><span>stec_replace_people</span><i class="fas fa-user"></i></span>
            </li>
        </script>

        <script type="text/html" id="stec-layout-event-inner-forecast-details-left-forecast-day-template">
            <div class="stec-layout-event-inner-forecast-details-left-forecast-day">
                <p>stec_replace_date</p>
                stec_replace_icon_div
                <p>stec_replace_min / stec_replace_max &deg;stec_replace_temp_units</p>
            </div>
        </script>

        <script type="text/html" id="stec-layout-event-inner-guests-guest-template">
            <div class="stec-layout-event-inner-guests-guest">

                <div class="stec-layout-event-inner-guests-guest-left">
                    <div class="stec-layout-event-inner-guests-guest-left-avatar">
                        stec_replace_avatar
                        <ul>stec_replace_social</ul>
                    </div>
                </div>

                <div class="stec-layout-event-inner-guests-guest-right">
                    <p class="stec-layout-event-inner-guests-guest-right-title stec-style-title2">stec_replace_name</p>
                    <div class="stec-layout-event-inner-guests-guest-right-desc  stec-style-text">
                        <p>stec_replace_about</p>
                    </div>
                </div>

            </div>
        </script>

        <script type="text/html" id="stec-layout-event-inner-intro-organizers-organizer-template">
            <li class="stec-layout-event-inner-intro-organizers-organizer">
                <div class="stec-layout-event-inner-intro-organizers-organizer-image">
                    <div class="stec-layout-event-inner-intro-organizers-organizer-image-photo" stec_replace_image></div>
                </div>
                <div class="stec-layout-event-inner-intro-organizers-organizer-content">
                    <div class="stec-layout-event-inner-intro-organizers-organizer-title stec-style-title2">stec_replace_title</div>
                    <div class="stec-layout-event-inner-intro-organizers-organizer-sub-title"><?php printf(esc_html__('Organizer of %s', 'stec'), 'stec_replace_event'); ?></div>
                    <div class="stec-layout-event-inner-intro-organizers-organizer-description stec-style-text">stec_replace_about</div>
                    <div class="stec-layout-event-inner-intro-organizers-organizer-social">stec_replace_social</div>
                </div>
            </li>
        </script>

        <script type="text/html" id="stec-layout-event-inner-intro-attachment-template">
            <li class="stec-layout-event-inner-intro-attachment">
                <div>
                    <p class="stec-layout-event-inner-intro-attachment-title stec-style-title2"><a target="BLANK" href="#stec_replace_url">stec_replace_filename</a></p>
                    <p class="stec-layout-event-inner-intro-attachment-desc stec-style-text">stec_replace_desc</p>
                </div>

                <div>
                    <a target="BLANK" href="#stec_replace_url" class="stec-style-title2"><?php esc_html_e('Download', 'stec'); ?></a>
                    <p class="stec-layout-event-inner-intro-attachment-size stec-style-text">stec_replace_size</p>
                </div>
            </li>
        </script>

        <script type="text/html" id="stec-layout-event-inner-schedule-tab-template">
            <div class="stec-layout-event-inner-schedule-tab">

                <div class="stec-layout-event-inner-schedule-tab-preview">
                    <div class="stec-layout-event-inner-schedule-tab-left">
                        <span class="">stec_replace_date stec_replace_time</span>
                    </div>
                    <div class="stec-layout-event-inner-schedule-tab-right">

                        <div class="stec-layout-event-inner-schedule-tab-right-title">
                            <i class="stec_replace_icon" stec_replace_color></i><span class="">stec_replace_title</span>
                        </div>

                        <div class="stec-layout-event-inner-schedule-tab-toggle">
                            <i class="fa fa-plus"></i>
                            <i class="fa fa-minus"></i>
                        </div>
                    </div>
                </div>

                <div class="stec-layout-event-inner-schedule-tab-desc">
                    <div class="stec-style-text">stec_replace_desc</div>
                </div>

            </div>
        </script>
        <?php
    }

    public static function get_single_page_templates() {
        ?>
        <script type="text/html" id="stec-layout-single-forecast-details-left-forecast-day-template">
            <div class="stec-layout-single-forecast-details-left-forecast-day">
                <p>stec_replace_date</p>
                stec_replace_icon_div
                <p>stec_replace_min / stec_replace_max &deg;stec_replace_temp_units</p>
            </div>
        </script>
        <?php
    }

}
