<?php

namespace Stachethemes\Stec\Elementor\Widgets\Single_Page;

class Stec_Single_Page_WPML_Tabs extends \WPML_Elementor_Module_With_Items {

    public function get_items_field() {
        return 'sections';
    }
    public function get_fields() {
        return array('tab_title');
    }
    protected function get_title($field) {
        switch ($field) {
            case 'tab_title':
                return esc_html__('Tab title', 'stec');

            default:
                return '';
        }
    }
    protected function get_editor_type($field) {
        switch ($field) {
            case 'tab_title':
                return 'LINE';

            default:
                return '';
        }
    }

}

add_filter('wpml_elementor_widgets_to_translate', function($widgets) {

    /* Tabs */
    $widgets['stec_single_tabs'] = array(
        'conditions'        => array('widgetType' => 'stec_single_tabs'),
        'fields'            => array(),
        'integration-class' => 'Stachethemes\Stec\Elementor\Widgets\Single_Page\Stec_Single_Page_WPML_Tabs',
    );


    return $widgets;
});


