<?php

namespace Stachethemes\Stec;

if (!$this instanceof Stachethemes_Event_Calendar) {
    wp_die('-1');
}

$stachethemes_ec_main = $this;

add_action('stec_register_custom_post', function() use ($stachethemes_ec_main) {

    $stachethemes_ec_main->register_custom_post('stec_calendar', esc_html__('Calendar', 'stec'), esc_html__('Calendars', 'stec'), Admin_Helper::get_permalinks('calendar'), array('title'));
    $stachethemes_ec_main->register_custom_post('stec_event', esc_html__('Event', 'stec'), esc_html__('Events', 'stec'), Admin_Helper::get_permalinks('event'), array('title', 'editor', 'comments'));
    $stachethemes_ec_main->register_custom_post('stec_cron', esc_html__('Cron', 'stec'), esc_html__('Crons', 'stec'), Admin_Helper::get_permalinks('cron'), array('title'));

    $stachethemes_ec_main->register_custom_post('stec_esf', esc_html__('Form', 'stec'), esc_html__('Forms', 'stec'), 'stec_esf', array('title', 'editor'), false, array(
        'show_ui'            => true,
        'show_in_menu'       => false,
        'publicly_queryable' => true
            )
    );

    $stachethemes_ec_main->register_custom_post('stec_sp', esc_html__('Page', 'stec'), esc_html__('Pages', 'stec'), 'stec_sp', array('title', 'editor'), false, array(
        'show_ui'            => true,
        'show_in_menu'       => false,
        'publicly_queryable' => true
            )
    );
});

do_action('stec_register_custom_post');
