<?php

namespace Stachethemes\Stec;
?>
<div class="stachethemes-admin-section-tab" data-tab="booking">

    <h2><?php esc_html_e('Booking Settings', 'stec'); ?></h2>

    <?php
    Admin_Html::html_info(esc_html__('Total tickets purchase limit', 'stec'));
    Admin_Html::html_input('bookable_purchase_limit', $event ? $event->get_bookable_purchase_limit() : 0, 0, '', false, 'number');
    Admin_Html::html_desc(esc_html__('Total amount of tickets customer can purchase for this event. Default: 0 (unlimited)'));
    ?>

    <div class="stachethemes-admin-tickets-list">

        <h2><?php esc_html_e('Manage Tickets', 'stec'); ?></h2>

        <?php
        Admin_Html::html_info(esc_html__('Add existing ticket to the event', 'stec'));

        $products_list = Booking::get_bookable_products_as_array_list();

        Admin_Html::html_select('wc_book_list', $products_list, '', false);

        Admin_Html::html_button(esc_html__('Add to Event', 'stec'), '', false, 'add-book-item blue-button');
        
        ?>
        
        
        <?php if ($event && $event->get_bookable_products()) : ?>

            <?php
            foreach ($event->get_bookable_products() as $product) :

                if (!$product instanceof Event_Meta_Bookable_Product) {
                    continue;
                }

                $product_info = WC()->product_factory->get_product($product->get_id());

                if (!$product_info) {
                    continue;
                }
                ?>

                <div class="stachethemes-admin-woocommerce-product">

                    <div class="stachethemes-admin-woocommerce-product-head">
                        <p class="stachethemes-admin-woocommerce-product-title"><span></span><span><?php esc_html_e($product_info->get_title()); ?></span></p>
                        <input type="hidden" name="wc_bookable_product[]" value="<?php echo (int) $product_info->get_id(); ?>" />
                        <div>
                            <?php
                            Admin_Html::html_button(esc_html__('Remove', 'stec'), '', true, "light-btn delete");
                            ?>
                        </div>
                    </div>

                </div>

            <?php endforeach; ?>

        <?php endif; ?>
            

    </div>


</div>