<?php

namespace Stachethemes\Stec;

$hours_list      = Admin_Helper::get_hours_array();
$minutes_list    = Admin_Helper::minutes_array();
$icons_list      = Admin_Helper::get_icon_list();
$categories_list = Categories::get_categories_list();
?>

<div class="stec-style-full-width">
    <h1 class="stec-builder-element-content-header-style"><?php esc_html_e('Event Details', 'stec'); ?></h1>
</div>
<div class="stec-style-flexbox">
    <div class="stec-style-full-width">
        <?php
        // Title
        printf('<div class="stec-builder-element"><input class="stec-builder-element-content-input-style" type="text" name="title" placeholder="%s" required /></div>', esc_html__('Event Title', 'stec'));

        // Description
        printf('<div class="stec-builder-element"><textarea class="stec-builder-element-content-textarea-style" name="description" placeholder="%s" %s></textarea></div>', esc_html__('Description', 'stec'), '');

        // Short description
        printf('<div class="stec-builder-element"><input class="stec-builder-element-content-input-style" name="short_desc" placeholder="%s" %s /></div>', esc_html__('Short Description', 'stec'), '');
        ?>
    </div>

    <div class="stec-style-full-width">
        <?php
        // Image
        echo '<div class="stec-builder-element">';

        if (current_user_can('upload_files')) {
            echo '<div class="stec-builder-element-content-media-images-style"><button type="button" class="stec-builder-add-media-photo">' . esc_html__('Add Images', 'stec') . '</button></div><input type="hidden" name="stec_has_media" value="1" />';
        } else {

            ob_start();
            ?>
            <button type='button' class='stec-builder-element-content-button-style stec-builder-submission-add-image'>
                <i class="fas fa-plus"></i>
                <span><?php esc_html_e('Image', 'stec'); ?></span>
            </button>
            <span class="stec-builder-submission-add-image-src stec-builder-element-content-p-style"></span>
            <?php
            $buffer_content = ob_get_clean();

            echo '<div class="stec-builder-element-content-media-images-style"><input class="stec-builder-hide-upload" name="stec_public_file_image" type="file" accept="image/png, image/jpeg"/>' . $buffer_content . '</div>';
        }

        echo '</div>';

        // Location

        $location_type = (int) Settings::get_admin_setting_value('stec_menu__general_event_submit', 'create_event_form_allow_location_type');
        $locations     = Locations::get_locations_list();
        $options       = array();

        if ($location_type > 0) {

            $options[] = "<optgroup label='" . esc_attr__('New location', 'stec') . "'>";

            switch ($location_type) :
                case 1:
                    $options[] = "<option value='custom_address'>" . esc_html__('Add new address', 'stec') . "</option>";
                    break;
                case 2:
                    $options[] = "<option value='custom'>" . esc_html__('Add new location', 'stec') . "</option>";
                    break;
                case 3:
                    $options[] = "<option value='custom'>" . esc_html__('Add new location', 'stec') . "</option>";
                    break;
            endswitch;

            $options[] = "</optgroup>";
        }

        $options[] = "<optgroup label='" . esc_attr__('Locations', 'stec') . "'>";
        $options[] = "<option selected value=''>" . esc_html__('No location', 'stec') . "</option>";
        if ($location_type !== 3) {
            foreach ($locations as $k => $v) :
                $options[] = "<option value='{$k}'>{$v}</option>";
            endforeach;
        }
        $options[] = "</optgroup>";

        $locations_list = implode(PHP_EOL, $options);

        switch ($location_type) {

            case 1:

                $locations = \Stachethemes\Stec\Locations::get_location_country_city();

                ob_start();
                ?>
                <div class="stec-builder-submission-new-address">

                    <select class="stec-builder-element-content-select-style" type="text" name="location_country" placeholder="<?php esc_attr_e('Country', 'stec'); ?>" >
                        <?php
                        printf('<option selected disabled>%s</option>', esc_html__('-- Country --', 'stec'));
                        foreach ($locations as $country => $cities) {
                            printf('<option value="%s">%s</option>', esc_attr($country), esc_html($country));
                        }
                        ?>
                    </select>

                    <select class="stec-builder-element-content-select-style" type="text" name="location_city" placeholder="<?php esc_attr_e('City', 'stec'); ?>" >
                        <?php
                        printf('<option selected disabled>%s</option>', esc_html__('-- City --', 'stec'));
                        foreach ($locations as $country => $cities) {
                            foreach ($cities as $city) {
                                printf('<option data-country="%s" value="%s">%s</option>', $country, esc_attr($city), esc_html($city));
                            }
                        }
                        ?>
                    </select>
                    <input class="stec-builder-element-content-input-style" type="text" name="location_address" placeholder="<?php esc_attr_e('Address', 'stec'); ?>" >

                    <div class="stec-builder-element-content-coordinates-wrap">
                        <input class="stec-builder-element-content-input-style" type="text" name="location_coordinates" placeholder="<?php esc_attr_e('Coordinates', 'stec'); ?>" >
                        <button title="<?php esc_html_e('Find coordinates', 'stec'); ?>" type="button" data-input="location_coordinates" data-action="get-coordinates"><i class="fas fa-search-location"></i></button>
                    </div>

                    <textarea class="stec-builder-element-content-textarea-style" name="location_details" placeholder="<?php esc_attr_e('Details', 'stec'); ?>"></textarea>
                </div>
                <?php
                $location_form = ob_get_clean();
                break;

            case 2:
            case 3:
                ob_start();
                ?>
                <div class="stec-builder-submission-new-location">

                    <select class="stec-builder-element-content-select-style" name="location_type">
                        <option value="physical"><?php esc_html_e('Physical'); ?></option>
                        <option value="virtual"><?php esc_html_e('Virtual'); ?></option>
                    </select>

                    <input class="stec-builder-element-content-input-style" type="text" name="location_address" placeholder="<?php esc_attr_e('Address', 'stec'); ?>" >

                    <div class="stec-builder-submission-new-location-physical-data">

                        <input class="stec-builder-element-content-input-style" type="text" name="location_city" placeholder="<?php esc_attr_e('City', 'stec'); ?>" >
                        <input class="stec-builder-element-content-input-style" type="text" name="location_country" placeholder="<?php esc_attr_e('Country', 'stec'); ?>" >

                        <div class="stec-builder-element-content-coordinates-wrap">
                            <input class="stec-builder-element-content-input-style" type="text" name="location_coordinates" placeholder="<?php esc_attr_e('Coordinates', 'stec'); ?>" >
                            <button title="<?php esc_html_e('Find coordinates', 'stec'); ?>" type="button" data-input="location_coordinates" data-action="get-coordinates"><i class="fas fa-search-location"></i></button>
                        </div>

                    </div>

                    <textarea class="stec-builder-element-content-textarea-style" name="location_details" placeholder="<?php esc_attr_e('Details', 'stec'); ?>"></textarea>
                </div>
                <?php
                $location_form = ob_get_clean();
                break;

            default:
                $location_form = '';
        }

        printf('<div class="stec-builder-element"><select class="stec-builder-element-content-select-style" name="location" %s>%s</select>%s</div>', '', $locations_list, $location_form);

        // Website URL
        echo '<div class="stec-style-flexbox-separate">';
        printf('    <div class="stec-builder-element"><input class="stec-builder-element-content-input-style" %s type="url" name="link[url]" placeholder="%s" /></div>', '', esc_html__('Website URL', 'stec'));
        printf('    <div class="stec-builder-element"><input class="stec-builder-element-content-input-style" %s type="text" name="link[text]" placeholder="%s" /></div>', '', esc_html__('Button text (optional)', 'stec'));
        echo '</div>';

        // Organizers

        ob_start();
        ?>

        <div class="stec-builder-submission-organizer-list">
            <input type="hidden" name="organizers[]" value="" />

            <select class="stec-builder-element-content-select-style" name="organizers[]" multiple>

                <option disabled value=''><?php esc_html_e('Select Organizer(s)', 'stec'); ?></option>
                <?php
                $organizers = Organizers::get_organizers_list();

                foreach ($organizers as $id => $name) {
                    printf("<option value='%s'>%s</option>", esc_attr($id), esc_html($name));
                }
                ?>

            </select>

        </div>

        <button type='button' class='stec-builder-element-content-button-style stec-builder-submission-add-organizer'>
            <i class="fas fa-plus"></i>
            <?php esc_html_e('New Organizer', 'stec'); ?>
        </button>

        <?php
        $organizers_content = ob_get_clean();

        printf('<div class="stec-builder-element"><div class="stec-builder-element-content-organizers-style">%s</div></div>', $organizers_content);
        ?>

    </div>

</div>

<div class="stec-style-full-width">
    <h1 class="stec-builder-element-content-header-style"><?php esc_html_e('Date & Time', 'stec'); ?></h1>
</div>

<div class="stec-style-flexbox">
    <div class="stec-style-full-width">
        <?php
        // Start Date
        printf('<div class="stec-builder-element"><input class="stec-builder-element-content-datetime-style stec-builder-element-content-input-style" type="text" name="start_date" placeholder="%s" value="%s" />', esc_html__('Start Date', 'stec'), '');
        printf('<input type="hidden" name="start_date_alt" value="%s" />', '');
        ?>
        <select class="stec-builder-element-content-datetime-style stec-builder-element-content-select-style" name="<?php echo 'start_time_hours'; ?>">
            <?php
            foreach ($hours_list as $key => $value) :
                ?>
                <option value="<?php esc_attr_e($key); ?>"><?php esc_html_e($value); ?></option>
                <?php
            endforeach;
            ?>
        </select>
        <select class="stec-builder-element-content-datetime-style stec-builder-element-content-select-style" name="<?php echo 'start_time_minutes'; ?>">
            <?php
            foreach ($minutes_list as $key => $value) :
                ?>
                <option value="<?php esc_attr_e($key); ?>"><?php esc_html_e($value); ?></option>
                <?php
            endforeach;
            ?>
        </select>
        <?php
        echo '</div>';
        ?>

        <?php
        // All day check
        printf('<div class="stec-builder-element"><label class="stec-builder-element-content-checkbox-style"><input name="all_day" type="checkbox" %s><span class="stec-builder-element-content-p-style">%s</span></label></div>', '', esc_html__('All day', 'stec'));
        ?>

    </div>

    <div class="stec-style-full-width">
        <?php
// End Date
        printf('<div class="stec-builder-element"><input class="stec-builder-element-content-datetime-style stec-builder-element-content-input-style" type="text" name="end_date" placeholder="%s" />', esc_html__('End Date', 'stec'));
        echo '<input type="hidden" name="end_date_alt" />';
        ?>
        <select class="stec-builder-element-content-datetime-style stec-builder-element-content-select-style" name="<?php echo 'end_time_hours'; ?>">
            <?php
            foreach ($hours_list as $key => $value) :
                ?>
                <option value="<?php esc_attr_e($key); ?>"><?php esc_html_e($value); ?></option>
                <?php
            endforeach;
            ?>
        </select>
        <select class="stec-builder-element-content-datetime-style stec-builder-element-content-select-style" name="<?php echo 'end_time_minutes'; ?>">
            <?php
            foreach ($minutes_list as $key => $value) :
                ?>
                <option value="<?php esc_attr_e($key); ?>"><?php esc_html_e($value); ?></option>
                <?php
            endforeach;
            ?>
        </select>
        <?php
        echo '</div>';
        ?>

        <?php
        // Repeater
        $options        = array();
        $options[]      = "<option value='0'>" . esc_html__('No repeat', 'stec') . "</option>";
        $options[]      = "<option value='1'>" . esc_html__('Daily', 'stec') . "</option>";
        $options[]      = "<option value='2'>" . esc_html__('Weekly', 'stec') . "</option>";
        $options[]      = "<option value='3'>" . esc_html__('Monthly', 'stec') . "</option>";
        $options[]      = "<option value='4'>" . esc_html__('Yearly', 'stec') . "</option>";
        $repeat_options = implode(PHP_EOL, $options);

        ob_start();
        ?>
        <div class="stec-repeater-content">

            <div class="stec-repeater-content-weekdays">
                <span><?php esc_html_e('By day:', 'stec'); ?></span>
                <div class="stec-repeater-content-repeat-on">
                    <span>
                        <label title="Sunday">
                            <input name="SU" title="Sunday" type="checkbox">
                            <?php esc_html_e('SU', 'stec'); ?></label>
                    </span>
                    <span>
                        <label title="Monday">
                            <input name="MO" title="Monday" type="checkbox">
                            <?php esc_html_e('MO', 'stec'); ?></label>
                    </span>
                    <span>
                        <label title="Tuesday">
                            <input name="TU" title="Tuesday" type="checkbox">
                            <?php esc_html_e('TU', 'stec'); ?>
                        </label>
                    </span>
                    <span>
                        <label title="Wednesday">
                            <input name="WE" title="Wednesday" type="checkbox">
                            <?php esc_html_e('WE', 'stec'); ?>
                        </label>
                    </span>
                    <span>
                        <label title="Thursday">
                            <input name="TH" title="Thursday" type="checkbox">
                            <?php esc_html_e('TH', 'stec'); ?>
                        </label>
                    </span>
                    <span>
                        <label title="Friday">
                            <input name="FR" title="Friday" type="checkbox">
                            <?php esc_html_e('FR', 'stec'); ?>
                        </label>
                    </span>
                    <span>
                        <label title="Saturday">
                            <input name="SA" title="Saturday" type="checkbox">
                            <?php esc_html_e('SA', 'stec'); ?>
                        </label>
                    </span>
                </div>
            </div>

            <div class="stec-repeater-content-repeat-gap">
                <span><?php esc_html_e('Repeat gap:', 'stec'); ?></span>
                <select class="stec-builder-element-content-select-style" name="repeat_gap">
                    <option value=""><?php esc_html_e('No gap', 'stec'); ?></option>
                    <?php
                    $gap = 2;
                    while ($gap <= 30) {
                        printf("<option value='%s'>%s</option>", $gap, ($gap - 1));
                        $gap++;
                    }
                    ?>
                </select>
            </div>

            <div class="stec-repeater-content-repeat-ends-on">
                <span><?php esc_html_e('Repeat ends on:', 'stec'); ?></span>
                <div class="stec-repeater-content-endson-options">
                    <div>
                        <label>
                            <input name="repeat_endson" value="0" checked="checked" type="radio">
                            <?php esc_html_e('Never', 'stec'); ?>
                        </label>
                    </div>
                    <div>
                        <label>
                            <input name="repeat_endson" value="1" type="radio">
                            <span><?php esc_html_e('After', 'stec'); ?></span>
                            <input class="stec-builder-element-content-input-style" type="number" name="repeat_occurences" max="99" min="1" value="" disabled="disabled">
                            <span><?php esc_html_e('occurrences', 'stec'); ?></span>
                        </label>
                    </div>
                    <div>
                        <label>
                            <input name="repeat_endson" value="2" type="radio">
                            <span><?php esc_html_e('On date', 'stec'); ?></span>
                            <input class="stec-builder-element-content-input-style" name="repeat_ends_on_date" size="10" value="" disabled="disabled" autocomplete="off">
                            <input type="hidden" name="repeat_ends_on_date_alt">
                        </label>
                    </div>
                </div>
            </div>

            <div class="stec-repeater-content-exdate-menu">
                <span><?php esc_html_e('Date exception:', 'stec'); ?></span>
                <div class="stec-repeater-content-exdate-options">
                    <div>
                        <input class="stec-builder-element-content-input-style" name="repeat_exdate_datepicker" value="" type="text">
                        <input type="hidden" name="repeat_exdate_datepicker_alt">
                        <a class="stec-repeater-content-add-exdate-button" href="javascript:void(0);"><?php esc_html_e('Add exdate', 'stec'); ?></a>
                    </div>
                    <ul class="stec-repeater-content-exdate-datelist">

                    </ul>
                </div>
            </div>

            <input type="hidden" name="rrule" value="">
            <input type="hidden" name="exdate" value="">

        </div>
        <?php
        $repeat_content = ob_get_clean();

        printf('<div class="stec-builder-element"><select class="stec-builder-element-content-select-style" name="repeater"><option disabled selected>%s</option>%s</select>%s</div>', esc_html__('Repeat Scheme', 'stec'), $repeat_options, $repeat_content);
        ?>
    </div>
</div>
<div class="stec-style-full-width">
    <h1 class="stec-builder-element-content-header-style"><?php esc_html_e('Guests & Schedule', 'stec'); ?></h1>
</div>
<div class="stec-style-flexbox">
    <div class="stec-style-full-width">
        <?php
        // Guests

        ob_start();
        ?>
        <button type='button' class='stec-builder-element-content-button-style stec-builder-submission-add-guest'>
            <i class="fas fa-plus"></i>
            <?php esc_html_e('Add Guest', 'stec'); ?>
        </button>

        <input type="hidden" name="has_guests_list" value="1" />

        <?php
        $guests_content = ob_get_clean();

        printf('<div class="stec-builder-element"><div class="stec-builder-element-content-guests-style">%s</div></div>', $guests_content);
        ?>
    </div>
    <div class="stec-style-full-width">
        <?php
        // Schedule

        ob_start();
        ?>

        <button type='button' class='stec-builder-element-content-button-style stec-builder-submission-add-schedule'>
            <i class="fas fa-plus"></i>
            <?php esc_html_e('Add Timespan', 'stec'); ?>
        </button>

        <?php
        $schedule_content = ob_get_clean();

        printf('<div class="stec-builder-element"><div class="stec-builder-element-content-schedules-style">%s</div></div>', $schedule_content);
        ?>
    </div>
</div>

<div class="stec-style-full-width">
    <h1 class="stec-builder-element-content-header-style"><?php esc_html_e('Additional Information', 'stec'); ?></h1>
</div>
<div class="stec-style-flexbox">
    <div class="stec-style-full-width">
        <?php
        // Colorpicker 
        printf('<div class="stec-builder-element"><input class="stec-builder-element-content-colorpicker-style" type="text" name="event_color" value="%s" /></div>', esc_attr('#f15e6e'));

        // Calendar Selector
        $options       = array();
        $writable_cals = Calendars::get_writable_calendar_list();

        foreach ($writable_cals as $cal) :
            $options[] = "<option data-color='{$cal->get_color()}' value='{$cal->get_id()}'>{$cal->get_title()}</option>";
        endforeach;

        $writable_calendars = implode(PHP_EOL, $options);

        if (1 === count($writable_cals)) {
            printf('<input type="hidden" name="calendar_id" value="%d">', $writable_cals[0]->get_id());
        } else {
            printf('<div class="stec-builder-element"><select class="stec-builder-element-content-select-style" required name="calendar_id"><option disabled selected value="">%s</option>%s</select></div>', esc_html__('Select Calendar', 'stec'), $writable_calendars);
        }

        // Featured Selector
        $options = array(
            sprintf('<option value="0">%s</option>', esc_html__('No', 'stec')),
            sprintf('<option value="1">%s</option>', esc_html__('Yes', 'stec')),
            sprintf('<option value="2">%s</option>', esc_html__('Yes, with background', 'stec')),
        );

        printf('<div class="stec-builder-element"><select class="stec-builder-element-content-input-style" name="featured"><option disabled selected value="">%s</option>%s</select></div>',
                esc_html__('Featured', 'stec'), implode(PHP_EOL, $options));

        // Search keywords input
        printf('<div class="stec-builder-element"><input class="stec-builder-element-content-input-style" %s type="text" name="keywords" placeholder="%s" value="" /></div>',
                '', esc_html__('Search Keywords', 'stec'));


        // Counter
        $options = array(
            sprintf('<option value="0">%s</option>', esc_html__('Disabled', 'stec')),
            sprintf('<option value="1">%s</option>', esc_html__('Enabled', 'stec')),
        );

        printf('<div class="stec-builder-element"><select class="stec-builder-element-content-select-style" name="counter"><option disabled selected value="">%s</option>%s</select></div>',
                esc_html__('Counter', 'stec'), implode(PHP_EOL, $options));


        // Comments
        $options = array(
            sprintf('<option value="0">%s</option>', esc_html__('Disabled', 'stec')),
            sprintf('<option value="1">%s</option>', esc_html__('Enabled', 'stec')),
        );

        printf('<div class="stec-builder-element"><select class="stec-builder-element-content-select-style" name="comments"><option disabled selected value="">%s</option>%s</select></div>',
                esc_html__('Comments', 'stec'), implode(PHP_EOL, $options));
        ?>
    </div>

    <div class="stec-style-full-width">
        <?php
        // Icon Type Selector
        $type_options   = array();
        $type_options[] = "<option value='icon'>" . esc_html__('Icon', 'stec') . "</option>";
        $type_options[] = "<option value='date'>" . esc_html__('Date', 'stec') . "</option>";
        if (current_user_can('upload_files')) {
            $type_options[] = "<option value='image'>" . esc_html__('Image', 'stec') . "</option>";
        }

        echo '<div class="stec-builder-element">';

        $options = array();
        foreach ($icons_list as $k => $icon) {
            $options[] = "<option value='{$k}'>{$icon}</option>";
        }
        $icons_options = implode(PHP_EOL, $options);

        printf('<select class="stec-builder-element-content-select-style" name="icon_type"><option disabled selected value="">%s</option>%s</select>', esc_html__('Icon Type', 'stec'), implode('', $type_options));
        printf('<select class="stec-builder-element-content-select-style" name="icon"><option disabled selected value="">%s</option>%s</select>', esc_html__('Select Icon', 'stec'), $icons_options);

        if (current_user_can('upload_files')) {
            printf('<div class="stec-builder-element-content-media-icon-images-style"><button type="button" class="stec-builder-add-media-photo">%s</button></div><input type="hidden" name="stec_has_icon_media" value="1" />', esc_html__('Icon Images', 'stec'));
        }

        echo '</div>';

        // Categories selector

        $options = array();
        foreach ($categories_list as $k => $v) :
            $options[] = "<option value='{$k}'>{$v}</option>";
        endforeach;
        $categories_options = implode(PHP_EOL, $options);

        printf('<div class="stec-builder-element"><select class="stec-builder-element-content-select-style" %s name="event_categories[]" multiple><option disabled value="">%s</option>%s</select></div>', '', esc_html__('Select Categories', 'stec'), $categories_options);
        ?>
    </div>
</div>

<div class="stec-style-full-width">
    <h1 class="stec-builder-element-content-header-style"><?php esc_html_e('Author Information', 'stec'); ?></h1>
</div>
<div class="stec-style-full-width">
    <?php
    // Notes to the reviewer
    printf('<div class="stec-builder-element"><textarea class="stec-builder-element-content-textarea-style" %s name="notes" placeholder="%s"></textarea></div>', '', esc_html__('Notes to the reviewer', 'stec'));

    // Contact email
    printf('<div class="stec-builder-element"><input class="stec-builder-element-content-input-style" type="email" name="contact_email" placeholder="%s" %s /></div>', esc_html__('Contact e-mail', 'stec'), 'required');

    // ToS
    if ((int) get_query_var('stec_edit_event') !== 1 && 1 === (int) Settings::get_admin_setting('stec_menu__general_privacy_agreement', 'display_privacy_agreement')) {

        $tos_text = Settings::get_admin_setting_value('stec_menu__general_privacy_agreement', 'privacy_agreement_content');

        $tos_html = '<div>'
                . '    <label class="stec-builder-element-content-checkbox-style">'
                . '        <input type="checkbox" name="privacy_policy" required />'
                . '        <span>' . $tos_text . '</span>'
                . '     </label>'
                . '</div>';

        $tos_html;

        printf('<div class="stec-builder-element"><div class="stec-builder-element-content-privacy-style">%s</div></div>', $tos_html);
    }

    // Captcha
    if (1 === (int) Settings::get_admin_setting_value('stec_menu__general_google_captcha', 'enabled')) {
        echo '<div class="stec-builder-element"><div class="stec-builder-element-content-captcha-style"><div></div></div></div>';
    }

    // Submit button
    printf('<div class="stec-builder-element"><div class="stec-builder-element-content-submit-style"><input type="submit" name="submit" value="%s" /></div></div>', esc_html__('Submit Event', 'stec'));
    ?>
</div>