<?php

namespace Stachethemes\Stec; ?>

<li class="stec-event-create-form stec-layout-event">

    <div class="stec-event-create-form-preview stec-layout-event-preview">

        <div class="stec-layout-event-preview-left">
            <div class="stec-layout-event-create-form-preview-left-text">
                <p class="stec-layout-event-preview-left-text-title"><?php esc_html_e('Submit an event', 'stec'); ?></p>
                <p class="stec-layout-event-preview-left-text-sub"><?php esc_html_e('Click to submit your own event', 'stec'); ?></p>
            </div>
        </div>

    </div>

    <div class="stec-layout-event-create-form-inner stec-layout-event-inner">
        <?php
        $classes     = array('stec-event-submission-form');
        $template_id = Settings::get_admin_setting_value('stec_menu__general_event_submit', 'submission_form_id');
        if (class_exists('SitePress')) {
            $template_id = apply_filters('wpml_object_id', $template_id, 'post', true);
        }

        /**
         * @todo Don't use try catch for logic
         */
        try {
            $template_content = Builder::get_project_content($template_id);
        } catch (Stec_Exception $ex) {
            if (404 === $ex->getCode()) {
                $classes[] = 'stec-event-submission-form-default';


                $default_path = Stachethemes_Event_Calendar::get_instance()->get_path('VIEW') . 'front/forms/default-submit-form.php';
                ob_start();

                if (locate_template('stec-submit-form.php')) {
                    locate_template('stec-submit-form.php', true, false);
                } else {
                    include ($default_path);
                }

                $template_content = ob_get_clean();
            } else {
                $template_content = '';
                Admin_Helper::debug_log($ex->getMessage());
            }
        }

        printf('<div id="%s" class="%s"><form>%s</form></div>', uniqid('stec-submission-form-'), implode(' ', $classes), apply_filters('stec_submit_form_content', $template_content, array(), false));
        ?>
    </div>

</li>