<?php

namespace Stachethemes\Stec;
?>

<?php $events = Events::get_related($event, $repeat_offset); ?>

<?php if ($events) : ?>
    <div class="stec-layout-single-related">
        <p class="stec-layout-single-preview-left-text-title"><?php esc_html_e('Related events', 'stec'); ?></p>
        <div class="stec-layout-single-related-events">
            <?php
            foreach ($events as $event) {
                ?>
                <div class="stec-layout-single-preview">

                    <div class="stec-layout-single-preview-left">

                        <div class="stec-layout-single-preview-left-icon <?php
                        if ($event->get_icon_type() === 'icon' && $event->get_icon() === 'fa') {
                            echo 'stec-no-icon';
                        }
                        ?>" style="background:<?php echo $event->get_color('display'); ?>">

                            <?php
                            switch ($event->get_icon_type()) :

                                case 'date' :

                                    $d   = $event->get_start_date('j', $repeat_offset);
                                    $mmm = date_i18n('M', $event->get_start_date('U', $repeat_offset));
                                    ?>
                                    <span class="stec-layout-single-preview-left-icon-date"><span class="stec-layout-single-preview-left-icon-date-number"><?php esc_html_e($d); ?></span><span class="stec-layout-single-preview-left-icon-date-month"><?php esc_html_e($mmm); ?></span></span>
                                    <?php
                                    break;

                                case 'image' :

                                    if ($event->get_icon_images()) {
                                        ?>
                                        <div class="stec-layout-single-preview-left-icon-images">
                                            <?php
                                            foreach ($event->get_parsed_icon_images() as $k => $image) {
                                                ?><div class="stec-layout-single-preview-left-icon-image <?php echo (int) $k === 0 ? 'active' : '' ?>" style="background-image: url(<?php echo esc_url($image->src); ?>)"></div><?php
                                            }
                                            ?>
                                        </div>
                                        <?php
                                    }
                                    break;

                                case 'icon' :
                                    ?><i class="<?php esc_attr_e($event->get_icon()); ?>"></i><?php
                                    break;

                            endswitch;
                            ?>

                        </div>


                        <div class="stec-layout-single-preview-left-text">

                            <?php
                            switch ($event->get_event_status()) :
                                case 'EventCancelled' :
                                    $event_status       = esc_html__('Cancelled', 'stec');
                                    $event_status_class = 'cancelled';
                                    break;

                                case 'EventMovedOnline' :
                                    $event_status       = esc_html__('Moved Online', 'stec');
                                    $event_status_class = 'moved-online';
                                    break;

                                case 'EventPostponed' :
                                    $event_status       = esc_html__('Postponed', 'stec');
                                    $event_status_class = 'postponed';
                                    break;

                                case 'EventRescheduled' :
                                    $event_status       = esc_html__('Rescheduled', 'stec');
                                    $event_status_class = 'rescheduled';
                                    break;

                                default:
                                    $event_status       = null;
                                    $event_status_class = null;

                            endswitch;


                            if ($event_status) {
                                printf('<span class="stec-layout-single-preview-left-text-event-status"><span class="%s">%s</span></span>', $event_status_class, $event_status);
                                printf('<meta property="eventStatus" content="http://schema.org/%s">', $event->get_event_status());
                            }

                            if ($event->get_approved() === 0) {
                                printf('<span class="stec-layout-single-preview-left-text-event-status"><span class="unapproved">%s</span></span>', esc_html__('Awaiting Approval', 'stec'));
                            }

                            if ($event->get_featured() >= 1) {
                                printf('<span class="stec-layout-single-preview-left-text-featured"><i class="fa fa-star"></i><span>%s</span></span>', esc_html__('Featured', 'stec'));
                            }


                            printf('<span class="stec-layout-single-preview-left-text-title">%s</span>', 'EventCancelled' === $event->get_event_status() ? "<s>{$event->get_title()}</s>" : $event->get_title());
                            ?>

                            <span class="stec-layout-single-preview-left-text-secondary">
                                <?php

                                printf('<span class="stec-layout-single-preview-left-text-date"><i class="fas fa-calendar"></i>%s</span>', Admin_Helper::get_the_timespan($event, $repeat_offset));


                                if ($event->get_location()) {
                                    $location = $event->get_parsed_location();
                                    $location_string = $location->type === 'virtual' ? esc_html__('Online Event','stec') : $location->full_address;
                                    printf('<span class="stec-layout-single-preview-left-text-location"><i class="fas fa-map-marker-alt"></i>%s</span>', $location_string);
                                    unset($location);
                                }
                                ?>
                            </span>

                        </div>

                    </div>

                    <div class="stec-layout-single-preview-right">
                        <a class="stec-layout-single-preview-related-link stec-style-button" href="<?php echo $event->get_permalink(); ?>"><?php esc_html_e('View Event', 'stec'); ?></a>
                    </div>

                </div>

                <?php
            }
            ?>
        </div>
    </div>
    <?php



 endif;