<?php

namespace Stachethemes\Stec;

if ('stec_event' === get_post_type()) :

    $repeat_offset = get_query_var('stec_repeat_offset', 0);
    $event         = new Event_Post(get_the_ID());

    if (Admin_Helper::user_is_invited($event)) :

        $user_status = (int) Admin_Helper::get_user_attendance_status($event, false, $repeat_offset);
        $free_slots  = Rsvp::has_free_slots($event, $event->get_start_date('Y-m-d', $repeat_offset));

        if (1 === $user_status || $free_slots !== false) :
            ?>

            <div class="stec-layout-single-attendance-invited">
                <p class="stec-style-title2">
                    <?php esc_html_e('You are invited to this event!', 'stec'); ?>
                    <br>
                    <span style="<?php echo 9999 === $free_slots ? 'display: none;' : ''; ?>"><?php printf('Places left: %s', '<span class="stec-layout-single-attendance-slots-count">' . (int) $free_slots . '</span>') ?></span>
                </p>
                <ul class="stec-layout-single-attendance-invited-buttons">
                    <li class="stec-style-button stec-layout-single-attendance-invited-buttons-attend  <?php
                    if ($user_status === 1) {
                        echo 'active';
                    }
                    ?>">
                        <p><?php esc_html_e('Attend', 'stec'); ?></p>
                    </li>

                    <li class="stec-style-button stec-layout-single-attendance-invited-buttons-decline  <?php
                    if ($user_status === 2) {
                        echo 'active';
                    }
                    ?>">
                        <p><?php esc_html_e('Decline', 'stec'); ?></p>
                    </li>

                    <li class="stec-style-button stec-layout-single-attendance-invited-buttons-unlist "><p><?php esc_html_e('Unlist', 'stec'); ?></p></li>
                </ul>
            </div>

        <?php endif; ?>

    <?php endif; ?>

    <?php
    $attendees = $event->get_attendance();

    if ($attendees) :

        echo '<ul class="stec-layout-single-attendance-attendees">';

        foreach ($attendees as $attendee) :

            if (false === ($attendee instanceof Event_Meta_Attendee)) {
                continue;
            }
            ?>

            <li class="stec-layout-single-attendance-attendee">

                <div data-userid="<?php echo (int) $attendee->get_userid(); ?>" class="stec-layout-single-attendance-attendee-avatar">
                    <img src="<?php echo esc_url($attendee->get_avatar()); ?>" alt="<?php esc_attr_e($attendee->get_name()); ?>" />
                    <ul>
                        <?php
                        $user_or_email = $attendee->get_userid() ?: $attendee->get_email();

                        switch (Admin_Helper::get_user_attendance_status($event, $user_or_email, $repeat_offset)) :

                            case 1:
                                echo '<li class=""><i class="fa fa-check"></i></li>';
                                break;

                            case 2:
                                echo '<li class=""><i class="fa fa-times"></i></li>';
                                break;

                            case 0:
                            default:
                                echo '<li class=""><i class="fa fa-question"></i></li>';

                        endswitch;
                        ?>
                    </ul>
                </div>

                <p class="stec-style-title2"><?php esc_html_e($attendee->get_name()); ?></p>
                <span class="stec-layout-single-attendance-attendee-persons"><span><?php esc_html_e($attendee->get_people()); ?></span><i class="fas fa-user"></i></span>
            </li>

            <?php
        endforeach;

        echo '</ul>';

    endif;
    ?>

<?php else: ?>

    <div class="stec-layout-event-inner-attendance-invited">
        <p class="stec-style-title2">
            <?php esc_html_e('You are invited to this event!', 'stec'); ?>
            <br>
            <span><?php printf(esc_html__('Places left: %s', 'stec'), '<span class="stec-layout-event-inner-attendance-invited-slots-count">0</span>') ?></span>
        </p>
        <ul class="stec-layout-event-inner-attendance-invited-buttons">
            <li class="stec-style-button stec-layout-event-inner-attendance-invited-buttons-accept stec-layout-event-btn-fontandcolor">
                <p><?php esc_html_e('Attend', 'stec'); ?></p>
            </li>

            <li class="stec-style-button stec-layout-event-inner-attendance-invited-buttons-decline stec-layout-event-btn-fontandcolor">
                <p><?php esc_html_e('Decline', 'stec'); ?></p>
            </li>

            <li class="stec-style-button stec-layout-event-inner-attendance-invited-buttons-unlist stec-layout-event-btn-fontandcolor">
                <p><?php esc_html_e('Unlist', 'stec'); ?></p>
            </li>
        </ul>
    </div>
            
    <ul class="stec-layout-event-inner-attendance-attendees">

    </ul>
            
<?php endif;